#include <jni.h>
#include <string>

#include <android/log.h>
#include <malloc.h>
#include <pthread.h>
#include <jni.h>
#include <string.h>
#include "../cpp/lib-android-mlpr/include/BitMapPublic.h"

#define  LOG_TAG    "ansun"

#define  LOGD(...)  __android_log_print(ANDROID_LOG_DEBUG, LOG_TAG, __VA_ARGS__)
#define  LOGE(...)  __android_log_print(ANDROID_LOG_ERROR, LOG_TAG, __VA_ARGS__)
// If you want you can add other log definition for info, warning etc



class JavaTask;

class MyMessageToJava {
public:
    BitMapPublic bits2;
    char *message;
    MyMessageToJava *next;

    MyMessageToJava(MyMessageToJava *root, BitMapPublic *oldBits, char *newMessage) {
        next = root;
        if (oldBits->buff) {
            IntRect clip = {0, 0, oldBits->width, oldBits->height};
           // CutByClip(*oldBits, clip, bits2);
            bits2 = *oldBits;
            long theSize = bits2.rowBytes * bits2.height;
            bits2.buff = (unsigned char *)malloc(theSize);
            memcpy(bits2.buff,oldBits->buff,theSize);
        } else {
            bits2.buff = 0;
        }
        message = (char *) malloc(strlen(newMessage) + 1);
        strcpy(message, newMessage);

    }

    ~MyMessageToJava() {


        free(message);
        if (next) {
            delete next;
        }

    }

    void Send1Out(JavaTask *task);

};

class MyMutex
{
public:
    MyMutex(){
        pthread_mutex_init(&mutexFlag, 0);

    }
    ~MyMutex()
    {
        pthread_mutex_destroy(&mutexFlag);
    }
    pthread_mutex_t mutexFlag;
    void Lock()
    {
        pthread_mutex_lock(&mutexFlag);
    }
    void Unlock()
    {
        pthread_mutex_unlock(&mutexFlag);
    }
    char TryLock()
    {
        return pthread_mutex_trylock(&mutexFlag) == 0;
    }
} ;

MyMessageToJava *pendingToJava = 0;
MyMutex pendingToJavaMutex;



jobject CreateBitmapForJava(JNIEnv *jniEnv, jobject obj, unsigned char *bitPixel, int _width, int _height) {
    jclass bitmapConfig = jniEnv->FindClass("android/graphics/Bitmap$Config");
    jfieldID rgba8888FieldID = jniEnv->GetStaticFieldID(bitmapConfig, "ARGB_8888",
                                                        "Landroid/graphics/Bitmap$Config;");
    jobject rgba8888Obj = jniEnv->GetStaticObjectField(bitmapConfig, rgba8888FieldID);

    jclass bitmapClass = jniEnv->FindClass("android/graphics/Bitmap");
    jmethodID createBitmapMethodID = jniEnv->GetStaticMethodID(bitmapClass, "createBitmap",
                                                               "(IILandroid/graphics/Bitmap$Config;)Landroid/graphics/Bitmap;");
    jobject bitmapObj = jniEnv->CallStaticObjectMethod(bitmapClass, createBitmapMethodID, _width,
                                                       _height, rgba8888Obj);
    jintArray pixels = jniEnv->NewIntArray(_width * _height);
    jniEnv->SetIntArrayRegion(pixels, 0, _width * _height, (int *) bitPixel);

    jmethodID setPixelsMid = jniEnv->GetMethodID(bitmapClass, "setPixels", "([IIIIIII)V");
    jniEnv->CallVoidMethod(bitmapObj, setPixelsMid, pixels, 0, _width, 0, 0, _width, _height);

    return bitmapObj;
}


void QueueMessageToJava(BitMapPublic *bits, char *message) {


    pendingToJavaMutex.Lock();
    pendingToJava = new MyMessageToJava(pendingToJava, bits, message);

    pendingToJavaMutex.Unlock();

}
char loadPatternBusy = 0;
class JavaTask {
public:
    jclass class1 = 0;
    jmethodID messageMeBitmap;

    jmethodID messageMeIntArray;
    jmethodID messageMeByteArray;
    jobject java_obj;
    JNIEnv *java_env;


    JavaTask() {

    }
    jstring SetPaths(
            JNIEnv *env,
            jobject obj, //if call by static , jobject will be jclass
            jstring key,
            jstring info_path
    );
    jlong OCRPixelBuffer( // 辨識jpg圖檔
            JNIEnv *env,
            jobject obj, //if call by static , jobject will be jclass
            jintArray pixel,
            jint width,
            jint height,
            jint threadIndex

    );

};



extern "C" void ocr_call_back_SendToFlutter1(void *userRef, // 用戶自備
                              char *lpr_num_text, //辨識結果車牌文字,例如: 'ABC-1234'
                              float score, //分數 0.0～1.0
                              float estimate_height, // 車牌字母的高度點數pixel，在相同焦距zoom條件下，點數越大代表距離越近。
                              BitMapPublic *lpr_captured_bits // 車牌截圖
)
{

  //  UIImage *image = [ImageHelper convertBitmapRGBA8ToUIImage:lpr_captured_bits->buff withWidth:lpr_captured_bits->width withHeight:lpr_captured_bits->height];
    printf("%s score:%.2f 字母高度：%.2f\n",lpr_num_text,score,estimate_height);
    //StringBuffer bitmapInfo;
    char infos[300];
    sprintf(infos,"estimate_height:%.2f,lpr_no:%s,match_score:%.2f,userRef:%ld",estimate_height,lpr_num_text,score,(long)userRef);
    //MyBitMapClass  newBits;

    QueueMessageToJava(lpr_captured_bits, infos);
}

void DoRecognition_android(  char *bitPixel, int rowBytes, int width, int height, long userRef)
{

    BitMapPublic bits2;

    bits2.buff = (unsigned char *)bitPixel;
    bits2.rowBytes = rowBytes;
    bits2.width = width;
    bits2.height = height;
    IntRect myClip = {0,0,width,height};
    int miniCharHeightToRecognize = 12; //照片中可以辨識的最小字母高度 pixels。
    apii_DoOCRImage(bits2,
                    myClip,
                    miniCharHeightToRecognize ,
                    ocr_call_back_SendToFlutter1,
                    ( void*)userRef
    );
}


char *jstring2string(JNIEnv *env0, jstring src, char *textresult) {
    const char *src_c = env0->GetStringUTFChars(src, 0);
    //static char text[4096];
    strcpy(textresult, src_c);
    env0->ReleaseStringUTFChars(src, src_c);
    return textresult;
}


extern "C" JNIEXPORT jstring JNICALL Java_com_example_myapplication_OCRRecognitionSample_SetPaths(
        JNIEnv *env,
        jobject obj, //if call by static , jobject will be jclass
        jstring key,
        jstring path

)
{
    JavaTask task;
    jstring result = task.SetPaths(env,obj,key,path);
    return result;
}

char bin_path[300] = {0};
char install_key[300] = {0};

extern "C" JNIEXPORT jlong JNICALL Java_com_example_myapplication_OCRRecognitionSample_Activate(
        JNIEnv *env,
        jobject obj, //if call by static , jobject will be jclass

        jint active
)
{
    if (active) {
        //("active\n");
        if (*bin_path && *install_key) {
            const char *result = apii_init_ocr_pattern(bin_path, install_key);
            printf("%s\n",result);
        }
    } else {
        //("deactive\n");
        //android 還有來自java 的 multithread 會用到 font_learnedPattern ,因此不能在第一時間刪除。
        apii_dispose_ocr_pattern();
    }
    return 0;
}
extern "C" JNIEXPORT jlong JNICALL Java_com_example_myapplication_OCRRecognitionSample_NativePixelBuffer(
        JNIEnv *env,
        jobject obj, //if call by static , jobject will be jclass
        jintArray pixel,
        jint width,
        jint height,
        jint threadIndex
)
{
    jlong result = 0;

    JavaTask task;
    task.class1 = env->FindClass("com/example/myapplication/OCRRecognitionSample"); //車牌辨識
    result = task.OCRPixelBuffer( // 辨識jpg圖檔
            env,
            obj, //if call by static , jobject will be jclass
            pixel,
            width,
            height,
            threadIndex

    );

    return result;
}

int CheckJobCapability();



jstring JavaTask::SetPaths(
        JNIEnv *env,
        jobject obj, //if call by static , jobject will be jclass
        jstring key,
        jstring path

) {

    char keys[128];
    jstring2string(env, key, keys);
    if (strcmp(keys, "install_key") == 0) {
        jstring2string(env, path, install_key);
        //("install_key : %s\n",install_key);

    } else if (strcmp(keys, "patterns") == 0) {
        jstring2string(env, path, bin_path);
        //("pattern_path : %s\n",pattern_path_bin);
    }
    const char *resultError = "";
    if (*bin_path && *install_key) {
        resultError = apii_init_ocr_pattern(bin_path, install_key);
        if (resultError == 0) {
            resultError = ""; //noErr
        }
        //resultError = "test 錯誤"; // debug only

    }
    if (resultError) {
        //("apii_init_ocr_pattern error message :%s\n",resultError);
        jclass strClass = env->FindClass("java/lang/String");
        jmethodID ctorID = env->GetMethodID(strClass, "<init>", "([BLjava/lang/String;)V");
        jstring encoding = env->NewStringUTF("UTF8");

        jbyteArray bytes = env->NewByteArray(strlen(resultError));
        env->SetByteArrayRegion(bytes, 0, strlen(resultError), (jbyte *) resultError);
        jstring str = (jstring) env->NewObject(strClass, ctorID, bytes, encoding);
        return str;
    }
}

jlong JavaTask::OCRPixelBuffer( // 辨識jpg圖檔
        JNIEnv *env,
        jobject obj, //if call by static , jobject will be jclass
        jintArray pixel,
        jint width,
        jint height,
        jint threadIndex

) {
    java_env = env;
    java_obj = obj;
    messageMeIntArray = env->GetMethodID(class1, "MessageMeIntArray",
                                         "([IIILjava/lang/String;)Ljava/lang/String;");
    messageMeByteArray = env->GetMethodID(class1, "MessageMeByteArray",
                                          "([BIILjava/lang/String;)Ljava/lang/String;");
    messageMeBitmap = env->GetMethodID(class1, "MessageMeBitmap",
                                       "(Landroid/graphics/Bitmap;Ljava/lang/String;)Ljava/lang/String;");

    if (pendingToJava) {
        pendingToJavaMutex.Lock();
        MyMessageToJava *messages = pendingToJava;
        pendingToJava = 0;
        pendingToJavaMutex.Unlock();
        if (messages) {
            messages->Send1Out(this);
            delete messages;
        }
    }
    jboolean isCopy = false;
    uint32_t *pixelData = (uint32_t *) env->GetIntArrayElements(pixel, &isCopy);
    int new_width;
    int new_height;
    new_width = width;
    new_height = height;
    int rowBytes = new_width * sizeof(uint32_t);
    DoRecognition_android( (char *) pixelData, rowBytes, new_width, new_height,   threadIndex);
    long lprOK = CheckJobCapability();
    env->ReleaseIntArrayElements(pixel, (jint *) pixelData, 0);
    return lprOK;

}


void MyMessageToJava::Send1Out(JavaTask *task) {
    //("message %s\n",message);
    jstring imageInfo = task->java_env->NewStringUTF(message);

    jobject image = 0;
    if (bits2.buff) {
        image = CreateBitmapForJava(task->java_env, task->java_obj, (unsigned char *) bits2.buff,
                                    bits2.width, bits2.height);
        free(bits2.buff);
    }
    task->java_env->CallObjectMethod(task->java_obj, task->messageMeBitmap, image,  imageInfo);
    if (next) {
        next->Send1Out(task);
    }
}




