package com.example.myapplication;
/*
install_key： 序號。 c++lib 需要序號，經由網路到雲端取得授權。屬於收費授權。sample code 內附的是測試用序號 , 測試序號隨時可能失效，正式版本序號付費購買請聯絡: chengansun@gmail.com


車牌辨識c++lib 提供三個 api：
apii_init_ocr_pattern: 呼叫一次以後共用於不同的 thread.
apii_DoOCRImage: 辨識車牌。辨識結果使用 OCRResultCallback 回傳。
apii_dispose_ocr_pattern()  不使用時呼叫可以釋放RAM。
呼叫 apii_DoOCRImage 時，指定的 myClip 大小，會影響辨識時間與佔用RAM，越大越慢且越容易發生記憶體不足。實際情況與手機 core 個數與 RAM 大小有關。


 */

import static android.os.Environment.getExternalStorageDirectory;

import androidx.appcompat.app.AppCompatActivity;
import android.content.Context;
import android.content.Intent;
import android.content.res.AssetManager;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Build;
import android.os.Bundle;
import android.os.Environment;
import android.provider.Settings;
import android.util.Log;
import com.example.myapplication.databinding.ActivityMainBinding;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;

import kotlin.jvm.Synchronized;

public class MainActivity extends AppCompatActivity {
    static MainActivity tis;
    static String TAG = "debug";
    // Used to load the 'myapplication' library on application startup.
    //static {
    //    System.loadLibrary("myapplication");
    //}

    private ActivityMainBinding binding;
    public static void unzipFromAssets(Context context, String zipFile, String destination) {
        try {
            if (destination == null || destination.length() == 0)
                destination = context.getFilesDir().getAbsolutePath();
            InputStream stream = context.getAssets().open(zipFile);
            unzip(stream, destination);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
/*
    public static void unzip(String zipFile, String location) throws FileNotFoundException {
        try {
            FileInputStream fin = new FileInputStream(zipFile);
            unzip(fin, location);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

 */
    private static final int BUFFER_SIZE = 1024 * 10;
    public static void unzip(InputStream stream, String destination) throws IOException {
        dirChecker(destination, "");

        byte[] buffer = new byte[BUFFER_SIZE];
        try {
            ZipInputStream zin = new ZipInputStream(stream);
            ZipEntry ze = null;

            while ((ze = zin.getNextEntry()) != null) {
                Log.v(TAG, "Unzipping " + ze.getName());

                if (ze.isDirectory()) {
                    dirChecker(destination, ze.getName());
                } else {
                    File f = new File(destination, ze.getName());
                    if (!f.exists()) {
                        boolean success = f.createNewFile();
                        if (!success) {
                            Log.w(TAG, "Failed to create file " + f.getName());
                            continue;
                        }
                        FileOutputStream fout = new FileOutputStream(f);
                        int count;
                        while ((count = zin.read(buffer)) != -1) {
                            fout.write(buffer, 0, count);
                        }
                        zin.closeEntry();
                        fout.close();
                    }
                }

            }
            zin.close();
        } catch (Exception e) {
            Log.e(TAG, "unzip", e);
        }

    }

    private static void dirChecker(String destination, String dir) throws IOException {
        File f = new File(destination, dir);
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
            Files.createDirectories(Paths.get(destination));
        }
        if (!f.isDirectory()) {
            boolean success = f.mkdirs();
            if (!success) {
                Log.d(TAG, "Failed to create folder " + f.getName());
            }
        }
    }
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        tis = this;
        binding = ActivityMainBinding.inflate(getLayoutInflater());
        setContentView(binding.getRoot());
        if (Build.VERSION.SDK_INT >= 30){
            if (!Environment.isExternalStorageManager()){
                Intent getpermission = new Intent();
                getpermission.setAction(Settings.ACTION_MANAGE_ALL_FILES_ACCESS_PERMISSION);
                startActivity(getpermission);
            }
        }

       // Assets/packed-patttern.bin.zip 這個檔案必須先解壓縮，存放到磁碟目錄內，然後將目錄透過 setPaths傳送到c++

        String patternBinPath = getExternalStorageDirectory() + "/pattern/packed-patttern.bin";
        File f = new File(patternBinPath);
        if (!f.exists()) {
            try {
                String path = getExternalStorageDirectory() + "/pattern";
                unzipFromAssets(this,"packed-patttern.bin.zip",path);

            } catch (Exception e) {
                throw new RuntimeException(e);
            }
        }
        try
        {
            // get input stream
            AssetManager assetManager = getAssets();
            InputStream istr = null;
            try {
                istr = assetManager.open("1.jpg");
            } catch (IOException e) {
                e.printStackTrace();
            }
            Bitmap bitmap = BitmapFactory.decodeStream(istr);
            OCRRecognitionSample ocr_recognition = new OCRRecognitionSample();
            //{"install_key": install_key,  "patterns": patternBinPath}

          /* 測試用序號 , 測試序號隨時可能失效，正式版本序號需付費購買，請聯絡: chengansun@gmail.com */
            String install_key = "20230608-09363763-01000001-debug+HEHFHCNCJFHHDPEBEDEGEFEGEKEKEHEGEDEDEDEEEADPEBEDEGEFEGEKEKEHEGEDEHEKEGEDDPEJEKECEDEFEGEEEDEBCMDBDADACMDBCMQFLQJHQKMEMMQHLHKBQGJLJA";


            // setPaths() 這兩行程式碼只需要呼叫一次即可。
            String result1 = ocr_recognition.SetPaths("install_key", install_key);
            String result2 = ocr_recognition.SetPaths("patterns", patternBinPath);
            if (result1.equals("") && result2.equals( "")) {
                // noError
                // result1 result2 如果不是空字串，代表有錯誤訊息。
            } else {
                Log.d("error",result1);
                Log.d("error",result2);
            }
            

            int scan_x = 0;
            int scan_y = 0;
            int scan_width = bitmap.getWidth();
            int scan_height = bitmap.getHeight();
            // 限定辨識範圍，範圍越大則耗時越久。
            Bitmap cropBits = Bitmap.createBitmap(bitmap, scan_x, scan_y, scan_width, scan_height);
            //  gap = System.currentTimeMillis() - startTime;
            //  Log.d("ansun", "cropBits: " + Long.toString(gap));
            // startTime = System.currentTimeMillis();
            int pixels[] = new int[scan_width * scan_height];
            cropBits.getPixels(pixels, 0, scan_width, 0, 0, scan_width, scan_height);
            final int[] counter = {0};
            for (int i=0;i<8;i++) { //同一張照片呼叫八次NativePixelBuffer會有不同的辨識結果。這是因為c++採用自動跳換演算法。
                // 實務上，八次必須使用八個獨立的 java thread才能有平行處理的能力
                // 實際使用，應該利用相機的即時串流，連續傳送照片辨識，藉由統計分數得到最佳化車牌號碼。
                int thread_index = i;
                // 辨識結束才回來，但辨識結果透過「回call」模式，可參考 OCRRecognitionSample內的 SendToFlutter()
                // SendToFlutter() 是被指定的 回call 函數，名稱參數都必須跟 mlpr-native-lib.cpp 內的定義相同。
                // 因為 ocr_recognition.NativePixelBuffer 辨識完成才回來，屬於block型態，
                // 必須使用 java thread 來呼叫 NativePixelBuffer() 才能利用到更多的 MCU Core效能。

                counter[0]++;
                new Thread(new Runnable() { //每一個Thread相當於需要 1 GB 的手機RAM，否則會因為記憶體不足當機。
                    @Override
                    public void run() {
                        long codeResult = ocr_recognition.NativePixelBuffer(pixels, scan_width,  scan_height,thread_index);
                        // 辨識結果在  OCRRecognitionSample::MessageMeBitmap()
                        counter[0]--;
                    }
                }).start();

                long codeResult = ocr_recognition.NativePixelBuffer(pixels, scan_width,  scan_height,thread_index);


            }

            while (counter[0] > 0) {
                try {
                    Thread.sleep(1);
                } catch (Exception e) {

                    e.printStackTrace();

                }
            }
            cropBits.recycle();
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.GINGERBREAD) {
                System.console().printf("finished");
            }

        }
        catch(Exception ex)
        {

        }

    }

    /**
     * A native method that is implemented by the 'myapplication' native library,
     * which is packaged with this application.
     */
   // public native String stringFromJNI();
}