package com.example.myapplication;
/*
install_key： 序號。 c++lib 需要序號，經由網路到雲端取得授權。屬於收費授權。sample code 內附的是測試用序號 , 測試序號隨時可能失效，正式版本序號付費購買請聯絡: chengansun@gmail.com


車牌辨識c++lib 提供三個 api：
apii_init_ocr_pattern: 呼叫一次以後共用於不同的 thread.
apii_DoOCRImage: 辨識車牌。辨識結果使用 OCRResultCallback 回傳。
apii_dispose_ocr_pattern()  不使用時呼叫可以釋放RAM。
呼叫 apii_DoOCRImage 時，指定的 myClip 大小，會影響辨識時間與佔用RAM，越大越慢且越容易發生記憶體不足。實際情況與手機 core 個數與 RAM 大小有關。


 */

import android.graphics.Bitmap;
import android.util.Log;

import androidx.annotation.Keep;

import java.io.ByteArrayOutputStream;
import java.util.HashMap;
import java.util.Map;



  // 2022/03/02 因為 proguard R8 會移除沒有被JAVA使用的 api，導致 c++ 無法找到這個api，所以需要宣告@Keep 保留全部屬於這個class 的member api。
 @Keep  public class OCRRecognitionSample extends Object {

    // Used to load the 'native-lib' library on application startup.
    static {
        System.loadLibrary("native-mlpr");
    }


    public native long NativePixelBuffer( // 辨識jpg圖檔
            int[] pixels, int width,
             int height,int threadIndex);
    public native String SetPaths( String key, String path);
    public native long Activate( int active);


    void SendToFlutter(final Map<String, Object> params)
    {
        // SendToFlutter params 內的 userPref  就是 傳送給 NativePixelBuffer 的 thread_index
        // 實際分數 = match_score x strlen(lpr_no)
        
        MainActivity.tis.runOnUiThread(new Runnable() {
            public void run() {
                try {
                    Log.d("ansun","params");
                   // MainActivity.methodChannelFlutter.invokeMethod("onImageCaptured", params);
                } catch (Exception e) {
                    e.printStackTrace();

                }
            }
        });
    }

    public String MessageMeBitmap(Bitmap bits, String bitmapInfo) { //a api for call back from c++

        try {
            Map<String, Object> params = new HashMap<>();
            //params.put("info", bitmapInfo);
            if (bits != null) {
                ByteArrayOutputStream bitsStream = new ByteArrayOutputStream();
                bits.compress(Bitmap.CompressFormat.PNG, 100, bitsStream);
                byte[] byteData = bitsStream.toByteArray();
                params.put("png", byteData);
            }
            String[] pairs = bitmapInfo.split(",");

            for (int i=0;i<pairs.length;i++) {
                String pair = pairs[i];
                String[] keyValue0 = pair.split(":");
                String[] keyValue = {keyValue0[0],""};
                if (keyValue0.length > 1) {
                    keyValue[1] =  keyValue0[1];
                }
                String key = keyValue[0];
                if (key.equals("match_score")) {
                    double value = Double.parseDouble(keyValue[1]);
                    params.put(keyValue[0], value);
                } else if (key.equals("match_count")) {
                    int value = Integer.parseInt(keyValue[1]);
                    params.put(keyValue[0], value);
                } else if  (key.equals("estimate_height")) {
                    double value = Double.parseDouble(keyValue[1]);
                    params.put(keyValue[0], value);
                } else {
                    params.put(keyValue[0], keyValue[1]);
                }
            }

            SendToFlutter(params);
            return "OK";
        } catch (Exception e) {
            e.printStackTrace();
            return "ERROR";
        }

    }

    public  String MessageMeIntArray(int[] dataInts,int width,int height, String bitmapInfo) { //a api for call back from c++

        try {
            Map<String, Object> params = new HashMap<>();
            params.put("path", "abcd");
            params.put("info", bitmapInfo);
            params.put("dataInts", dataInts);
            params.put("width",width);
            params.put("height",height);
            SendToFlutter(params);
            return "OK";
        } catch (Exception e) {
            e.printStackTrace();
            return "ERROR";
        }

    }

    public  String MessageMeByteArray(byte[] dataBytes,int width,int height, String bitmapInfo) { //a api for call back from c++

        try {
            Map<String, Object> params = new HashMap<>();
            params.put("path", "abcd");
            params.put("info", bitmapInfo);
            params.put("dataBytes", dataBytes);
            params.put("width",width);
            params.put("height",height);
            SendToFlutter(params);
            return "OK";
        } catch (Exception e) {
            e.printStackTrace();
            return "ERROR";
        }

    }

}


