package tw.com.smartinside.mlpr.sample;

import android.Manifest;
import android.annotation.SuppressLint;
import android.content.Context;
import android.content.pm.PackageManager;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.ImageFormat;
import android.graphics.Matrix;
import android.graphics.Paint;
import android.graphics.PixelFormat;
import android.graphics.PorterDuff;
import android.graphics.Rect;
import android.hardware.SensorManager;
import android.hardware.camera2.CameraCaptureSession;
import android.hardware.camera2.CameraCharacteristics;
import android.hardware.camera2.CameraDevice;
import android.hardware.camera2.CameraManager;
import android.hardware.camera2.CameraMetadata;
import android.hardware.camera2.CaptureRequest;
import android.hardware.camera2.CaptureResult;
import android.hardware.camera2.TotalCaptureResult;
import android.hardware.camera2.params.MeteringRectangle;
import android.hardware.camera2.params.StreamConfigurationMap;
import android.media.AudioManager;
import android.media.Image;
import android.media.ImageReader;
import android.media.ToneGenerator;
import android.os.AsyncTask;
import android.os.Build;
import android.os.Environment;
import android.os.Handler;
import android.os.HandlerThread;
import android.renderscript.Allocation;
import android.renderscript.Element;
import android.renderscript.RenderScript;
import android.renderscript.ScriptIntrinsicYuvToRGB;
import android.util.DisplayMetrics;
import android.util.Log;
import android.util.Range;
import android.util.Size;
import android.view.MotionEvent;
import android.view.OrientationEventListener;
import android.view.Surface;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.View;
import android.widget.FrameLayout;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.fragment.app.FragmentManager;

import org.jetbrains.annotations.NotNull;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.nio.ByteBuffer;
import java.nio.channels.Channels;
import java.nio.channels.WritableByteChannel;
import java.nio.charset.Charset;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.util.Timer;
import java.util.TimerTask;
import java.util.concurrent.atomic.AtomicReference;

import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.plugin.common.BinaryMessenger;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.StandardMessageCodec;
import io.flutter.plugin.platform.PlatformView;
import io.flutter.plugin.platform.PlatformViewFactory;

//SurfaceView 具有兩個 Canvas.

// LENS_FOCAL_LENGTH 焦距變換 變焦 就是 光學zoom 变焦最直观的感受就是被摄物体在取景器离被放大或者缩小了。
// LENS_FOCUS_DISTANCE 對焦 0.0 这个值意味着无限远焦点，值集将被限制为[0.0f，android.lens.info.minimumFocusDistance]。

//android.os.Build.VERSION.SDK_INT;
//宣育 htc api-22
//Peterson htc api-24
//ansun 小米cc9 api-30
//云霏的姊  oppo cph1831  api-29
//samsung i9300 更新到 api-25 以後，無法正確使用 ImageReader ImageFormat.YUV_420_888,但可以使用 ImageFormat.JPEG,原因不明。
/*
interface FragmentLifecycleListener {
    // These methods are the different events and
    // need to pass relevant arguments related to the event triggered
    void onPause();

    // or when data has been loaded
    void onResume();
}
*/
class WaitForCameraObject {
    MethodChannel.Result flutter_result;
    MainActivity activity;

    public WaitForCameraObject(MainActivity activity0, MethodChannel.Result flutter_resulto) {
        this.flutter_result = flutter_resulto;
        activity = activity0;
    }

    public void notifyCameraSet(boolean status) {
        flutter_result.success(status);
    }
}

@SuppressWarnings("ALL")
public class AndroidCamera implements MethodChannel.MethodCallHandler, PlatformView {

    int grayDeltaThreshold = 0;
    private final Context context;
    private final MainActivity activity;
    private boolean disposed = false;
    private final FrameLayout view2;
    SurfaceView mySurfaceView;
    private final SurfaceHolder imgSurfaceHolder;
    private final SurfaceHolder holderTransparent; //float over on imgSurface
    private CameraDevice camera22;
    private int cameraFacing = 0;
    private SavePicTask savePicTask;
    CameraFragment cameraFragment;
    private File folder;
    private Integer maxSize;
    private String savePath;
    private String fileNamePrefix = "camera";
    private int iOrientation = 0;
    private int mPhotoAngle = 90;
    private String previewRatio;
    private float mDist;
    private String flashType = "off";
    private boolean bestPictureSize;
    //boolean needPreview = false;
    private WaitForCameraObject waitForCameraObject;
    private int focusRectColor = Color.GREEN;
    private float focusRectSize = 100f;
    boolean pausedByMe = false;
    //Bitmap cropBits = null;
    double preview_height;// = mySurfaceView.getHeight(); //imgSurfaceView
    double preview_width;// = mySurfaceView.getWidth();
    //private CameraManager
    //Bitmap bitmap = null;
    //ImageView my_picture = null;
    byte[] nv21data = null;
    int[] ocrPixelBufferPending = null;
    Boolean DrawCanvasDirect = false;
    Integer canvasLocked = 0;
    boolean usePreview = false;
    int defaultImageFormat;
    long lastOCRTimeMillis = System.currentTimeMillis();
    long threadNeedDelayTimeGap;
    long jobsCapability;

    class MyOCRThread {
        //負責 呼叫 c++ 做車牌辨識。只有透過 java thread 才能讓c++用到 multi-core。
        //android.hardware.Camera camera;
        Thread threading;
        MyOCRRunnable runnable;
        AndroidCamera owner;

        public MyOCRThread(int threadIndex, AndroidCamera this0) {
            owner = this0;
            runnable = new MyOCRRunnable(this, threadIndex);
            threading = new Thread(runnable);
            threading.start();
        }
    }

    ;

    void DrawToCanvas(Bitmap cropBits) {
        try {
            boolean canvasBusy = false;
            synchronized (canvasLocked) {
                // synchronized (canvasLocked)  比  lockCanvas() 有效率，減少 UI lag 卡頓。
                if (canvasLocked == 1) {
                    canvasBusy = true;
                } else {
                    canvasBusy = false;
                    canvasLocked = 1;
                }
            }
            if (!canvasBusy) {
                Canvas canvas = imgSurfaceHolder.lockCanvas();
                if (canvas != null) {

                    if (cropBits != null) {

                        int right = (int) preview_width;
                        int bottom = (int) preview_height;
                        int bitWidth = cropBits.getWidth();
                        int bitHeight = cropBits.getHeight();
                        if (true) {
                            //縮放調整剛好滿螢幕。
                            canvas.drawBitmap(cropBits, null, new Rect(0, 0, right, bottom), paint);
                        } else {
                            //實際解析度大小，可能不滿或溢出螢幕。
                            canvas.drawBitmap(cropBits, null, new Rect(0, 0, cropBits.getWidth(), cropBits.getHeight()), paint);
                        }
                        double ratio = preview_width / bitWidth;
                        int pixel16 = (int) (ratio * 28);
                        int left = (right - pixel16) / 2;
                        int top = (bottom - pixel16) / 2;
                        Paint redPaint = new Paint();

                        redPaint.setColor(Color.rgb(0, 0, 0));
                        redPaint.setStrokeWidth(1);
                        redPaint.setStyle(Paint.Style.STROKE);
                        canvas.drawRect(left, top, left + pixel16, top + pixel16, redPaint); //提示最小可辨識字母高度pixel.
                        //canvas.drawBitmap(cropBits,0,0, paint  );
                        //Log.d("ansun","canvas.drawBitmap on thread");

                    }

                    imgSurfaceHolder.unlockCanvasAndPost(canvas);

                }
                synchronized (canvasLocked) {
                    canvasLocked = 0;
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    Image imagePending = null;
    MyPrepareImageThread prepareThreads[];// 解壓縮 camera 得到的 照片，傳給 display 與 MyOCRThread。
    Bitmap drawPending = null;
    MyOCRThread ocrThreads[];
    Thread drawThread;

    Thread GetDrawThread() {


        return new Thread(new Runnable() {
            @Override
            public void run() {
                Paint paint = new Paint();
                paint.setAntiAlias(false);
                synchronized (MainActivity.ocr_recognition) {
                    threadCounter++;
                }
                while (threadDeactovateToStop == false) {
                    Bitmap cropBits = null;

                    synchronized (DrawCanvasDirect) {
                        if (drawPending != null) {
                            cropBits = drawPending;
                            drawPending = null;
                        }
                    }

                    if (cropBits != null) {
                        //Bitmap cropBits = drawPending;
                        // drawPending = null;
                        try {
                            DrawToCanvas(cropBits);
                        } catch (Exception e) {
                            e.printStackTrace();
                        }
                        if (cropBits != null) {
                            cropBits.recycle();
                            cropBits = null;
                        }
                    }
                    try {
                        Thread.sleep(100);
                    } catch (Exception e) {
                    }
                    ;
                }
                synchronized (MainActivity.ocr_recognition) {
                    threadCounter--;
                }
            }
        });
    }

    void SetupThread() {
        if (threadCounter > 0) {
            return;
        }
        threadDeactovateToStop = false;

        int iJavaThreadCount = 2; // android 只有在java 或 renderscript 才能用到 multi-score。
        if (Build.VERSION.SDK_INT >= 17) {
            iJavaThreadCount = Runtime.getRuntime().availableProcessors() - 3; //flutter 也需要 thread, 保留 cpu core 給 flutter, 2021/11/30
            if (iJavaThreadCount < 2) {
                iJavaThreadCount = 2;
            }
        }
        boolean iDoMLPR = true;
        if (iDoMLPR) {

        } else {
            iJavaThreadCount = 1;
        }
        threadNeedDelayTimeGap = 1000 / iJavaThreadCount; //2021/12/02 確保每個thread 可以平均分配時間，避免全部集中在一起搶奪資源造成漏掉照片。
        ocrThreads = new MyOCRThread[iJavaThreadCount]; //辨識比較花時間，為了讓c++可以得到multi-core，所以需要比較多個 java thread。
        for (int i = 0; i < iJavaThreadCount; i++) {
            ocrThreads[i] = new MyOCRThread(i + 1, this);

        }
        int prepareCount = 2; // iJavaThreadCount modify date 2021/11/23, 減少 MyPrepareImageThread 個數後，UI更新比較不會lag。
        prepareThreads = new MyPrepareImageThread[prepareCount]; //解壓縮如果太多個thread ，解開後也來不及處理，所以不需要太多 thread。
        for (int i = 0; i < prepareCount; i++) {

            prepareThreads[i] = new MyPrepareImageThread(i + 1);
        }
        if (DrawCanvasDirect == false) {
            drawThread = GetDrawThread();
            drawThread.start();
        }

    }

    boolean threadDeactovateToStop = false;

    void CloseThread() {
        threadDeactovateToStop = true;
        try {
            while (threadCounter > 0) {
                Thread.sleep(500);
            }
            printf("thread closed");
        } catch (Exception e) {

            e.printStackTrace();
        }

    }

    @SuppressLint({"InflateParams", "ClickableViewAccessibility"})
    AndroidCamera(
            int id,
            BinaryMessenger messenger,
            final Context context,
            MainActivity activity0,
            Object args_params) {

        this.context = context;
        activity = activity0;


        SetupThread();

        MainActivity.methodChannelFlutter = new MethodChannel(messenger, "plugins.flutter.io/my_camera/" + id);
        MainActivity.taskinfo_channel = new MethodChannel(messenger, "my_task_channel");
        MainActivity.methodChannelFlutter.setMethodCallHandler(this);
        final SurfaceView xx;
        if (false) {
            view2 = (FrameLayout) activity.getLayoutInflater().inflate(tw.com.smartinside.mlpr.sample.R.layout.activity_camera, null);
            mySurfaceView = view2.findViewById(tw.com.smartinside.mlpr.sample.R.id.imgSurface);
            xx = view2.findViewById(tw.com.smartinside.mlpr.sample.R.id.TransparentView);
        } else {
            view2 = new FrameLayout(activity);
            mySurfaceView = new SurfaceView(view2.getContext()) {

                @Override
                protected void onAttachedToWindow() {
                    super.onAttachedToWindow();
                    setWillNotDraw(false);
                    preview_height = getHeight(); //imgSurfaceView
                    preview_width = getWidth();
                }

                Bitmap cropBits = null;
/*
                @Override
                public void onDraw(Canvas canvasOfView) {
                    //SurfaceView 具有兩個 Canvas.

                    try {
                        Canvas canvasOfSurface = imgSurfaceHolder.lockCanvas();
                        if (canvasOfSurface != null) {
                            canvasOfSurface.drawColor(Color.BLACK);
                            if (drawPending != null) {
                                cropBits = drawPending;
                                drawPending = null;
                            }
                            if (cropBits != null) {
                                int right = (int) preview_width;
                                int bottom = (int) preview_height;
                                Paint bitmapPaint = null;//new Paint(Paint.FILTER_BITMAP_FLAG);
                                canvasOfSurface.drawBitmap(cropBits, null, new Rect(0, 0, right, bottom), bitmapPaint);
                            }
                            imgSurfaceHolder.unlockCanvasAndPost(canvasOfSurface);
                            //Log.d("ansun", "canvas.drawBitmap onDraw: ");
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                    super.onDraw(canvasOfView);

                }

 */
            };
            view2.addView(mySurfaceView);
            xx = new SurfaceView(view2.getContext());
            view2.addView(xx);
        }
        xx.setZOrderMediaOverlay(true);
        holderTransparent = xx.getHolder();
        holderTransparent.setFormat(PixelFormat.TRANSPARENT);
        holderTransparent.setType(SurfaceHolder.SURFACE_TYPE_PUSH_BUFFERS);

        cameraFragment = new CameraFragment();
        FragmentManager manager = activity.getSupportFragmentManager();

        manager.beginTransaction().add(cameraFragment, "cameraFragment").commit();
        mySurfaceView.setFocusable(true);
        mySurfaceView.setFocusableInTouchMode(true);

        if (args_params instanceof HashMap) {
            @SuppressWarnings({"unchecked"})
            Map<String, Object> params = (Map<String, Object>) args_params;
            Object initialCamera = params.get("initialCameraType");
            Object flashType = params.get("flashType");
            Object savePath = params.get("savePath");
            Object previewRatio = params.get("previewRatio");
            Object fileNamePrefix = params.get("fileNamePrefix");
            Object maxSize = params.get("maxSize");
            Object bestPictureSize = params.get("bestPictureSize");
            Object focusRectColorRed = params.get("focusRectColorRed");
            Object focusRectColorGreen = params.get("focusRectColorGreen");
            Object focusRectColorBlue = params.get("focusRectColorBlue");
            Object focusRectSize = params.get("focusRectSize");

            if (initialCamera != null) {
                if (initialCamera.equals("front")) {
                    cameraFacing = 1;
                } else if (initialCamera.equals("rear")) {
                    cameraFacing = 0;
                }
            }

            if (flashType != null) {
                this.flashType = flashType.toString();
            }

            if (savePath != null) {
                this.savePath = savePath.toString();
            } else {
                this.savePath = Environment.getExternalStorageDirectory() + "/images";
            }

            if (previewRatio != null) {
                this.previewRatio = previewRatio.toString();
            } else {
                this.previewRatio = "16:9";
            }

            if (fileNamePrefix != null) {
                this.fileNamePrefix = fileNamePrefix.toString();
            }

            if (maxSize != null) {
                this.maxSize = (Integer) maxSize;
            }

            if (bestPictureSize != null) {
                this.bestPictureSize = Boolean.parseBoolean(bestPictureSize.toString());
            }

            if (focusRectColorRed != null && focusRectColorGreen != null && focusRectColorBlue != null) {
                final int red = Integer.parseInt(focusRectColorRed.toString());
                final int green = Integer.parseInt(focusRectColorGreen.toString());
                final int blue = Integer.parseInt(focusRectColorBlue.toString());
                focusRectColor = Color.rgb(red, green, blue);
            }

            if (focusRectSize != null) {
                this.focusRectSize = Float.parseFloat(focusRectSize.toString());
            }
        }

        mySurfaceView.setOnTouchListener(new View.OnTouchListener() {
            boolean twoFingerTouched = false;

            @Override
            public boolean onTouch(View v, MotionEvent event) {
                // Get the pointer ID
                //Camera.Parameters params = camera22.getParameters();

                int action = event.getAction();

                if (event.getPointerCount() > 1) {
                    twoFingerTouched = true;
                    // handle multi-touch events
                    if (action == MotionEvent.ACTION_POINTER_2_DOWN) {
                        mDist = getFingerSpacing(event);
                    } else if (action == MotionEvent.ACTION_MOVE /*&& params.isZoomSupported()*/) {

                        handleZoomPinch(event);

                        MainActivity.tis.runOnUiThread(new Runnable() {
                            public void run() {
                                try {
                                    Map<String, Double> params = new HashMap<>();
                                    params.put("setZoom", zoomScaler);
                                    MainActivity.methodChannelFlutter.invokeMethod("setZoom", params);
                                } catch (Exception e) {
                                    e.printStackTrace();

                                }
                            }
                        });
                    }
                } else {
                    // handle single touch events
                    if (action == MotionEvent.ACTION_UP) {
                        int pointerId = event.getPointerId(0);
                        int pointerIndex = event.findPointerIndex(pointerId);
                        if (twoFingerTouched == false) {
                            ResetAuto(zoomScaler, (int) event.getX(pointerIndex), (int) event.getY(pointerIndex), true, false);
                        }
                        twoFingerTouched = false;
                        // Get the pointer's current position

                    }
                }
                return true;
            }
        });


        folder = new File(this.savePath);
        if (!folder.exists()) {
            folder.mkdirs();
        }

        imgSurfaceHolder = mySurfaceView.getHolder();
        imgSurfaceHolder.addCallback(new SurfaceHolder.Callback() {

            @Override
            public void surfaceCreated(SurfaceHolder holder) {
                printf("surfaceCreated\n");
                /*
                // 可能重複呼叫：
                Some changes you do in Surface View makes it call surfaceCreated() again,
                for example: "yourSurfaceView.getHolder().setFormat(PixelFormat.TRANSPARENT)"
                will call surfaceCreated() again.

                 */
                //if (camera22 == null) {
                setupCamera();
                // }

            }

            @Override
            public void surfaceChanged(SurfaceHolder holder, int format, int width, int height) {
                // refreshCamera();
                //Log.d("ansun", "surfaceChanged: ");
                printf("surfaceChanged\n");
                preview_width = width;
                preview_height = height;
                //if ((width > 0) && (height > 0) && needPreview) {
                //setupCamera();
                //}
            }

            @Override
            public void surfaceDestroyed(SurfaceHolder holder) {
                printf("surfaceDestroyed\n");
                try {

                    CloseCamera();
                    camera22 = null;
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }

        });

        identifyOrientationEvents();


    }

    class MyCaptureCallback extends CameraCaptureSession.CaptureCallback {
        boolean auto_focus_locked = false;
        boolean auto_exposure_locked = false;
        boolean auto_awb_locked = false;
        boolean waitLock = false;

        private void process(CaptureResult result) {
            boolean use_continous = false;
            try {
                int afState = result.get(CaptureResult.CONTROL_AF_STATE);
                if (afState == CaptureResult.CONTROL_AF_STATE_FOCUSED_LOCKED) {
                    auto_focus_locked = true;
                }
            } catch (Exception e) {
                use_continous = true;
            }
            try {
                int aeState = result.get(CaptureResult.CONTROL_AE_STATE);
                switch (aeState) {
                    case CaptureResult.CONTROL_AE_STATE_CONVERGED:
                    case CaptureResult.CONTROL_AE_STATE_LOCKED:
                    case CaptureResult.CONTROL_AE_STATE_FLASH_REQUIRED:
                        auto_exposure_locked = true;

                        break;
                }
            } catch (Exception e) {
                use_continous = true;
            }
            try {
                int awbState = result.get(CaptureResult.CONTROL_AWB_STATE);


                switch (awbState) {
                    case CaptureResult.CONTROL_AWB_STATE_CONVERGED:
                    case CaptureResult.CONTROL_AWB_STATE_LOCKED:
                        auto_awb_locked = true;
                        break;
                }
            } catch (Exception e) {
                use_continous = true;
            }


            if (auto_exposure_locked && auto_focus_locked && auto_awb_locked) {
                try {
                    mCameraCaptureSession.stopRepeating();
                } catch (Exception e) {

                }
                ;

                //modify date 2021/12/05  利用 3個自動 對焦/曝光/白平衡 完成之後改用鎖定模式，避免手機不斷的忙碌改變畫面，導致很沒效率。
                waitLock = false; // 已經完成三個自動項目。
                ResetAuto(zoomScaler, 0, 0, false, false);
            } else {
                if (use_continous) {
                    waitLock = false; // 已經完成三個自動項目。
                    ResetAuto(zoomScaler, 0, 0, false, use_continous);
                }
            }
        }

        @Override
        public void onCaptureCompleted(CameraCaptureSession session,
                                       CaptureRequest request, TotalCaptureResult result) {
            // default empty implementation
            //  printf("setRepeatingRequest onCaptureCompleted");
            if (waitLock) {
                if (autoValue == 0) {
                    //全自動時不需要分析
                    waitLock = false;
                } else {
                    //半自動時需要分析是否已經鎖定
                    process(result);
                }
            }

        }
    }

    ;

    private void captureImage() {
        CameraManager cameraManager = (CameraManager) context.getSystemService(Context.CAMERA_SERVICE);

    }

    double zoomScaler = 0;
    double oldISO = -1;
    double oldExpose = -1;
    double oldFocus = -1;


    CaptureRequest myRequest = null; // getTag -> MyCaptureCallback


    boolean ResetAuto(double newZoom, int x, int y, boolean resetFocus, boolean use_continous) {

        try {
            CameraCaptureSession.CaptureCallback callback;
            CameraManager cameraManager = (CameraManager) context.getSystemService(Context.CAMERA_SERVICE);
            CameraCharacteristics characteristics = cameraManager.getCameraCharacteristics(camera22.getId());
            int deviceLevel = characteristics.get(CameraCharacteristics.INFO_SUPPORTED_HARDWARE_LEVEL);
            //INFO_SUPPORTED_HARDWARE_LEVEL 不同機型的camera2 可能有不同程度的自動化參數。

            CaptureRequest.Builder mCaptureRequestBuilder = camera22.createCaptureRequest(CameraDevice.TEMPLATE_PREVIEW);
            //resetAuto

            mCaptureRequestBuilder.set(CaptureRequest.CONTROL_MODE, CameraMetadata.CONTROL_MODE_AUTO);
            mCaptureRequestBuilder.addTarget(myImgReader.getSurface());
            if (usePreview == true) {
                mCaptureRequestBuilder.addTarget(mySurfaceView.getHolder().getSurface());
            }
            //Range<Integer> fps  = Range.create(3,60);
            //mCaptureRequestBuilder.set(CaptureRequest.CONTROL_AE_TARGET_FPS_RANGE,fps);

            handleZoomScaled(newZoom, mCaptureRequestBuilder);


            MeteringRectangle focusAreaTouch = handleFocusBy1Touch(x, y);
            boolean waitLock0;
            if ((focusAreaTouch != null) && (use_continous || (autoValue == 0))) {
                //全自動
                waitLock0 = false; //modify date 2021/12/05  利用 3個自動 對焦/曝光/白平衡 完成之後改用鎖定模式，避免手機不斷的忙碌改變畫面，導致很沒效率。
                mCaptureRequestBuilder.set(CaptureRequest.CONTROL_AF_MODE, CaptureRequest.CONTROL_AF_MODE_CONTINUOUS_VIDEO);
                mCaptureRequestBuilder.set(CaptureRequest.CONTROL_AE_MODE, CaptureRequest.CONTROL_AE_MODE_ON);

                mCaptureRequestBuilder.set(CaptureRequest.CONTROL_AWB_MODE, CaptureRequest.CONTROL_AWB_MODE_AUTO);

                mCaptureRequestBuilder.set(CaptureRequest.CONTROL_AE_LOCK, false);
                //有些機型手機只能採用持續對焦，無法鎖定對焦。
                //  MeteringRectangle meter[] = new MeteringRectangle[]{focusAreaTouch};
                // mCaptureRequestBuilder.set(CaptureRequest.CONTROL_AF_REGIONS, meter);
                // mCaptureRequestBuilder.set(CaptureRequest.CONTROL_AF_TRIGGER, CameraMetadata.CONTROL_AF_TRIGGER_START);
                //  mCaptureRequestBuilder.set(CaptureRequest.CONTROL_AE_REGIONS, meter);
                //  mCaptureRequestBuilder.set(CaptureRequest.CONTROL_AE_PRECAPTURE_TRIGGER, CameraMetadata.CONTROL_AE_PRECAPTURE_TRIGGER_START);
            } else {
                //半自動
                if ((focusAreaTouch != null) && resetFocus)
                // if (focusAreaTouch != null)
                {
                    waitLock0 = true; //modify date 2021/12/05  利用 3個自動 對焦/曝光/白平衡 完成之後改用鎖定模式，避免手機不斷的忙碌改變畫面，導致很沒效率。
                    mCaptureRequestBuilder.set(CaptureRequest.CONTROL_AF_MODE, CaptureRequest.CONTROL_AF_MODE_AUTO);
                    mCaptureRequestBuilder.set(CaptureRequest.CONTROL_AE_MODE, CaptureRequest.CONTROL_AE_MODE_ON);

                    mCaptureRequestBuilder.set(CaptureRequest.CONTROL_AWB_MODE, CaptureRequest.CONTROL_AWB_MODE_AUTO);

                    mCaptureRequestBuilder.set(CaptureRequest.CONTROL_AE_LOCK, false);
                    //CONTROL_AF_MODE_AUTO 會自動鎖定focus,中途不會持續自動對焦
                    MeteringRectangle meter[] = new MeteringRectangle[]{focusAreaTouch};
                    mCaptureRequestBuilder.set(CaptureRequest.CONTROL_AF_REGIONS, meter);
                    mCaptureRequestBuilder.set(CaptureRequest.CONTROL_AF_TRIGGER, CameraMetadata.CONTROL_AF_TRIGGER_START);
                    mCaptureRequestBuilder.set(CaptureRequest.CONTROL_AE_REGIONS, meter);
                    mCaptureRequestBuilder.set(CaptureRequest.CONTROL_AE_PRECAPTURE_TRIGGER, CameraMetadata.CONTROL_AE_PRECAPTURE_TRIGGER_START);
                    // mCaptureRequestBuilder.set(CaptureRequest.CONTROL_AE_LOCK, true);

                    // mCaptureRequestBuilder.set(CaptureRequest.CONTROL_AE_LOCK, true);
                } else {
                    //modify date 2021/12/05  利用 3個自動 對焦/曝光/白平衡 完成之後改用鎖定模式，避免手機不斷的忙碌改變畫面，導致很沒效率。
                    waitLock0 = false; // 已經完成三個自動項目。
                    mCaptureRequestBuilder.set(CaptureRequest.CONTROL_AF_MODE, CaptureRequest.CONTROL_AF_MODE_AUTO);
                    mCaptureRequestBuilder.set(CaptureRequest.CONTROL_AE_MODE, CaptureRequest.CONTROL_AE_MODE_ON);
                    mCaptureRequestBuilder.set(CaptureRequest.CONTROL_AWB_MODE, CaptureRequest.CONTROL_AWB_MODE_OFF);
                    mCaptureRequestBuilder.set(CaptureRequest.CONTROL_AE_LOCK, true);
                    mCaptureRequestBuilder.set(CaptureRequest.CONTROL_AF_TRIGGER, CameraMetadata.CONTROL_AF_TRIGGER_IDLE);
                    mCaptureRequestBuilder.set(CaptureRequest.CONTROL_AE_PRECAPTURE_TRIGGER, CameraMetadata.CONTROL_AE_PRECAPTURE_TRIGGER_IDLE);
                }
            }
            try {
                //resetAuto
                //("resetAuto");
                mCameraCaptureSession.stopRepeating();
                if (myRequest != null) {
                    mCameraCaptureSession.stopRepeating();
                }
                myRequest = mCaptureRequestBuilder.build();

                MyCaptureCallback myCallback = new MyCaptureCallback();
                myCallback.waitLock = waitLock0;
                mCaptureRequestBuilder.setTag(myCallback);
                mCameraCaptureSession.setRepeatingRequest(myRequest, myCallback, mBackgroundHandler);
                return true;
            } catch (Exception e) {
                e.printStackTrace();
                return false;
            }

        } catch (Exception e) {
            e.printStackTrace();
            return false;
        }
    }

    void printf(String message) {
        Log.d("ansun", message);
    }


    private void ResetCamera(double newFocus, double newZoom, double newExpose, double newISO) {
        { //已經停用 2021/12/04, 改用 自動鎖定 resetAuto

            try {


                CameraManager cameraManager = (CameraManager) context.getSystemService(Context.CAMERA_SERVICE);
                CameraCharacteristics characteristics = cameraManager.getCameraCharacteristics(camera22.getId());
                CaptureRequest.Builder mCaptureRequestBuilder = camera22.createCaptureRequest(CameraDevice.TEMPLATE_PREVIEW);

                handleZoomScaled(newZoom, mCaptureRequestBuilder);
                mCaptureRequestBuilder.set(CaptureRequest.LENS_FOCUS_DISTANCE, (float) newFocus * 10);

                // fix exposure
                //ResetCamera 停用 //已經停用 2021/12/04, 改用 自動鎖定 resetAuto
                mCaptureRequestBuilder.set(CaptureRequest.CONTROL_AE_MODE, CameraMetadata.CONTROL_AE_MODE_OFF);
                mCaptureRequestBuilder.set(CaptureRequest.CONTROL_AF_MODE, CameraMetadata.CONTROL_AF_MODE_OFF);
                Range<Long> exposureTimeRange = characteristics.get(CameraCharacteristics.SENSOR_INFO_EXPOSURE_TIME_RANGE);
                //mCaptureRequestBuilder.set(CaptureRequest.CONTROL_MODE, CameraMetadata.INFO_SUPPORTED_HARDWARE_LEVEL_FULL);

                if (exposureTimeRange != null) {
                    long minExpose = exposureTimeRange.getLower();
                    //long maxExpose = exposureTimeRange.getUpper();//minExpose * 1000;//(long) (0.3 * 1000000000.0);
                    //double root = Math.sqrt(maxExpose - minExpose) * newExpose;
                    //double exposureNanos = minExpose + root*root;//(maxExpose - minExpose) * newExpose;

                    long maxExpose = minExpose * 1000;//(long) (0.3 * 1000000000.0);
                    // double root = Math.sqrt(maxExpose - minExpose) * newExpose;
                    double exposureNanos = minExpose + (maxExpose - minExpose) * newExpose;

                    mCaptureRequestBuilder.set(CaptureRequest.SENSOR_EXPOSURE_TIME, (long) exposureNanos);
                }

                // fix ISO
                Range<Integer> isoRange = characteristics.get(CameraCharacteristics.SENSOR_INFO_SENSITIVITY_RANGE);
                if (isoRange != null) {
                    ////ResetCamera //已經停用 2021/12/04, 改用 自動鎖定 resetAuto
                    mCaptureRequestBuilder.set(CaptureRequest.CONTROL_AE_MODE, CameraMetadata.CONTROL_AE_MODE_OFF);
                    double desiredIso = isoRange.getLower() + (isoRange.getUpper() - isoRange.getLower()) * newISO;
                    // mCaptureRequestBuilder.set(CaptureRequest.CONTROL_MODE, CameraMetadata.INFO_SUPPORTED_HARDWARE_LEVEL_FULL);
                    mCaptureRequestBuilder.set(CaptureRequest.SENSOR_SENSITIVITY, (int) desiredIso);
                }
                mCaptureRequestBuilder.addTarget(myImgReader.getSurface());
                try {
                    //ResetCamera
                    printf("ResetCamera");  //已經停用 2021/12/04, 改用 自動鎖定 resetAuto
                    mCameraCaptureSession.stopRepeating();
                    mCameraCaptureSession.setRepeatingRequest(mCaptureRequestBuilder.build(), null, mBackgroundHandler);
                } catch (Exception e) {
                    e.printStackTrace();
                }

            } catch (Exception e) {
                e.printStackTrace();

            }
            oldExpose = newExpose;
            oldISO = newISO;
            oldFocus = newFocus;
            zoomScaler = newZoom;

        }
    }

    boolean ContainFormat(int formats[], int value) {
        for (int i = 0; i < formats.length; i++) {
            if (formats[i] == value) {
                return true;
            }
        }
        return false;
    }

    Timer suspendTimer = null;

    void SuspendThread() {
        suspendSetting = true;
        if (suspendTimer != null) {
            try {
                suspendTimer.cancel();
                //suspendTimer = null;
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        suspendTimer = new Timer();
        suspendTimer.schedule(new TimerTask() {
            @Override
            public void run() {
                suspendSetting = false;
                suspendTimer.cancel();
                suspendTimer = null;
            }
        }, 1500, 1000);
    }

    void deactivateOCR() {
        CloseCamera();

        CloseThread();
        //thread 沒有關掉，可能還有照片送到 c++，因此不適合直接關掉 c++.
        MainActivity.DoActivate(0);
    }

    int autoValue = 0;
    double scanArea = 0;
    @Override
    public void onMethodCall(MethodCall methodCall, @NonNull MethodChannel.Result result) {
        switch (methodCall.method) {
            case "activateOCR":
                printf("activateOCR1");
                if (camera22 == null) {
                    setupCamera();
                    SetupThread();
                    MainActivity.DoActivate(1);
                }
                result.success(true);
                break;
            case "deactivateOCR": //2022/12/31 發現 有邏輯問題， 通知關掉camera導致 channel 被關閉而無法完成這個呼叫程序。
                printf("deactivateOCR1");
                deactivateOCR();
                //CloseCamera();
               // CloseThread();
                //thread 沒有關掉，可能還有照片送到 c++，因此不適合直接關掉 c++.
               // MainActivity.DoActivate(0);


                result.success(true);
                break;
            case "setPaths":
                if (methodCall.arguments instanceof HashMap) {
                    Map<String, String> params = (Map<String, String>) methodCall.arguments;
                    params.forEach((key,value)-> {
                        activity.ocr_recognition.SetPaths(key,value);
                    });

                }
                result.success(true);
                break;
            case "getZoom":
                result.success(zoomScaler); // oldZoom : range 0..1
                break;
            case "setSliders":
                printf("setSliders");
                if ((methodCall.arguments instanceof HashMap) && (camera22 != null)) {
                    //SuspendThread();
                    @SuppressWarnings({"unchecked"})
                    Map<String, Object> slidersv = (Map<String, Object>) methodCall.arguments;
                    // "對焦:","曝光:","遠近:"

                    autoValue = (Integer) slidersv.get("autoCamera");
                   // boolean auto = (autoValue != 0);
                    Double scanAreaNew = (Double)slidersv.get("面積:"); //camera擷取可辨識面積
                    if (scanAreaNew != scanArea) {
                        scanArea = scanAreaNew;
                        if (camera22 != null) {
                            CloseCamera();
                            try {
                                Thread.sleep(500);
                            } catch (Exception e) {

                            }
                        }
                        setupCamera();
                    }
                    if (autoValue < 2) {
                        //只用自動鎖定模式，停用手動模式，也停用<自動持續>模式。 2021/12/04
                        grayDeltaThreshold = 0;
                        double newZoom = (Double)slidersv.get("遠近:");
                        //setZoom
                        ResetAuto(newZoom,0,0,true,autoValue==0);

                    } else {
                        //已經停用 2021/12/04, 改用 自動鎖定, 2021/12/07 因為發現光線不足時需要手動設定，因此重新啟用
                        if (slidersv.containsKey("ISO:")) {

                            grayDeltaThreshold = 0;//valueDelta * 90 + 10;
                            double newFocus = (Double)slidersv.get("對焦:");
                            double newZoom = (Double)slidersv.get("遠近:");
                            double newExpose = (Double)slidersv.get("曝光:");
                            double newISO = (Double)slidersv.get("ISO:");
                            ResetCamera(newFocus, newZoom, newExpose, newISO);
                        }
                    }
                }
                result.success(true);
                break;
            case "waitForCamera":
                if (camera22 == null) {
                    waitForCameraObject = new WaitForCameraObject(activity, result);
                } else {
                    result.success(true);
                }
                //result.success(true); // WaitForCameraObject will reply ,don't need result.success(true) here
                break;
            case "turnOff":
                CloseCamera();
                result.success(null);
                break;
            case "turnOn":
                setupCamera();
                result.success(null);
                break;
            case "setPreviewRatio": {
                String previewRatio = "";

                if (methodCall.arguments instanceof HashMap) {
                    @SuppressWarnings({"unchecked"})
                    Map<String, Object> params = (Map<String, Object>) methodCall.arguments;
                    Object previewRatioRaw = params.get("previewRatio");
                    previewRatio = previewRatioRaw == null ? null : previewRatioRaw.toString();
                }
                try {
                    CameraManager cameraManager = (CameraManager) context.getSystemService(Context.CAMERA_SERVICE);
                    CameraCharacteristics characteristics = cameraManager.getCameraCharacteristics(camera22.getId());
                    StreamConfigurationMap map = null;
                    Size imageSizes[] = null;
                    if (characteristics != null) {
                        map = characteristics.get(CameraCharacteristics.SCALER_STREAM_CONFIGURATION_MAP);

                        imageSizes = map.getOutputSizes(defaultImageFormat);

                        Size selectedSize = null;
                        for (Size size : imageSizes) {
                            if (asFraction(size.getWidth(), size.getHeight()).equals(previewRatio)) {
                                selectedSize = size;
                                break;
                            }
                        }

                        if (selectedSize == null) {
                            result.success(false);
                            return;
                        }
                        this.previewRatio = previewRatio;

                        CloseCamera();

                        setupCamera();

                        result.success(true);
                    } else {
                        result.success(false);
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                    result.success(false);
                }

                break;
            }
            case "captureImage":
                Integer maxSize = null;

                if (methodCall.arguments instanceof HashMap) {
                    @SuppressWarnings({"unchecked"})
                    Map<String, Object> params = (Map<String, Object>) methodCall.arguments;
                    maxSize = params.get("maxSize") == null ? null : (Integer) params.get("maxSize");
                }

                if (maxSize != null) {
                    this.maxSize = maxSize;
                }

                captureImage();

                result.success(true);
                break;
            case "switchCamera":
                if (cameraFacing == 0) {
                    cameraFacing = 1;
                } else {
                    cameraFacing = 0;
                }

                CloseCamera();

                setupCamera();
                result.success(true);
                break;
                /*
            case "getPictureSizes": {
                List<String> pictureSizes = new ArrayList<>();
                CameraManager cameraManager = (CameraManager) context.getSystemService(Context.CAMERA_SERVICE);
                try {
                    CameraCharacteristics characteristics = cameraManager.getCameraCharacteristics(camera22.getId());
                    StreamConfigurationMap map = null;
                    Size imageSizes[] = null;
                    if (characteristics != null) {
                        map = characteristics.get(CameraCharacteristics.SCALER_STREAM_CONFIGURATION_MAP);
                        imageSizes = map.getOutputSizes(defaultImageFormat); // YUV_420_888 包含 nv12/nv21


                        //List<Camera.Size> sizes = param.getSupportedPictureSizes();
                        for (Size size : imageSizes) {
                            pictureSizes.add(size.getWidth() + ":" + size.getHeight());
                        }
                        result.success(pictureSizes);
                    } else {
                        pictureSizes.add("0:0");
                        result.success(pictureSizes);
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                    result.success(false);
                }


                break;
            }

                 */
            case "setPhotoFeedBack":
            {
                if (methodCall.arguments instanceof HashMap) {
                    @SuppressWarnings({"unchecked"})
                    Map<String, Integer> params = (Map<String, Integer>) methodCall.arguments;
                    Integer needRecording = params.get("feedBack");
                    MainActivity.tis.needRecording = needRecording;
                }
                    
            }
            result.success(true);
            break;
            case "setCameraViewSize": {
                double pictureWidth = 0;
                double pictureHeight = 0;
                String error = "";

                if (methodCall.arguments instanceof HashMap) {
                    @SuppressWarnings({"unchecked"})
                    Map<String, Object> params = (Map<String, Object>) methodCall.arguments;
                    pictureWidth = (double) params.get("cameraWidth");
                    pictureHeight = (double) params.get("cameraHeight");
                    //CloseCamera();
                    int width = mySurfaceView.getWidth();
                    int height = mySurfaceView.getHeight();
                    int useWidth = width;
                    int useHeight = (int) (width / pictureWidth * pictureHeight);
                    //needPreview = true;
                    mySurfaceView.getHolder().setFixedSize((int) useWidth, (int) useHeight);
                    //surfaceChanged will setupCamera();
                }
                result.success(true);
                break;
            }

            case "setPictureSize": {
                int pictureWidth = 0;
                int pictureHeight = 0;
                String error = "";

                if (methodCall.arguments instanceof HashMap) {
                    @SuppressWarnings({"unchecked"})
                    Map<String, Object> params = (Map<String, Object>) methodCall.arguments;
                    pictureWidth = (int) params.get("pictureWidth");
                    pictureHeight = (int) params.get("pictureHeight");
                }


                CloseCamera();


                setupCamera();

                if (error.isEmpty()) {
                    result.success(true);
                } else {
                    result.error("Camera Error", "setPictureSize", error);
                }
                break;
            }
            case "setSavePath":
                if (methodCall.arguments instanceof HashMap) {
                    @SuppressWarnings({"unchecked"})
                    Map<String, Object> params = (Map<String, Object>) methodCall.arguments;
                    this.savePath = params.get("savePath") == null ? null : params.get("savePath").toString();
                }

                folder = new File(this.savePath);

                if (!folder.exists()) {
                    folder.mkdirs();
                }

                result.success(true);
                break;
            case "getFlashType": {
                //Camera.Parameters param = camera22.getParameters();
                //result.success(param.getSupportedFlashModes());
                result.success(true);
                break;
            }
            case "setFlashType": {
                String flashType = "autoFlash";

                if (methodCall.arguments instanceof HashMap) {
                    @SuppressWarnings({"unchecked"})
                    Map<String, Object> params = (Map<String, Object>) methodCall.arguments;
                    flashType = params.get("flashType") == null ? "autoFlash" : params.get("flashType").toString();
                }


                CloseCamera();

                setupCamera();

                result.success(true);
                break;
            }
            case "setFocus": {
                result.success(true);
                break;
            }
        }
    }


    @Override
    public View getView() {

        return view2;
    }

    @Override
    public void dispose() {
        if (disposed) {
            return;
        }
        disposed = true;
        deactivateOCR();
        MainActivity.methodChannelFlutter.invokeMethod("channel_closed",null);
        // case "deactivateOCR": //2022/12/31 發現 有邏輯問題， 通知關掉camera導致 channel 被關閉而無法完成deactivateOCR這個呼叫程序。
        //這裡不可以呼叫：  MainActivity.methodChannelFlutter.setMethodCallHandler(null);

        activity.getSupportFragmentManager().beginTransaction().remove(cameraFragment).commit();
        // }
    }


    HandlerThread mBackgroundThread;
    Handler mBackgroundHandler;

    CameraCaptureSession mCameraCaptureSession;

    int nv_width = 0; // nv21 pixelstrike width
    int image_width = 0; //image採橫向座標 1280 * 720
    int image_height = 0;
    int scan_x = 0; // scan 採直向座標, 720 * 1280
    int scan_y = 0;
    int scan_width = 0;
    int scan_height = 0;
    ImageReader myImgReader; // ImageFormat.YUV_420_888,


    private Handler startBackgroundThread() {
        mBackgroundThread = new HandlerThread("CameraBackground");
        mBackgroundThread.start();
        mBackgroundHandler = new Handler(mBackgroundThread.getLooper());
        return mBackgroundHandler;
    }

    private void stopBackgroundThread() {
        mBackgroundThread.quitSafely();
        try {
            mBackgroundThread.join();
            mBackgroundThread = null;
            mBackgroundHandler = null;
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    private boolean isMeteringAreaAFSupported() {
        CameraManager cameraManager = (CameraManager) context.getSystemService(Context.CAMERA_SERVICE);
        try {
            CameraCharacteristics characteristics = cameraManager.getCameraCharacteristics(camera22.getId());
            return characteristics.get(CameraCharacteristics.CONTROL_MAX_REGIONS_AF) >= 1;
        } catch (Exception e) {
            e.printStackTrace();
            return false;
        }

    }

    private void CloseCamera() {
        if (camera22 != null) {
            try {
                mCameraCaptureSession.stopRepeating();
                camera22.close();
                camera22 = null;
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    void DoNV21(Image image) {
        Image.Plane[] planes = image.getPlanes();
        if ((nv21data == null)) {
            //比較快
            ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
            WritableByteChannel channel = Channels.newChannel(outputStream);
            String headText =  // 加了space是為了跟c++ sscanf 匹配。
                    " " +
                            Integer.toString(planes[0].getRowStride()) + " " +
                            Integer.toString(image_height) + " " +
                            Integer.toString(planes[0].getBuffer().limit()) + " " +
                            Integer.toString(planes[1].getPixelStride()) + " " +
                            Integer.toString(planes[1].getBuffer().limit()) + " " +
                            Integer.toString(planes[2].getPixelStride()) + " " +
                            Integer.toString(planes[2].getBuffer().limit()) + " ";


            ByteBuffer bytes = ByteBuffer.wrap(headText.getBytes(Charset.defaultCharset()));
            byte lens = (byte) bytes.limit();
            bytes.put(0, lens);
            try {
                channel.write(bytes);
                channel.write(planes[0].getBuffer());
                channel.write(planes[1].getBuffer());
                channel.write(planes[2].getBuffer());
                channel.close();
                outputStream.close();
            } catch (Exception e) {
                e.printStackTrace();
            }
            nv_width = planes[0].getRowStride(); // 真正的 pixelWidth 必須以 nv21 為準。
            int nv_width2 = planes[2].getRowStride();


            double startTime = System.currentTimeMillis();
            if (true) {

                nv21data = outputStream.toByteArray().clone();

            } else {

            }
            double gap = System.currentTimeMillis() - startTime;

        }
    }

    String pixel_sync = "pixel_sync";

    void ShowPreviewAndReadyToDoOCR(Image image, boolean useBitmapPixel, int threadIndex) {

        {
            Bitmap myBitmap = null;
            long startTime = System.currentTimeMillis();
            if (image.getFormat() == ImageFormat.YUV_420_888) {

                final ByteBuffer yuvBytes = imageToByteBuffer(image);
                // Convert YUV to RGB
                final RenderScript rScript = RenderScript.create(activity); //android 多工模式解壓縮
                myBitmap = Bitmap.createBitmap(image.getWidth(), image.getHeight(), Bitmap.Config.ARGB_8888);
                final Allocation allocationRgb = Allocation.createFromBitmap(rScript, myBitmap);
                final Allocation allocationYuv = Allocation.createSized(rScript, Element.U8(rScript), yuvBytes.array().length);
                allocationYuv.copyFrom(yuvBytes.array());
                ScriptIntrinsicYuvToRGB scriptYuvToRgb = ScriptIntrinsicYuvToRGB.create(rScript, Element.U8_4(rScript));
                scriptYuvToRgb.setInput(allocationYuv);
                scriptYuvToRgb.forEach(allocationRgb);
                allocationRgb.copyTo(myBitmap);
                allocationYuv.destroy();
                allocationRgb.destroy();
                rScript.destroy();
            } else if (image.getFormat() == ImageFormat.JPEG) {

                final Image.Plane[] planes = image.getPlanes();
                final ByteBuffer buffer = planes[0].getBuffer(); //2021/05/14，不明原因  GetYUVPlaneInfo: Invalid format passed: 0x21

                int size = buffer.remaining();
                byte[] bbuff = new byte[size];
                buffer.get(bbuff);
                myBitmap = BitmapFactory.decodeByteArray(bbuff, 0, size);

            }
            long gap = System.currentTimeMillis() - startTime;
            // printf("RenderScript: " + Long.toString(gap));
            startTime = System.currentTimeMillis();
            // rotate  crop
            Matrix matrix = new Matrix();
            matrix.postRotate(90); //rotate 90
            Bitmap rotatedBitmap2 = Bitmap.createBitmap(myBitmap, 0, 0, myBitmap.getWidth(), myBitmap.getHeight(), matrix, true);
            // gap = System.currentTimeMillis() - startTime;
            //  printf( "rotatedBitmap2: " + Long.toString(gap));
            // startTime = System.currentTimeMillis();

            Bitmap cropBits = Bitmap.createBitmap(rotatedBitmap2, scan_x, scan_y, scan_width, scan_height);
            //  gap = System.currentTimeMillis() - startTime;
            //  Log.d("ansun", "cropBits: " + Long.toString(gap));
            // startTime = System.currentTimeMillis();
            int buffs[] = new int[scan_width * scan_height];
            cropBits.getPixels(buffs, 0, scan_width, 0, 0, scan_width, scan_height);
            if (useBitmapPixel && (ocrPixelBufferPending == null)) {

                // synchronized (pixel_sync) //
                // {
                //採用bitmap pixel buffer 可以節省 在 ndk 解開 nv21 格式的時間。
                //Log.d("ansun", "ShowPreview: set pixelBuffer " + Integer.toString(threadIndex));
                ocrPixelBufferPending = buffs; // prepare to DoOCR
                // }
            } else {
                //Log.d("ansun", "bitmapPixelBuffer_fromDisplayUI:   skip");
            }
            // gap = System.currentTimeMillis() - startTime;
            //  Log.d("ansun", "synchronized: " + Long.toString(gap));
            // startTime = System.currentTimeMillis();
            //  Bitmap scaledBitmap = Bitmap.createScaledBitmap(cropBits, (int)preview_width, (int)preview_height, true);
            //activity.runOnUiThread(new Runnable() // 這裡使用  runOnUiThread 變更慢。
            //synchronized (drawThread)
            //{

            // draw ruler to cropBits

            if (DrawCanvasDirect) {
                //synchronized (canvasLocked) {
                    if (canvasLocked == 0) { //避免太多thread都來 lockCanvas 導致全部都在等待，反而出現畫面 lag 卡頓。

                        DrawToCanvas(cropBits);
                    }
               // }
                cropBits.recycle();
                cropBits = null;
                //Log.d("ansun", "DrawToCanvas: ");
            } else {
                synchronized (DrawCanvasDirect) {
                    if (drawPending != null) {
                        drawPending.recycle();
                        drawPending = null;
                    }
                    if (drawPending == null) {
                        drawPending = cropBits;
                        //mySurfaceView.postInvalidate();
                    } else {
                        cropBits.recycle();
                        cropBits = null;
                        //Log.d("ansun", "drawPending:   skip");
                    }
                }
            }
            //}
            rotatedBitmap2.recycle();
            myBitmap.recycle();
            // gap = System.currentTimeMillis() - startTime;
            // Log.d("ansun", "recycle: " + Long.toString(gap));
            //  startTime = System.currentTimeMillis();
        }

    }


    void ProcessImage(Image image, int threadIndex) {
        //Log.d("ansun", "ProcessImage: ");
        try {
            double cameraWidth = image_height;//螢幕與鏡頭不同方向
            double cameraHeight = image_width;//螢幕與鏡頭不同方向
            double ratio_preview = preview_width / preview_height;
            double ratio_camera = cameraWidth / cameraHeight;
            if (ratio_preview > ratio_camera) {
                scan_width = (int) cameraWidth;
                scan_height = (int) (cameraWidth / ratio_preview);
            } else {
                scan_height = (int) cameraHeight;
                scan_width = (int) (cameraHeight * ratio_preview);
            }
            scan_x = (int) (cameraWidth - scan_width) / 2;
            scan_y = (int) (cameraHeight - scan_height) / 2;

            boolean useNv21 = false; //在 ndk 解壓縮nv21 比較慢


            boolean useBitmapPixel = !useNv21;
            if (defaultImageFormat == ImageFormat.JPEG) {
                useNv21 = false;
            }
            switch (defaultImageFormat) {

                case ImageFormat.YUV_420_888:

                    if (useNv21) {

                        DoNV21(image);
                    }
            }
            if (ocrPixelBufferPending == null || drawPending == null)
            //if (true)
            { // convert yuv_420_888 to bitmap and show it in SurfaceView

                ShowPreviewAndReadyToDoOCR(image, useBitmapPixel, threadIndex); //順便顯示並且存了一份給 OCR.
            }


        } catch (Exception e) {
            e.printStackTrace();
        }

    }
    long countPhotos = 0;
    long photoStartTime = System.currentTimeMillis();
    long printcount = 0;
    void ImageAvailable(ImageReader reader) {
        //System.out.println("image available");
        int format = reader.getImageFormat();
        try {

            Image image = reader.acquireLatestImage();

            if (image != null) {

                imageBusy++;
                //synchronized (imageTask)
                {
                    if (imagePending == null) {
                        imagePending = image;

/*
                        countPhotos++;
                        long average =  1000* countPhotos / (System.currentTimeMillis() - photoStartTime);
                        if (printcount++ > 60) {
                            printf("average photos per seconds " + average);
                            printcount = 0;
                        }

 */

                    } else {
                        image.close();
                        imageBusy--;
                        //Log.d("ansun", "ImageAvailable: closed and skip");
                    }
                }
            }
            while (maxImages - imageBusy == 0) {
                Thread.sleep(1); //imageReader image buffer 用完就會當機，所以需要等待恢復。
            }
        } catch (Exception e) {
            e.printStackTrace();
        }


    }

    private ByteBuffer imageToByteBuffer(final Image image) {
        final Rect crop = image.getCropRect();
        final int width = crop.width();
        final int height = crop.height();

        final Image.Plane[] planes = image.getPlanes();
        final byte[] rowData = new byte[planes[0].getRowStride()];
        final int bufferSize = width * height * ImageFormat.getBitsPerPixel(ImageFormat.YUV_420_888) / 8;
        final ByteBuffer output = ByteBuffer.allocateDirect(bufferSize);

        int channelOffset = 0;
        int outputStride = 0;

        for (int planeIndex = 0; planeIndex < 3; planeIndex++) {
            if (planeIndex == 0) {
                channelOffset = 0;
                outputStride = 1;
            } else if (planeIndex == 1) {
                channelOffset = width * height + 1;
                outputStride = 2;
            } else if (planeIndex == 2) {
                channelOffset = width * height;
                outputStride = 2;
            }

            final ByteBuffer buffer = planes[planeIndex].getBuffer();
            final int rowStride = planes[planeIndex].getRowStride();
            final int pixelStride = planes[planeIndex].getPixelStride();

            final int shift = (planeIndex == 0) ? 0 : 1;
            final int widthShifted = width >> shift;
            final int heightShifted = height >> shift;

            buffer.position(rowStride * (crop.top >> shift) + pixelStride * (crop.left >> shift));

            for (int row = 0; row < heightShifted; row++) {
                final int length;

                if (pixelStride == 1 && outputStride == 1) {
                    length = widthShifted;
                    buffer.get(output.array(), channelOffset, length);
                    channelOffset += length;
                } else {
                    length = (widthShifted - 1) * pixelStride + 1;
                    buffer.get(rowData, 0, length);

                    for (int col = 0; col < widthShifted; col++) {
                        output.array()[channelOffset] = rowData[col * pixelStride];
                        channelOffset += outputStride;
                    }
                }

                if (row < heightShifted - 1) {
                    buffer.position(buffer.position() + rowStride - length);
                }
            }
        }

        return output;
    }

    //boolean once = true;
    int maxImages = 4; // if > 1 在比較舊的 android 可能造成畫面延遲 (例如:htc d830x api-22)  。
    int imageBusy = 0;

    Timer delayVisor = null;


    void PrepareImageReader() {

        int version = android.os.Build.VERSION.SDK_INT;
        if (version >= 28) {
            maxImages = 8;
        }
        //maxImages = 3;
        try {
            /*
            if (useFormat == 1) {
                delayVisor = new Timer();
                delayVisor.schedule(new TimerTask() {
                    @Override
                    public void run() {

                        delayVisor.cancel();
                        delayVisor = null;
                        useFormat = 2;

                        activity.runOnUiThread(new Runnable() {
                            @Override
                            public void run() {
                                CloseCamera();
                                setupCamera();
                            }
                        });

                    }
                }, 5 * 1000, 1000);
            }
            */

            myImgReader = ImageReader.newInstance(image_width, image_height,

                    defaultImageFormat,//  ImageFormat.YUV_420_888,
                    maxImages);

            myImgReader.setOnImageAvailableListener(new ImageReader.OnImageAvailableListener() {

                @Override
                public void onImageAvailable(ImageReader reader) {
                    //if (delayVisor != null) {
                    //    delayVisor.cancel();
                    //    delayVisor = null;
                   // }
                    ImageAvailable(reader);
                }


            }, new Handler());
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    //Surface myImgReaderSurface = null;
    private void startPreview(boolean checkSize) {

        try {
            List<Surface> myList;
            if (usePreview) {
                myList = Arrays.asList(
                        mySurfaceView.getHolder().getSurface()
                        ,
                        myImgReader.getSurface()
                );
            } else {
                myList = Arrays.asList(
                        //mySurfaceView.getHolder().getSurface()
                        //,
                        myImgReader.getSurface()
                );
            }

            camera22.createCaptureSession(myList, //api-21
                    new CameraCaptureSession.StateCallback() {

                        @Override
                        public void onConfigured(@NonNull CameraCaptureSession session) {
                            mCameraCaptureSession = session;


                            //攝像頭已經準備好，開始顯示預覽
                            boolean result = ResetAuto(zoomScaler, 0, 0,true,false);


                            if (waitForCameraObject != null) {
                                activity.runOnUiThread(new Runnable() {
                                    @Override
                                    public void run() {
                                        waitForCameraObject.notifyCameraSet(result);

                                        waitForCameraObject = null;
                                    }
                                });

                            }

                        }

                        @Override
                        public void onConfigureFailed(@NonNull CameraCaptureSession session) {

                            Log.e("Camera2", "相機預覽失敗");
                            if (waitForCameraObject != null) {
                                activity.runOnUiThread(new Runnable() {
                                    @Override
                                    public void run() {
                                        waitForCameraObject.notifyCameraSet(false);

                                        waitForCameraObject = null;
                                    }
                                });

                            }
                        }
                    },
                    mBackgroundHandler);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    int useFormat = 0;

    CameraDevice.StateCallback cameraCallBack = new CameraDevice.StateCallback() {

        Size FindSize(Size[] imageSizes, int width, int height) { //數字越大則越慢，但可辨識範圍與解析度都會更好。
            int request = width * height;
            Size matchSize = imageSizes[0];
            int maxDelta = 1000000;

            for (Size theSize : imageSizes) {
                int value = theSize.getWidth() * theSize.getHeight();
                int myDelta = (value - request);
                if (myDelta < 0) {
                    myDelta = -myDelta;
                }
                if (myDelta < maxDelta) {
                    maxDelta = myDelta;
                    matchSize = theSize;
                }
            }
            return matchSize;
        }

        @Override
        public void onOpened(@NonNull CameraDevice camera0) {
            camera22 = camera0;
            try {

                printf( "Camera onOpened: ");
                String cid = camera22.getId();
                CameraManager cameraManager = (CameraManager) context.getSystemService(Context.CAMERA_SERVICE);
                CameraCharacteristics characteristics = cameraManager.getCameraCharacteristics(cid);
                Size[] imageSizes = null;
                StreamConfigurationMap map = null;
                Size matchSize = null;
                if (characteristics != null) {
                    int deviceLevel = characteristics.get(CameraCharacteristics.INFO_SUPPORTED_HARDWARE_LEVEL);
                    if (deviceLevel == CameraCharacteristics.INFO_SUPPORTED_HARDWARE_LEVEL_3) {
                        useFormat = 1; //YUV_420_888 //android 宣稱全系列支援 YUV_420_888，但某些舊機並沒有。

                    } else {
                        useFormat = 2; //JPEG
                    }
useFormat = 1;
                    map = characteristics.get(CameraCharacteristics.SCALER_STREAM_CONFIGURATION_MAP);
                    int format[] = map.getOutputFormats();
                    if (useFormat == 0) {
                        useFormat = 1;
                        if (ContainFormat(format, ImageFormat.YUV_420_888)) {
                            //samsung i9300 will not work for YUV_420_888
                            //but htc may not work for JPEG
                            defaultImageFormat = ImageFormat.YUV_420_888; // YUV_420_888 包含 nv12/nv21
                        } else {
                            useFormat = 2;
                            boolean can_use_jpg = ContainFormat(format, ImageFormat.JPEG);
                            if (can_use_jpg) {
                                defaultImageFormat = ImageFormat.JPEG;
                            } else if (ContainFormat(format, ImageFormat.YUV_420_888)) {
                                //samsung i9300 will not work for YUV_420_888
                                //but htc may not work for JPEG
                                useFormat = 1;
                                defaultImageFormat = ImageFormat.YUV_420_888; // YUV_420_888 包含 nv12/nv21
                            }
                        }
                    } else {
                        if (useFormat == 1) {
                            defaultImageFormat = ImageFormat.YUV_420_888; // YUV_420_888 包含 nv12/nv21
                        } else {
                            //if (useFormat == 2) {
                            //    defaultImageFormat = ImageFormat.JPEG;
                            //}
                            if (ContainFormat(format, ImageFormat.JPEG)) {
                                useFormat = 2;
                                defaultImageFormat = ImageFormat.JPEG;
                            } else if (ContainFormat(format, ImageFormat.YUV_420_888)) {
                                //samsung i9300 will not work for YUV_420_888
                                //but htc may not work for JPEG
                                useFormat = 1;
                                defaultImageFormat = ImageFormat.YUV_420_888; // YUV_420_888 包含 nv12/nv21
                            }
                        }

                    }

                    imageSizes = map.getOutputSizes(
                            //   ImageFormat.JPEG
                            defaultImageFormat //  ImageFormat.YUV_420_888
                    ); // YUV_420_888 包含 nv12/nv21

                }

                if (imageSizes != null && (imageSizes.length > 0)) {

                    ArrayList<Size> sizes = new ArrayList();
                    for (Size item:imageSizes) { //太大的照片會當機
                        if ((item.getWidth() <= 1280) && (item.getHeight() <= 1280)) {
                            sizes.add(item);
                        }
                    }
                    int selectPhoto = (int)((sizes.size()-1) * scanArea);
                    Size photoSize =  sizes.get(selectPhoto);
                    matchSize = FindSize(imageSizes, 1280, 720); //發行版本只用此解析度
                    //matchSize = FindSize(imageSizes, photoSize.getWidth(), photoSize.getHeight()); //debug 版本，數字越大則越慢，但可辨識範圍與解析度都會更好。
                    image_width = matchSize.getWidth();
                    image_height = matchSize.getHeight();
                }
                PrepareImageReader();
                startPreview(true);
            } catch (Exception e) {
                e.printStackTrace();
                image_width = 640;
                image_height = 480;
            }


        }

        @Override
        public void onDisconnected(@NonNull CameraDevice camera) {
            printf( "cameraManager.openCamera: onDisconnected");
        }

        private String getErrorDescription(int errorCode) {
            switch (errorCode) {
                case CameraDevice.StateCallback.ERROR_CAMERA_DEVICE: // 4
                    return "Camera device has encountered a fatal error.";
                case CameraDevice.StateCallback.ERROR_CAMERA_DISABLED:
                    return "Camera device could not be opened due to a device policy.";
                case CameraDevice.StateCallback.ERROR_CAMERA_IN_USE:
                    return "Camera device is in use already.";
                case CameraDevice.StateCallback.ERROR_CAMERA_SERVICE:
                    return "Camera service has encountered a fatal error.";
                case CameraDevice.StateCallback.ERROR_MAX_CAMERAS_IN_USE:
                    return "Camera device could not be opened because"
                            + " there are too many other open camera devices.";
                default:
                    return "Unknown camera error: " + errorCode;
            }
        }

        @Override
        public void onError(@NonNull CameraDevice camera, int error) {
            //CameraDevice.StateCallback.ERROR_CAMERA_DEVICE = 4
            if (camera22 != null) {
                CloseCamera();
            }
            camera22 = null;
            //boolean done = false;
            //if (error == 4) {
                //if (useFormat == 1) {
                 //   useFormat = 2;
                 //   done = true;
                 //   OpenCamera();
                //}
           // }
            //if (! done) {
            printf( "cameraManager.openCamera: onError " + getErrorDescription(error));
            Toast.makeText(activity, "相機無法開啟，請讓手機睡眠後再喚醒", Toast.LENGTH_LONG).show();
           // }
        }
    };

    void OpenCamera() {
        CameraManager cameraManager = (CameraManager) context.getSystemService(Context.CAMERA_SERVICE);
        try {
            // Log.d("ansun", "cameraManager.openCamera: 1");
            cameraManager.openCamera(Integer.toString(cameraFacing), cameraCallBack, new Handler());
            // Log.d("ansun", "cameraManager.openCamera: 2");
        } catch (Exception e) {
            printf( "cameraManager.openCamera: Exception");
            e.printStackTrace();
        }
    }

    private void setupCamera() {
        // Log.d("ansun", "setupCamera: ");
        MainActivity.channelResult = null;
        int version = android.os.Build.VERSION.SDK_INT;
        //宣育 htc api-22
        //Peterson htc api-24
        //ansun 小米cc9 api-30
        //云霏的姊  oppo cph1831  api-29
        //samsung i9300 更新到 api-25 以後，無法正確使用 ImageReader ImageFormat.YUV_420_888,但可以使用 ImageFormat.JPEG,原因不明。
        if (android.os.Build.VERSION.SDK_INT >= 23) {


            if (activity.checkSelfPermission(Manifest.permission.CAMERA) != PackageManager.PERMISSION_GRANTED) {
                activity.requestPermissions(
                        new String[]{
                                Manifest.permission.CAMERA,
                                Manifest.permission.WRITE_EXTERNAL_STORAGE,
                                Manifest.permission.READ_EXTERNAL_STORAGE,
                              //  Manifest.permission.ACCESS_FINE_LOCATION
                        },
                        MainActivity.RequestCodeForCameraPermission
                );
                return;  // onResume will call setupCamera() again

            }
/*
            if (activity.checkSelfPermission(Manifest.permission.ACCESS_FINE_LOCATION) != PackageManager.PERMISSION_GRANTED) {
                activity.requestPermissions(
                        new String[]{

                                Manifest.permission.ACCESS_FINE_LOCATION
                        },
                        MainActivity.RequestCodeForCameraPermission
                );
                return; // onResume will call setupCamera() again
            }

 */

        }
        try {
            printf( "startBackgroundThread ");

            startBackgroundThread();
            CameraManager cameraManager = (CameraManager) context.getSystemService(Context.CAMERA_SERVICE);
            if (android.os.Build.VERSION.SDK_INT >= 28) {
                cameraManager.registerTorchCallback(new CameraManager.TorchCallback() {
                    @Override
                    public void onTorchModeUnavailable(@NonNull String cameraId) {
                        super.onTorchModeUnavailable(cameraId);
                    }

                    @Override
                    public void onTorchModeChanged(@NonNull String cameraId, boolean enabled) {
                        super.onTorchModeChanged(cameraId, enabled);
                    }
                }, mBackgroundHandler);
            }
            printf( "OpenCamera ");


            OpenCamera();

        } catch (Exception e) {
            e.printStackTrace();
            return;
        }

    }


    public String translateFlashType(List<String> supportedModes) {
        String result = this.flashType;

        if (cameraFacing == 1) {
            if (!this.flashType.equals("off")) {
                result = "on";
            }
        }

        if (supportedModes != null && !supportedModes.contains(result)) {
            if (supportedModes.size() > 0) {
                result = supportedModes.get(0);
            } else {
                result = "";
            }
        } else {
            result = "off";
        }

        return result;
    }

    private int setCameraDisplayOrientation(int cameraId) {
        //Camera.CameraInfo info = new Camera.CameraInfo();
        //Camera.getCameraInfo(cameraId, info);

        int rotation = activity.getWindowManager().getDefaultDisplay().getRotation();

        if (Build.MODEL.equalsIgnoreCase("Nexus 6") && cameraFacing == 1) {
            rotation = Surface.ROTATION_180;
        }

        int degrees = 0;
        switch (rotation) {

            case Surface.ROTATION_0:
                degrees = 0;
                break;
            case Surface.ROTATION_90:
                degrees = 90;
                break;
            case Surface.ROTATION_180:
                degrees = 180;
                break;
            case Surface.ROTATION_270:
                degrees = 270;
                break;
        }

        int result = 0;

        //if (info.facing == Camera.CameraInfo.CAMERA_FACING_FRONT) {

        //    result = (info.orientation + degrees) % 360;
        //    result = (360 - result) % 360; // compensate the mirror

        //} else {
        //    result = (info.orientation - degrees + 360) % 360;

        //}

        //camera22.setDisplayOrientation(result);

        return result;

    }

    private void refreshCamera() {
        if (imgSurfaceHolder.getSurface() == null) {
            return;
        }
        if (camera22 != null) {
            CloseCamera();
            setupCamera();
        }
    }


    private void cancelSavePicTaskIfNeed() {
        if (savePicTask != null && savePicTask.getStatus() == AsyncTask.Status.RUNNING) {
            savePicTask.cancel(true);
        }
    }

    @SuppressLint("StaticFieldLeak")
    private class SavePicTask extends AsyncTask<Void, Void, String> {
        private final byte[] data;
        private final int rotation;

        SavePicTask(byte[] data, int rotation) {
            this.data = data;
            this.rotation = rotation;
        }

        protected void onPreExecute() {

        }

        @Override
        protected String doInBackground(Void... params) {
            try {
                return saveToSDCard(data, rotation);
            } catch (Exception e) {
                e.printStackTrace();
                return null;
            }
        }

        @Override
        protected void onPostExecute(String result) {
            //  Map<String, Object> params = new HashMap<>();
            //  params.put("path", result);
            //  MainActivity.methodChannelFlutter.invokeMethod("onImageCaptured", params);

            //  refreshCamera();

        }
    }

    private String saveToSDCard(byte[] data, int rotation) {
        String imagePath = "";

        try {
            final BitmapFactory.Options options = new BitmapFactory.Options();
            options.inJustDecodeBounds = true;
            BitmapFactory.decodeByteArray(data, 0, data.length, options);

            DisplayMetrics metrics = new DisplayMetrics();
            activity.getWindowManager().getDefaultDisplay().getMetrics(metrics);

            int reqHeight = metrics.heightPixels;
            int reqWidth = metrics.widthPixels;
            // Fix for exporting image with correct resolution in landscape mode
            if (reqWidth > reqHeight) {
                reqHeight = metrics.widthPixels;
                reqWidth = metrics.heightPixels;
            }

//            // Fix for exporting image with correct resolution in landscape mode
//            if(reqWidth > reqHeight){
//                reqHeight = metrics.widthPixels;
//                reqWidth = metrics.heightPixels;
//            }

            options.inSampleSize = calculateInSampleSize(options, reqWidth, reqHeight);

            options.inJustDecodeBounds = false;
            Bitmap bitmap = BitmapFactory.decodeByteArray(data, 0, data.length, options);

            if (Build.MODEL.equalsIgnoreCase("LGM-G600L")) {
                //for now there's a case for LGM-G600L phone that its rotation degree exceeded by 90
                rotation -= 90;
            }

            if (maxSize != null) {
                double initialWidth = bitmap.getWidth();
                double initialHeight = bitmap.getHeight();
                int width = initialHeight < initialWidth ? maxSize : (int) (initialWidth / initialHeight * maxSize);
                int height = initialWidth <= initialHeight ? maxSize : (int) (initialHeight / initialWidth * maxSize);

                bitmap = Bitmap.createScaledBitmap(bitmap, width,
                        height, true);
            }

            if (rotation != 0) {
                Matrix mat = new Matrix();
                mat.postRotate(rotation);

                Bitmap bitmap1 = Bitmap.createBitmap(bitmap, 0, 0, bitmap.getWidth(), bitmap.getHeight(), mat, true);
                if (bitmap != bitmap1) {
                    bitmap.recycle();
                }

                if (cameraFacing == 1) {
                    Matrix matrixMirror = new Matrix();
                    matrixMirror.preScale(-1.0f, 1.0f);
                    Bitmap mirroredBitmap = Bitmap.createBitmap(bitmap1, 0, 0, bitmap1.getWidth(), bitmap1.getHeight(), matrixMirror, true);

                    if (mirroredBitmap != bitmap1) {
                        bitmap1.recycle();
                    }

                    imagePath = getSavePhotoLocal(mirroredBitmap);

                    if (mirroredBitmap != null) {
                        mirroredBitmap.recycle();
                    }
                } else {
                    imagePath = getSavePhotoLocal(bitmap1);
                    if (bitmap1 != null) {
                        bitmap1.recycle();
                    }
                }
            } else {
                if (cameraFacing == 1) {
                    Matrix matrixMirror = new Matrix();
                    matrixMirror.preScale(-1.0f, 1.0f);
                    Bitmap mirroredBitmap = Bitmap.createBitmap(bitmap, 0, 0, bitmap.getWidth(), bitmap.getHeight(), matrixMirror, true);

                    if (mirroredBitmap != bitmap) {
                        bitmap.recycle();
                    }

                    imagePath = getSavePhotoLocal(mirroredBitmap);

                    if (mirroredBitmap != null) {
                        mirroredBitmap.recycle();
                    }
                } else {
                    imagePath = getSavePhotoLocal(bitmap);
                    if (bitmap != null) {
                        bitmap.recycle();
                    }
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return imagePath;
    }

    private int calculateInSampleSize(BitmapFactory.Options options, int reqWidth, int reqHeight) {
        final int height = options.outHeight;
        final int width = options.outWidth;
        int inSampleSize = 1;

        if (height > reqHeight || width > reqWidth) {
            if (width > height) {
                inSampleSize = Math.round((float) height / (float) reqHeight);
            } else {
                inSampleSize = Math.round((float) width / (float) reqWidth);
            }
        }
        return inSampleSize;
    }

    private String getSavePhotoLocal(Bitmap bitmap) {
        String path = "";
        Date currentTime = Calendar.getInstance().getTime();
        DateFormat dateFormat = new SimpleDateFormat("yyyyMMdd_HHmmss", Locale.getDefault());
        try {
            OutputStream output;
            File file = new File(folder.getAbsolutePath(), fileNamePrefix + "_" + dateFormat.format(currentTime) + ".jpg");
            try {
                output = new FileOutputStream(file);
                bitmap.compress(Bitmap.CompressFormat.JPEG, 100, output);
                output.flush();
                output.close();
                path = file.getAbsolutePath();
            } catch (Exception e) {
                e.printStackTrace();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return path;
    }

    private int getPhotoRotation() {
        int rotation = 0;
        int orientation = mPhotoAngle;

        //Camera.CameraInfo info = new Camera.CameraInfo();
        //if (cameraFacing == 0) {
        //    Camera.getCameraInfo(0, info);
        //} else {
        //    Camera.getCameraInfo(1, info);
        //}

        //if (info.facing == Camera.CameraInfo.CAMERA_FACING_FRONT) {
        //    rotation = (info.orientation - orientation + 360) % 360;
        //} else {
        //    rotation = (info.orientation + orientation) % 360;
        // }

        return rotation;
    }

    private void identifyOrientationEvents() {
        OrientationEventListener myOrientationEventListener = new OrientationEventListener(context, SensorManager.SENSOR_DELAY_NORMAL) {
            @Override
            public void onOrientationChanged(int iAngle) {
                final int[] iLookup = {0, 0, 0, 90, 90, 90, 90, 90, 90, 180, 180, 180, 180, 180, 180, 270, 270, 270, 270, 270, 270, 0, 0, 0}; // 15-degree increments
                if (iAngle != ORIENTATION_UNKNOWN) {
                    int iNewOrientation = iLookup[iAngle / 15];
                    if (iOrientation != iNewOrientation) {
                        iOrientation = iNewOrientation;
                    }
                    mPhotoAngle = normalize(iAngle);
                }
            }
        };

        if (myOrientationEventListener.canDetectOrientation()) {
            myOrientationEventListener.enable();
        }
    }

    private int normalize(int degrees) {
        if (degrees > 315 || degrees <= 45) {
            return 0;
        }

        if (degrees <= 135) {
            return 90;
        }

        if (degrees <= 225) {
            return 180;
        }

        return 270;
    }

    public Range<Float> getMaxZoom() {
        int version = android.os.Build.VERSION.SDK_INT;
        if (version < 30) {
            return null;
        }


        try {
            CameraManager cameraManager = (CameraManager) context.getSystemService(Context.CAMERA_SERVICE);
            CameraCharacteristics characteristics = cameraManager.getCameraCharacteristics(camera22.getId());
            Range<Float> result = characteristics.get(CameraCharacteristics.CONTROL_ZOOM_RATIO_RANGE);
            // LENS_INFO_MINIMUM_FOCUS_DISTANCE  LENS_INFO_HYPERFOCAL_DISTANCE
            return result;
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    boolean isHardwareLevelSupported(CameraCharacteristics c, int requiredLevel) {
        final int[] sortedHwLevels = {
                CameraCharacteristics.INFO_SUPPORTED_HARDWARE_LEVEL_LEGACY, // 2
                CameraCharacteristics.INFO_SUPPORTED_HARDWARE_LEVEL_EXTERNAL, // 4
                CameraCharacteristics.INFO_SUPPORTED_HARDWARE_LEVEL_LIMITED, // 0
                CameraCharacteristics.INFO_SUPPORTED_HARDWARE_LEVEL_FULL, // 1
                CameraCharacteristics.INFO_SUPPORTED_HARDWARE_LEVEL_3 //3
        };
        int deviceLevel = c.get(CameraCharacteristics.INFO_SUPPORTED_HARDWARE_LEVEL);
        if (requiredLevel == deviceLevel) {
            return true;
        }

        return false; // Should never reach here
    }


    //float zoomScaleFactor = 1;

    private void handleZoomPinch(MotionEvent event) {
        Range<Float> maxZoomRange = getMaxZoom();
        boolean doLegacy = false;
        if (maxZoomRange == null) {
            doLegacy = true;
            //return; //no zoom for old version of android
        } else {
            if (maxZoomRange.getLower() == maxZoomRange.getUpper()) {
                doLegacy = true;
            }
        }
        if (doLegacy) {
            float newDist = getFingerSpacing(event);
            if (Math.abs(newDist - mDist) < 2) return;
            try {
                CameraManager cameraManager = (CameraManager) context.getSystemService(Context.CAMERA_SERVICE);
                CameraCharacteristics characteristics = cameraManager.getCameraCharacteristics(camera22.getId());
                float maxZoom = (characteristics.get(CameraCharacteristics.SCALER_AVAILABLE_MAX_DIGITAL_ZOOM));
                Rect m = characteristics.get(CameraCharacteristics.SENSOR_INFO_ACTIVE_ARRAY_SIZE);
                float step = maxZoom / 120;
                if (newDist > mDist) {
                    zoomScaler += step;
                    if (zoomScaler > maxZoom) {
                        zoomScaler = maxZoom;
                        return;
                    }
                } else {
                    zoomScaler -= step;
                    if (zoomScaler < 0) {
                        zoomScaler = 0;
                        return;
                    }
                }

            } catch (Exception e) {
                e.printStackTrace();
            }
            mDist = newDist;
        } else {
            //光學變焦
            //version >= 30 android.R
            //float zoomFactorNow = mCaptureRequestBuilder.get(CaptureRequest.CONTROL_ZOOM_RATIO);
            float newDist = getFingerSpacing(event);

            if (Math.abs(newDist - mDist) < 2) return;

            if (newDist > mDist) {
                //zoom in
                zoomScaler += 0.005;
                if (zoomScaler > 1) {

                    zoomScaler = 1;
                }
            } else if (newDist < mDist) {
                //zoom out

                zoomScaler -= 0.005;
                if (zoomScaler < 0) {
                    zoomScaler = 0;
                }
            }
            mDist = newDist;

        }
        ResetAuto(zoomScaler,0,0,true,false);
    }


    private void handleZoomScaled(double newZoom, CaptureRequest.Builder mCaptureRequestBuilder) {
        Range<Float> maxZoomRange = getMaxZoom();
        boolean doLegacy = false;
        if (maxZoomRange == null) {
            doLegacy = true;
            //return; //no zoom for old version of android
        } else {
            if (maxZoomRange.getLower() == maxZoomRange.getUpper()) {
                doLegacy = true;
            }
        }
        if (doLegacy) {
            //float newDist = getFingerSpacing(event);
            //if (Math.abs(newDist - mDist) < 2) return;
            try {
                CameraManager cameraManager = (CameraManager) context.getSystemService(Context.CAMERA_SERVICE);
                CameraCharacteristics characteristics = cameraManager.getCameraCharacteristics(camera22.getId());
                float maxzoomUpper = (characteristics.get(CameraCharacteristics.SCALER_AVAILABLE_MAX_DIGITAL_ZOOM)) * 10;
                double zoomFactorNow = 1 + (maxzoomUpper - 1) * newZoom;
                Rect m = characteristics.get(CameraCharacteristics.SENSOR_INFO_ACTIVE_ARRAY_SIZE);

                //if (newDist > mDist) {
                //    zoomScaleFactor += 1;
                if (zoomFactorNow > maxzoomUpper) {
                    zoomFactorNow = maxzoomUpper;
                }
                //} else {
                //     zoomScaleFactor -= 1;
                if (zoomFactorNow < 1) {
                    zoomFactorNow = 1;
                }
                //}
                int minW = (int) (m.width() / maxzoomUpper);
                int minH = (int) (m.height() / maxzoomUpper);
                int difW = m.width() - minW;
                int difH = m.height() - minH;
                int cropW = difW / 100 * (int) zoomFactorNow;
                int cropH = difH / 100 * (int) zoomFactorNow;
                cropW -= cropW & 3;
                cropH -= cropH & 3;
                //無光學變焦，就採用數位放大 handleZoomScaled
                Rect zoomRect = new Rect(cropW, cropH, m.width() - cropW, m.height() - cropH);

                mCaptureRequestBuilder.set(CaptureRequest.SCALER_CROP_REGION, zoomRect);



            } catch (Exception e) {
                e.printStackTrace();
            }
            //mDist = newDist;

        } else {
            //光學變焦

            double zoomFactorNow = maxZoomRange.getLower() + (maxZoomRange.getUpper() - maxZoomRange.getLower()) * newZoom;


            //zoom in
            if (zoomFactorNow > maxZoomRange.getUpper()) {
                zoomFactorNow = maxZoomRange.getUpper();

            }

            //zoom out
            if (zoomFactorNow < maxZoomRange.getLower()) {
                zoomFactorNow = maxZoomRange.getLower();

            }

            mCaptureRequestBuilder.set(CaptureRequest.CONTROL_ZOOM_RATIO, (float) zoomFactorNow); //0.0f for infinity focus.

        }
        zoomScaler = newZoom;
    }

    private MeteringRectangle handleFocusBy1Touch(float screen_x, float screen_y) {

        final int rotation = activity.getWindowManager().getDefaultDisplay().getRotation();
        int surfaceHeight = mySurfaceView.getHeight();
        int surfaceWidth = mySurfaceView.getWidth();

        if (screen_x < focusRectSize) {
            screen_x = surfaceWidth / 2;

        }
        if (screen_y < focusRectSize) {
            screen_y = surfaceHeight / 2; //螢幕座標
        }

        /// normal
        float camera_x = screen_y;
        float camera_y = surfaceWidth - screen_x; // camera 座標

        if (rotation == Surface.ROTATION_90) {
            /// for this rotation, we have to swap upper right corner to bottom left corner
            /// the rest, bottom right and upper left, will still be the same
            /// rotate left
            final float xPercentage = screen_y / surfaceHeight;
            final float yPercentage = screen_x / surfaceWidth;
            final boolean condition = (xPercentage > .5) == (yPercentage > .5);
            camera_x = !condition ? (1 - xPercentage) * surfaceHeight : screen_y;
            camera_y = !condition ? (1 - yPercentage) * surfaceWidth : screen_x;
        } else if (rotation == Surface.ROTATION_270) {
            /// for this rotation, we have to swap upper left corner to bottom right corner
            /// the rest, bottom left and upper right, will still be the same
            /// rotate right
            final float xPercentage = screen_y / surfaceHeight;
            final float yPercentage = screen_x / surfaceWidth;
            final boolean condition = (xPercentage > .5) == (yPercentage > .5);
            camera_x = condition ? (1 - xPercentage) * surfaceHeight : screen_y;
            camera_y = condition ? (1 - yPercentage) * surfaceWidth : screen_x;
        }


        Rect touchRect = new Rect(
                (int) (camera_x - focusRectSize),
                (int) (camera_y - focusRectSize),
                (int) (camera_x + focusRectSize),
                (int) (camera_y + focusRectSize));

        final float RectLeft = screen_x - focusRectSize;
        final float RectTop = screen_y - focusRectSize;
        final float RectRight = screen_x + focusRectSize;
        final float RectBottom = screen_y + focusRectSize;

        setFocus(RectLeft, RectTop, RectRight, RectBottom, focusRectColor);
        MeteringRectangle focusAreaTouch = new MeteringRectangle(
                (int) RectLeft,//Math.max(x - halfTouchWidth,  0),
                (int) RectTop,//Math.max(y - halfTouchHeight, 0),
                (int) RectRight - (int) RectLeft,//halfTouchWidth  * 2,
                (int) RectBottom - (int) RectTop,//halfTouchHeight * 2,
                MeteringRectangle.METERING_WEIGHT_MAX - 1);

        if (isMeteringAreaAFSupported()) {

            return focusAreaTouch;
        }
        return null;
    }

    private float getFingerSpacing(MotionEvent event) {
        // ...
        float x = event.getX(0) - event.getX(1);
        float y = event.getY(0) - event.getY(1);
        return (float) Math.sqrt(x * x + y * y);
    }

    /**
     * @return the greatest common denominator
     */
    private static long gcm(long a, long b) {
        return b == 0 ? a : gcm(b, a % b); // Not bad for one line of code :)
    }

    private static String asFraction(long a, long b) {
        long gcm = gcm(a, b);
        return (a / gcm) + ":" + (b / gcm);
    }


    Canvas canvas;
    Paint paint;
    Canvas dismissCanvas;
    long lastId;

    private void setFocus(float RectLeft, float RectTop, float RectRight, float RectBottom, int color) {

        canvas = holderTransparent.lockCanvas();
        canvas.drawColor(0, PorterDuff.Mode.CLEAR);
        //border's properties
        paint = new Paint();
        paint.setStyle(Paint.Style.STROKE);
        paint.setColor(color);
        paint.setStrokeWidth(3);
        canvas.drawRect(RectLeft, RectTop, RectRight, RectBottom, paint);

        holderTransparent.unlockCanvasAndPost(canvas);

        final long id = System.currentTimeMillis();
        final DismissHandler handler = new DismissHandler();
        handler.id = id;
        lastId = id;

        handler.postDelayed(new Runnable() {
            @Override
            public void run() {
                if (handler.id == lastId) {
                    dismissCanvas = holderTransparent.lockCanvas();
                    if (dismissCanvas != null) {
                        dismissCanvas.drawColor(0, PorterDuff.Mode.CLEAR);
                        holderTransparent.unlockCanvasAndPost(dismissCanvas);
                    }
                }
            }
        }, 2000);
    }

    class MyPrepareImageThread {

        Thread threading;
        MyPrepareImageRunnable runnable;

        public MyPrepareImageThread(int threadIndex) {
            runnable = new MyPrepareImageRunnable(this, threadIndex);
            threading = new Thread(runnable);
            threading.start();
        }
    }

    ;
    String image_sync = "image_sync";
    int threadCounter = 0;

    class MyPrepareImageRunnable implements Runnable {
        MyPrepareImageThread owner;
        int threadIndex;

        public MyPrepareImageRunnable(MyPrepareImageThread threading, int threadIndex0) {
            owner = threading;
            threadIndex = threadIndex0;
        }

        @Override
        public void run() {
            synchronized (MainActivity.ocr_recognition) {
                threadCounter++;
            }
            //recognition thread runnable
            while (threadDeactovateToStop == false) {
                Image image = null;

                if (imagePending != null) {
                    synchronized (image_sync) {
                        image = imagePending;
                        imagePending = null;
                    }
                }
                if (image != null) {
                    long start = System.currentTimeMillis();
                    ProcessImage(image, threadIndex);
                    image.close();
                    imageBusy--;
                    long offset = System.currentTimeMillis() - start;
                    // Log.d("ansun", "ProcessImage: " + Long.toString(offset));
                }
                try {
                    Thread.sleep(1);
                } catch (Exception e) {

                    e.printStackTrace();
                    printf( "run: imagePending");
                }

            }
            synchronized (MainActivity.ocr_recognition) {
                threadCounter--;
            }
        }
    }

    String nv21_sync = "nv21";
    boolean suspendSetting = false;


    class MyOCRRunnable implements Runnable {
        MyOCRThread owner;
        int threadIndex;

        public MyOCRRunnable(MyOCRThread threading, int threadIndex0) {
            owner = threading;
            threadIndex = threadIndex0;
        }

        @Override
        public void run() {
            synchronized (MainActivity.ocr_recognition) {
                threadCounter++;
            }
            while (threadDeactovateToStop == false) {
                if (false) {
                    double deltaTime = System.currentTimeMillis() - lastOCRTimeMillis;
                    if (deltaTime < threadNeedDelayTimeGap) {
                        try {
                            //底層已經有c++ 多工，不需要太頻繁呼叫。
                            Thread.sleep(10); //sleep久一點可以避免c++吃掉太多cpu時間，拖垮預覽畫面的流暢度。
                        } catch (Exception e) {

                        }
                          continue;
                    }
                }
                if (suspendSetting) {
                    // if setSLider, suspend thread 可以讓UI操作比較順暢。
                    //Log.d("ansun", "run: suspend...");
                } else {
                    byte[] nv21 = null;
                    if (nv21data != null) {
                        synchronized (nv21_sync) {

                            nv21 = nv21data;
                            nv21data = null;
                        }
                    }
                    if (nv21 != null) {
                        //需要解壓縮nv21
                        runtask_nv21_ocr(nv21, threadIndex);

                    }

                    int prepareToOCR[] = null;
                    if (ocrPixelBufferPending != null) { //
                        synchronized (pixel_sync) {
                            lastOCRTimeMillis = System.currentTimeMillis();
                            //採用 pixelbuffer 比較快，因為不需要解壓縮nv21
                            prepareToOCR = ocrPixelBufferPending;
                            ocrPixelBufferPending = null;
                        }
                    }

                    if (prepareToOCR != null) {
                        if (false) {
                            countPhotos++;
                            long average = 1000 * countPhotos / (System.currentTimeMillis() - photoStartTime);
                            if (printcount++ > 60) {
                                printf("average photos per seconds " + average);
                                printcount = 0;
                            }

                        }
                        //Log.d("ansun", "run thread: " + Integer.toString(threadIndex));
                        // 2021/12/05 呼叫runtask_DoOCR的同時也會回傳 lpr bitmap 與 char1bitmap ,這內容如果太多，NativePixelBuffer就會很耗時。
                        runtask_DoOCR(prepareToOCR, threadIndex);
                    } else {
                        //Log.d("ansun", "skip thread: " + Integer.toString(threadIndex));
                    }
                }
                try {
                    //底層已經有c++ 多工，不需要太頻繁呼叫。
                    Thread.sleep(1); //sleep久一點可以避免c++吃掉太多cpu時間，拖垮預覽畫面的流暢度。
                } catch (Exception e) {

                }
            }
            synchronized (MainActivity.ocr_recognition) {
                threadCounter--;
            }
        }

        public void runtask_DoOCR(int[] pixels, int threadIndex) {
            // 2021/12/05 呼叫NativePixelBuffer的同時也會回傳 lpr bitmap 與 char1bitmap ,這內容如果太多，NativePixelBuffer就會很耗時。

            int width = image_width;//parameters.getPreviewSize().width;
            int height = image_height;//parameters.getPreviewSize().height;;
            String info_path = MainActivity.patternPath;

            codeResult = MainActivity.
                    ocr_recognition.NativePixelBuffer(
                    pixels,
                    scan_width,
                    scan_height,
                    grayDeltaThreshold,
                    threadIndex,
                    info_path,
                    activity.needRecording
            );

            if (codeResult > 0) {
                //modify date 2021/12/05 統計實際每秒鐘完成分析的照片個數，動態更新。
                owner.owner.jobsCapability =  codeResult;
                if (codeResult > 0) {
                    threadNeedDelayTimeGap = 1000 /  codeResult + 1;
                }

                matched_once = true;

            } else {

            }


            if(false) // (codeResult >= 0)
            {


                boolean beep = false;
                if (beep) {
                    ToneGenerator toneG = new ToneGenerator(AudioManager.STREAM_ALARM, 100);

                    toneG.startTone(ToneGenerator.TONE_CDMA_ALERT_CALL_GUARD, 200);
                    /*
                    try { //play mp3 ring tone
                        Uri notification = RingtoneManager.getDefaultUri(RingtoneManager.TYPE_NOTIFICATION);
                        Ringtone ring = RingtoneManager.getRingtone(MainActivity.tis, notification);
                        ring.play();
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                    */
                }
            }


        }

        long codeResult = 0;

        boolean matched_once;

        public void runtask_nv21_ocr(byte[] nv21, int threadIndex) {

            if (nv21 == null) {
                printf( "runtask_nv21: ");
            }
            int width = image_width;//parameters.getPreviewSize().width;
            int height = image_height;//parameters.getPreviewSize().height;;
            int[] rgb = new int[nv_width * height];

            float pda_front = 1;
            if (pda_front > 0) {
                // imageRatio = 1.285;
                // 這個數字，是由前鏡頭拍照時，
                // 計算出現在720﹡1280的720方向出現的點數約56點。
                // 720 / 56 = 12.85
                // 如果 pda_front = 0.5
                // 12.85 * pda_front = 6.425
                // imageRatio = 6.425  / 5; //標準點距為5
                //  imageRatio =  0;//(double)720 / 56 * pda_front / 5;// 已經停用

            }


            //File appDir = MainActivity.tis.getFilesDir();

            String info_path = MainActivity.patternPath;


            int matchWhat = 1 + 4;
            int front_camera = 0; // 0=back or 1=front

            {

                codeResult = MainActivity.ocr_recognition.OCRNativeNV21ToRGBiScanCodeB(
                        rgb,
                        nv21,
                        nv_width,
                        height,
                        scan_x,
                        scan_y,
                        scan_width,
                        scan_height,
                        (int) grayDeltaThreshold,
                        threadIndex,
                        info_path,
                        pda_front,
                        matchWhat,
                        front_camera
                );

                if (codeResult > 0) {

                    matched_once = true;

                } else {

                }
            }

            if (codeResult >= 0) {


                boolean beep = false;
                if (beep) {
                    ToneGenerator toneG = new ToneGenerator(AudioManager.STREAM_ALARM, 100);

                    toneG.startTone(ToneGenerator.TONE_CDMA_ALERT_CALL_GUARD, 200);
                    /*
                    try { //play mp3 ring tone
                        Uri notification = RingtoneManager.getDefaultUri(RingtoneManager.TYPE_NOTIFICATION);
                        Ringtone ring = RingtoneManager.getRingtone(MainActivity.tis, notification);
                        ring.play();
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                    */
                }
            }

            if (true) {
                if (true) {
                    //已經旋轉90度
                    int temp = width;
                    width = height;
                    height = temp;
                }

            }


        }
    }


}

class DismissHandler extends Handler {
    long id;

    // public DismissHandler(long id) {
    //      this.id = id;
    //  }
}


class AndroidCameraFactory extends PlatformViewFactory {
    MainActivity activity;
    BinaryMessenger messenger;

    AndroidCameraFactory(MainActivity activity0, BinaryMessenger messenger0) {
        super(StandardMessageCodec.INSTANCE);
        activity = activity0;
        messenger = messenger0;
    }

    @Override
    public PlatformView create(Context context, int id, Object args) {
        return new AndroidCamera(id, messenger, context, activity, args);
    }
}


class MyPlugin implements FlutterPlugin {
    MainActivity activity;

    class myMethodCallHandler implements MethodChannel.MethodCallHandler {
        public final MainActivity activity;

        private myMethodCallHandler(MainActivity activity0) {

            activity = activity0;
        }


        void printf(String message)
        {
            Log.d("ansun",message);
        }

        @Override
        public void onMethodCall(MethodCall call, final MethodChannel.Result result) {
            switch (call.method) {
                case "activateOCR":
                    printf("activateOCR2");
                    result.success(true);
                    break;
                case "waitForCamera":
                    result.success(true);
                    break;
            }
            if (call.method.equals("setPaths")) {
                AtomicReference<String> errorMessage = new AtomicReference<>("");
                if (call.arguments instanceof HashMap) {
                    Map<String, String> params = (Map<String, String>) call.arguments;

                    params.forEach((key,value)-> {
                        String theError = activity.ocr_recognition.SetPaths(key,value);
                        if (theError.length() > 0) {
                            // 參考：需要顯示錯誤訊息
                            errorMessage.set(theError);
                        }
                    });

                }
                result.success(errorMessage.get());
            } else if (call.method.equals("checkForPermission")) {
                checkForPermission(result); //checkPermission
                //result.success(true);
            } else {

                    result.notImplemented();

            }
        }

        private void checkForPermission(final MethodChannel.Result result0) {


            MainActivity.channelResult = null;//result0;
            if (android.os.Build.VERSION.SDK_INT < 23) {
                result0.success(true);
            } else {
                MainActivity.channelResult = result0;
                //checkSelfPermission api:>=23
                if (activity.checkSelfPermission(Manifest.permission.CAMERA) != PackageManager.PERMISSION_GRANTED) {
                    activity.requestPermissions(
                            new String[]{
                                    Manifest.permission.CAMERA,
                                    Manifest.permission.WRITE_EXTERNAL_STORAGE,
                                    Manifest.permission.READ_EXTERNAL_STORAGE
                            },
                            MainActivity.RequestCodeForCameraPermission
                    );
                } else {
                    MainActivity.channelResult = null;
                    result0.success(true);

                }
            }

        }
    }


    MyPlugin(MainActivity activity0) {
        activity = activity0;
    }

    @Override
    public void onAttachedToEngine(@NonNull @NotNull FlutterPluginBinding binding) {
        binding.getPlatformViewRegistry().registerViewFactory(
                "plugins.flutter.io/my_camera",
                new AndroidCameraFactory(activity, binding.getBinaryMessenger())
        );
        final MethodChannel candidate_channel = new MethodChannel(binding.getBinaryMessenger(), "my_desktop_channel");
        candidate_channel.setMethodCallHandler(new myMethodCallHandler(activity));
    }

    @Override
    public void onDetachedFromEngine(@NonNull @NotNull FlutterPluginBinding binding) {

    }
}

