package tw.com.smartinside.mlpr.sample;

import android.content.Intent;
import android.content.pm.PackageManager;
import android.net.Uri;
import android.os.Bundle;
import android.os.Looper;
import android.os.StrictMode;
import android.os.Handler;
import androidx.annotation.NonNull;
//import androidx.fragment.app.FragmentActivity;

//import com.google.android.gms.ads.MobileAds;
//import com.google.android.gms.ads.RequestConfiguration;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.Arrays;
import java.util.List;

import io.flutter.BuildConfig;
import io.flutter.embedding.android.FlutterFragmentActivity;
import io.flutter.plugin.common.MethodChannel;

import io.flutter.embedding.engine.FlutterEngine;
import tw.com.smartinside.mlpr.sample.OCRRecognitionSample;

public class MainActivity extends FlutterFragmentActivity //FlutterActivity
{
// flutter platformView required API level is: >= 20
    static int RequestCodeForCameraPermission = 100;
    static MethodChannel.Result channelResult;
    static MethodChannel methodChannelFlutter = null;
    static MethodChannel taskinfo_channel = null;
    static String patternPath = "";
    static public OCRRecognitionSample ocr_recognition = new OCRRecognitionSample();
    //static public DotRecognition dot_recognition = new DotRecognition();
    static public MainActivity tis;
    int needRecording = 0;

    static void DoActivate(int active)
    {
        ocr_recognition.Activate(active);
    }
    String ConvertFile(String name)
    {
        BufferedReader reader = null;


        try {
            reader = new BufferedReader( new InputStreamReader(getAssets().open(name), "UTF-8"));
            File file = getCacheDir();
            file = new File(file,name);
            FileOutputStream outputStream = new FileOutputStream(file);
            OutputStreamWriter outWriter = new OutputStreamWriter(outputStream);
            // do reading, usually loop until end of file reading
            String mLine; //將檔案從apk複製到目錄
            while ((mLine = reader.readLine()) != null) {
                //process line
                outWriter.append(mLine);
                outWriter.append('\n');
            }
            outWriter.close();
            outputStream.close();
            reader.close();

            return file.getParentFile().getAbsolutePath() + "/pattern";
        } catch (IOException e) {
            //log the exception
            //e.printStackTrace();
        }
        return "";
    }
    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        tis = this;
/*
        if (BuildConfig.DEBUG) {
            //RequestConfiguration.Builder().setTestDeviceIds(Arrays.asList("F041063885C3F01C2CF3D4EAA28E1F7A"));
            List<String> testDeviceIds = Arrays.asList("F041063885C3F01C2CF3D4EAA28E1F7A");
            RequestConfiguration configuration = new RequestConfiguration.Builder().setTestDeviceIds(testDeviceIds).build();
            MobileAds.setRequestConfiguration(configuration);
        }

 */
        //StrictMode.getVmPolicy();
        patternPath = ConvertFile("pattern-8-8-8_font.txt"); // -7-8-8
        String path = patternPath;
        ConvertFile("pattern-8-8-8_lpr.txt");


        Intent intent  = getIntent();
        if (intent != null) {
            try {
                CheckIfImportmlprdoc(intent,true);
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    @Override
    protected void onNewIntent(Intent intent) {
    super.onNewIntent(intent);
        try {
            CheckIfImportmlprdoc(intent,false);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    void CheckIfImportmlprdoc(Intent intent ,Boolean boot) throws IOException {
        //android.os.Debug.waitForDebugger()
        Bundle bundle = intent.getExtras();
        if (bundle != null) {
            Uri uri = bundle.getParcelable(Intent.EXTRA_STREAM) ;
            // uri 不是檔名，而是必須透過系統操作的路徑,並不包含副檔名 .mlprdoc,
            if (uri != null) {
                InputStream inputStream  = getContentResolver().openInputStream(uri);
                  //      uri.let { getContentResolver().openInputStream(it) }
                if (inputStream != null) {
                    File path = File.createTempFile("tempToImport","tmp"); // xxxx.tmp

                    //val file: File = path.toFile() // from somewhere
                    //if (file != null) {
                   // ByteArray bytes = inputStream.read();

                    //if (bytes) {
                   // file.writeBytes(bytes)
                    BufferedReader reader = null;


                    try {
                        //  mlprdoc 是純文字檔 utf8
                        reader = new BufferedReader( new InputStreamReader(inputStream, "UTF-8"));
                        //File file = getCacheDir();
                        //file = new File(file,name);
                        FileOutputStream outputStream = new FileOutputStream(path);
                        OutputStreamWriter outWriter = new OutputStreamWriter(outputStream);
                        // do reading, usually loop until end of file reading
                        String mLine; //將檔案從apk複製到目錄
                        while ((mLine = reader.readLine()) != null) {
                            //process line
                            outWriter.append(mLine);
                            outWriter.append('\n');
                        }
                        outWriter.close();
                        outputStream.close();
                        reader.close();

                        //return file.getParentFile().getAbsolutePath() + "/pattern";
                    } catch (IOException e) {
                        //log the exception
                        //e.printStackTrace();
                    }

                    String name  = path.toString();
                    if (boot) {
                        //因為flutter channel 還沒有建好，必須延遲。
                        new Handler(Looper.myLooper()).postDelayed(new Runnable() {
                            @Override
                            public void run() {
                                methodChannelFlutter.invokeMethod("gotFile", name);
                            }
                        }, 1000);
                    } else {
                        methodChannelFlutter.invokeMethod("gotFile", name);
                    }
                    // }
                    //}
                    inputStream.close();
                }
            }
        }
    }


    @Override
    public void configureFlutterEngine(FlutterEngine flutterEngine) {
        super.configureFlutterEngine(flutterEngine);
        flutterEngine.getPlugins().add(new MyPlugin(this));
        //MyPlugin.DoRegisterWith(flutterEngine,this);
        //GeneratedPluginRegistrant.registerWith(flutterEngine);
    }


// This function is called when user accept or decline the permission.
// Request Code is used to check which permission called this function.
// This request code is provided when user is prompt for permission.

    @Override
    public void onRequestPermissionsResult(int requestCode,
                                           @NonNull String[] permissions,
                                           @NonNull int[] grantResults)
    {
        super.onRequestPermissionsResult(requestCode,permissions,grantResults);
        if (channelResult != null) {
            if (requestCode == RequestCodeForCameraPermission) {

                // Checking whether user granted the permission or not.
                if (grantResults.length > 0 && grantResults[0] == PackageManager.PERMISSION_GRANTED) {
                    channelResult.success(true);
                    channelResult = null;
                } else {
                    channelResult.success(false);
                    channelResult = null;
                }
            }
        }
    }

}

