package tw.com.smartinside.mlpr.sample;


import android.graphics.Bitmap;

import androidx.annotation.Keep;

import java.io.ByteArrayOutputStream;
import java.util.HashMap;
import java.util.Map;



  // 2022/03/02 因為 proguard R8 會移除沒有被JAVA使用的 api，導致 c++ 無法找到這個api，所以需要宣告@Keep 保留全部屬於這個class 的member api。
 @Keep  public class OCRRecognitionSample extends Object {

    // Used to load the 'native-lib' library on application startup.
    static {
        System.loadLibrary("native-mlpr");
    }

    public native long OCRNativeNV21ToRGBiScanCodeB(
            // 辨識 相機 NV21 rawdata
            int[] pixels,  byte[] nv21,
                                                          int width, int height,
                                                          int scan_x, int scan_y, int scan_width, int scan_height,
                                                          int iGrayDeltaThreshold, int myThreadID_index,
                                                          String info_path,  double pda_front,
                                                          int matchWhat,  int front_camera  );

    public native long NativePixelBuffer( // 辨識jpg圖檔
            int[] pixels, int width,
             int height,int iGrayDeltaThreshold,int threadIndex,String info_path,int needRecording);
    public native String SetPaths( String key, String path);
    public native long Activate( int active);


    void SendToFlutter(final Map<String, Object> params)
    {
        MainActivity.tis.runOnUiThread(new Runnable() {
            public void run() {
                try {
                    MainActivity.methodChannelFlutter.invokeMethod("onImageCaptured", params);
                } catch (Exception e) {
                    e.printStackTrace();

                }
            }
        });
    }

    public String MessageMeBitmap(Bitmap bits, String bitmapInfo) { //a api for call back from c++

        try {
            Map<String, Object> params = new HashMap<>();
            //params.put("info", bitmapInfo);
            if (bits != null) {
                ByteArrayOutputStream bitsStream = new ByteArrayOutputStream();
                bits.compress(Bitmap.CompressFormat.PNG, 100, bitsStream);
                byte[] byteData = bitsStream.toByteArray();
                params.put("png", byteData);
            }
            String[] pairs = bitmapInfo.split(",");

            for (int i=0;i<pairs.length;i++) {
                String pair = pairs[i];
                String[] keyValue0 = pair.split(":");
                String[] keyValue = {keyValue0[0],""};
                if (keyValue0.length > 1) {
                    keyValue[1] =  keyValue0[1];
                }
                String key = keyValue[0];
                if (key.equals("match_score")) {
                    double value = Double.parseDouble(keyValue[1]);
                    params.put(keyValue[0], value);
                } else if (key.equals("match_count")) {
                    int value = Integer.parseInt(keyValue[1]);
                    params.put(keyValue[0], value);
                } else if  (key.equals("estimate_height")) {
                    double value = Double.parseDouble(keyValue[1]);
                    params.put(keyValue[0], value);
                } else {
                    params.put(keyValue[0], keyValue[1]);
                }
            }

            SendToFlutter(params);
            return "OK";
        } catch (Exception e) {
            e.printStackTrace();
            return "ERROR";
        }

    }

    public  String MessageMeIntArray(int[] dataInts,int width,int height, String bitmapInfo) { //a api for call back from c++

        try {
            Map<String, Object> params = new HashMap<>();
            params.put("path", "abcd");
            params.put("info", bitmapInfo);
            params.put("dataInts", dataInts);
            params.put("width",width);
            params.put("height",height);
            SendToFlutter(params);
            return "OK";
        } catch (Exception e) {
            e.printStackTrace();
            return "ERROR";
        }

    }

    public  String MessageMeByteArray(byte[] dataBytes,int width,int height, String bitmapInfo) { //a api for call back from c++

        try {
            Map<String, Object> params = new HashMap<>();
            params.put("path", "abcd");
            params.put("info", bitmapInfo);
            params.put("dataBytes", dataBytes);
            params.put("width",width);
            params.put("height",height);
            SendToFlutter(params);
            return "OK";
        } catch (Exception e) {
            e.printStackTrace();
            return "ERROR";
        }

    }

}


