//#include "FontParse.h"


class BlackSection :public _BaseLearning
{
    // 橫向縱向的黑點出現頻率變化
    // 橫向最多有16總變化
    // 縱向也是
public:
    class CodingChars : public Char1Pattern
    {
    public:
        CodingChars(char theChar ,float ratioc,float ratiow,BitInfo *info) : Char1Pattern(theChar,ratioc,ratiow,info)
        {
            value0 = 0;
            value1 = 0;
           
        }
        
        char Exist(CodingChars*new1)
        {
            if (value0 == new1->value0) {
                if (value1 == new1->value1) {
                    if (theChar == new1->theChar) {
                        return 1;
                    }
                }
            }
            return 0;
        }
        
        uint64_t value0;
        uint64_t value1;
        //char theChar;
        //float ratio_w;
        //CodingChars *next;
        
    };
    
    BlackSection()
    {
        charsRoot = 0;
        strcpy(names,"BlackSection");
    };
    
    ~BlackSection(){
        delete charsRoot;
       
    };
    
    int CountBlackByRow(unsigned char *buff,int len)
    {
        char oldBlack = 0;
        int count = 0;
        for (int i=0;i<len;i++) {
            char newBlack = 0;
            if (IsBlack(*(MyRGB*)buff)) {
                newBlack = 1;
                
            }
            if (oldBlack ^ newBlack) {
                if (newBlack) {
                    count++;
                    
                }
                oldBlack = newBlack;
            }
            buff += 4;
        }
        
        return count;
    }
    
    int CountBlackByColumn(unsigned char *buff,int len,int rowbytes)
    {
        char oldBlack = 0;
        char count = 0;
        
        for (int i=0;i<len;i++) {
            char newBlack = 0;
            if (IsBlack(*(MyRGB*)buff)) {
                newBlack = 1;
                
            }
            if (oldBlack ^ newBlack) {
                
                if (newBlack) {
                    count++;
                    
                }
                oldBlack = newBlack;
            }
            buff += rowbytes;
        }
        
        return count;
    }
    
    char GetCharCodingByRow(MyBitMap &bits, uint64_t *result0)
    {
        uint64_t result = 0;
        unsigned char *buff0 = bits.buff ;
        int count = 0;
        int sectCount = 0;
        int oldBlack = 0;
        for (int y=0;y<bits.height;y++) {
            int newBlack = CountBlackByRow(buff0,bits.width);
            if (newBlack > 0) {
                if (oldBlack != newBlack) {
                    if (count > 3) {
                        if (oldBlack > 15) {
                            return 0;
                            
                        }
                        if (count == 0) {
                            if (oldBlack > 0) {
                                sectCount++;
                                result <<= 4;
                                result |= oldBlack;
                            }
                        } else {
                            sectCount++;
                            result <<= 4;
                            result |= oldBlack;
                            
                        }
                    }
                    oldBlack = newBlack;
                    count = 1;
                } else {
                    count++;
                }
            }
            buff0 += bits.rowBytes;
        }
        if (sectCount > 15) {
            return 0;
            
        }
        if (count > 3) {
            result <<= 4;
            result |= oldBlack;
        }
        
        
        *result0 = result;
        return 1;
        
    }
    
    char GetCharCodingByColumn(MyBitMap &bits,uint64_t *result0)
    {
        uint64_t result = 0;
        unsigned char *buff0 = bits.buff;
        int count = 0;
        int oldBlack = 0;
        int sectCount = 0;
        for (int x=0;x<bits.width;x++) {
            int newBlack = CountBlackByColumn(buff0,bits.height,bits.rowBytes);
            if (newBlack > 0) {
                if (oldBlack != newBlack) {
                    if (count > 1) {
                        if (oldBlack > 15) {
                            return 0;
                            
                        }
                        if (count == 0) {
                            if (oldBlack > 0) {
                                sectCount++;
                                result <<= 4;
                                result |= oldBlack;
                            }
                        } else {
                            sectCount++;
                            result <<= 4;
                            result |= oldBlack;
                            
                        }
                    }
                    oldBlack = newBlack;
                    count = 1;
                } else {
                    count++;
                }
            }
            buff0 += 4;
        }
        if (sectCount > 15) {
            return 0;
            
        }
        if (count > 3) {
            result <<= 4;
            result |= oldBlack;
        }
        
        *result0 = result;
        return 1;
        
    }
    
    char *DumpBinary(uint64_t value)
    {
        printf("DumpBinary\n");
        static char buff0 [128];
        char *buff = buff0;
        for (int i=0;i<32;i++) {
            *buff++ = (int)value<0?'1':'0';
            value <<= 1;
        }
        *buff++ = 0;
        printf("%s\n",buff0);
        return buff0;
    }
    
    void DumpHex(char theChar, uint64_t value, char lineFeed)
    {
        printf("DumpHex\n");
        if (theChar) {
            printf("%c  ",theChar);
        }
        const char *hex = "0123456789ABCDEF";
        char result[17];
        for (int i=0;i<16;i++) {
            uint64_t index = value & 0x0f;
            result[15-i] = hex[index];
            value >>= 4;
        }
        result[16] = 0;
        //("result1 %s  ",result);
        if (lineFeed) {
            //("\n");
        }
        
    }
    
    char GetCharCodings(MyBitMap &bits,uint64_t *resultColumn,uint64_t *resultRow)
    {
        //計算橫向與縱向的奇偶變化
        if (GetCharCodingByColumn(bits,resultColumn)) {
            if (GetCharCodingByRow(bits,resultRow)) {
                return 1;
            }
        }
        return 0;
    }
    
    char Exist(CodingChars *new1)
    {
        CodingChars *current = charsRoot;
        while (current) {
            if (current->value0 == new1->value0) {
                if (current->value1 == new1->value1) {
                    if (current->theChar == new1->theChar) {
                        return 1;
                    }
                }
            }
            current = (CodingChars *)current->next;
        }
        return 0;
    }
    
    virtual char Process1Char(char theChar,CharMaps *result_maps,MyBitMap &bits, FloatRect clip,float ratio_w, float ratio_char, BitInfo *finfo)
    {
        
        uint64_t vh_codings8C;
        uint64_t vh_codings8R;
        
        if (GetCharCodings(bits,&vh_codings8C,&vh_codings8R)) {
            CodingChars *new1 = new CodingChars(theChar,ratio_char,ratio_w,finfo);
            new1->value0 = vh_codings8C;
            new1->value1 = vh_codings8R;
            new1->theChar = theChar;
            new1->ratio_w = ratio_w;
            if (theChar > 0) {
                if (!Exist(new1) ) {
                    new1->next = charsRoot;
                    charsRoot = new1;
                    charCounts++;
                } else {
                    delete new1;
                }
            } else {
                CodingChars *currentChar = charsRoot;
                while (currentChar) {
                    if ((currentChar->value0 == new1->value0) && (currentChar->value1 == new1->value1))
                    {
                        result_maps->blocks->chars[currentChar->theChar].SetMax(1);
                    } else if ((currentChar->value0 == new1->value0) || (currentChar->value1 == new1->value1)) {
                        
                        result_maps->blocks->chars[currentChar->theChar].SetMax(0.5);
                    } else {
                        //result_maps->blocks->chars[currentChar->theChar].Add(0.0);
                    }
                    currentChar = (CodingChars *)currentChar->next;
                }
                delete new1;
            }
        }
        return 1;
    }
    
    CodingChars *charsRoot;
   // int count;
    
};
