//#include "FontParse.h"


class CountBlacks :public _BaseLearning
{
#define iMaxCodingBlacks 7
    
    
public:
    class CodingBlacks : public Char1Pattern
    {
    public:
        CodingBlacks(char theChar0 ,float ratioc,float ratiow,BitInfo *info) : Char1Pattern(theChar0,ratioc,ratiow,info)
        {
            theChar = 0;
            next = 0;
        }
        
        char Exist(CodingBlacks*new1)
        {
            for (int x=0;x<iMaxCodingBlacks;x++) {
                if (columns[x] != new1->columns[x]) {
                    return 0;
                }
                if (rows[x] != new1->rows[x]) {
                    return 0;
                }
            }
            if (theChar != new1->theChar) {
                return 0;
            }
            return 1;
            
        }
        
        float MatchCode1(CodingBlacks &new1)
        {
            float matchs = 0;
            for (int x=0;x<iMaxCodingBlacks;x++) {
                if (columns[x] && new1.columns[x]) {
                    if (columns[x] == new1.columns[x]) {
                        matchs += 1;
                    }
                }
                if (rows[x] && new1.rows[x]) {
                    if (rows[x] == new1.rows[x]) {
                        matchs += 1;
                    }
                }
            }
            
            return matchs / (iMaxCodingBlacks*2);
        }
        
        
        unsigned char columns[iMaxCodingBlacks];
        unsigned char rows[iMaxCodingBlacks];
        
        
        
    };
    
    CountBlacks()
    {
        charsRoot = 0;
        strcpy(names,"CountBlacks");
    };
    
    ~CountBlacks()
    {
        delete charsRoot;
        
    };
    
    int CountBlackByRow(unsigned char *buff,int len)
    {
        char oldBlack = 0;
        char count = 0;
        for (int i=0;i<len;i++) {
            char newBlack = 0;
            if (IsBlack(*(MyRGB*)buff)) {
                newBlack = 1;
            }
            if (oldBlack ^ newBlack) {
                if (newBlack) {
                    count++;
                }
                oldBlack = newBlack;
            }
            buff += 4;
        }
        return count;
    }
    
    int CountBlackByColumn(unsigned char *buff,int len,int rowbytes)
    {
        char oldBlack = 0;
        char count = 0;
        
        for (int i=0;i<len;i++) {
            char newBlack = 0;
            if (IsBlack(*(MyRGB*)buff)) {
                newBlack = 1;
                //("1");
            } else {
                //("0");
            }
            if (oldBlack ^ newBlack) {
                
                if (newBlack) {
                    count++;
                }
                oldBlack = newBlack;
            }
            buff += rowbytes; //skip argb/rgba
        }
        
        return count;
    }
    
    void GetCharCodingByRow(MyBitMap &bits, CodingBlacks &result0)
    {
        
        double ratioy = bits.height / iMaxCodingBlacks;
        double top = ratioy / 2;
        for (int y=0;y<iMaxCodingBlacks;y++) {
            unsigned char *buff0 = bits.buff + ((int)top) * bits.rowBytes;
            int countBlacks = CountBlackByRow(buff0,bits.width);
            result0.rows[y] = countBlacks;
            top += ratioy;
        }
    }
    
    void GetCharCodingByColumn(MyBitMap &bits,CodingBlacks &result0)
    {
        
        double ratiox = (float)bits.width / iMaxCodingBlacks;
        double fromLeft = ratiox / 2;
        for (int x=0;x<iMaxCodingBlacks;x++) {
            unsigned char *buff0 = bits.buff + ((int)fromLeft) * 4 ;
            int newBlack = CountBlackByColumn(buff0,bits.height,bits.rowBytes);
            result0.columns[x] = newBlack;
            fromLeft += ratiox;
        }
        
    }
    
    char *ToBinary(uint32_t value)
    {
        static char buff0 [128];
        char *buff = buff0;
        for (int i=0;i<32;i++) {
            *buff++ = (int)value<0?'1':'0';
            value <<= 1;
        }
        *buff++ = 0;
        return buff0;
    }
    
    void GetCharCodings(MyBitMap &bits,CodingBlacks &result0)
    {
        //計算橫向與縱向的奇偶變化
        // uint64_t resultColumn ;
        GetCharCodingByColumn(bits,result0);
        // uint64_t resultRow ;
        GetCharCodingByRow(bits,result0);
        
    }
    
    char Exist(CodingBlacks *new1)
    {
        CodingBlacks *current = charsRoot;
        while (current) {
            if (current->Exist(new1)) {
                return 1;
            }
            current = (CodingBlacks *)current->next;
        }
        return 0;
    }
    
    virtual char Process1Char(char theChar,CharMaps *result_maps,MyBitMap &bits, FloatRect clip,float ratio_w, float ratio_char, BitInfo *finfo)
    {
        CodingBlacks *new1 = new CodingBlacks(theChar,ratio_char,ratio_w,finfo);
        new1->ratio_w = ratio_w;
        new1->theChar = theChar;
        GetCharCodings(bits,*new1);
        if (theChar > 0) {
            new1->next = this->charsRoot;
            this->charsRoot = new1;
            charCounts++;
        } else {
            CodingBlacks *currentChar = charsRoot;
            while (currentChar) {
                float matchRatio = currentChar->MatchCode1(*new1);
                result_maps->blocks->chars[currentChar->theChar].SetMax(matchRatio);
                currentChar = (CodingBlacks *)currentChar->next;
            }
            delete new1;
        }
        return 1;
    }
    CodingBlacks *charsRoot;
};
