// 2013/04/08 chengansun@gmail.com

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "Rotate3d.h"


// Rotate3Dto2D 將3D座標投射在2D螢幕

#define rangex1   -2
#define rangex2  2
#define rangey1   -2
#define rangey2   2
#define scale (200/(rangex2-rangex1))
float  rangeStep = (((float)rangex2 - rangex1) / 800);

#define degreeStep 1
double degree_v = 72;
double degree_h = 52;
#define kDown 0x1f
#define kUp 0x1e
#define kLeft 0x1c
#define kRight 0x1d
double upSideDown = 0;
double viewDistance = 400;
//double distanceStep = 3;
double scale2d0;
double scale2dStep = 1;
long lineCount;
char rotate3DFast = 1;
extern double pi_half;
//extern GrafPtr  localPort;
// 2d 旋轉矩陣
//  cos    sin
//  -sin	cos


//  3d 旋轉矩陣


// 對X軸旋轉
//	1	   0		0
// 	0	  cos	sin
// 	0	  -sin	cos

// 對Y軸旋轉
// 	cos	   0		sin
//	0	   1		0
// 	-sin	   0		cos


// 對Z軸旋轉
//   cos	  sin		0
//   -sin	  cos		0
//   0	   0		1




void dsprintf( char *format, ...)
{
    /*
     char s[256];
     vsprintf(s+1, format,  (char*)(&format+1));
     *s = strlen(s+1);
     MoveTo(0,vtab);
     DrawString((unsigned char *)s);
     vtab += 15;
     */
}


double maxAngle = 0;
double minAngle = 1000;

double dabs(double v);
#define pi M_PI

double Normalize(double value)
{
	if (dabs(value) < 0.000000000001) {
		return 0;
	}
	return value;
}
double angle90pi180 = 90 * pi / 180;
double anlge270pi180 = 270 * pi / 180;

char Pt2Angle(double x1,double y1,double x2,double y2, double *angle0)
{
	double dtx = Normalize(x2-x1);
	double angle = 0;
	double dty = Normalize(y2-y1);
	
	if (dtx == 0) {
		if (dty == 0) {
			*angle0 = 0;
			return 0;
		} else {
			if (dty > 0) {
				
				angle = angle90pi180;
			} else {
				
				angle = anlge270pi180;
			}
		}
	} else {
		double ratio =  dty / dtx;
		angle = atan(ratio);
		//if (angle) {
        if (dtx > 0) {
            if (dty > 0) {
                // 1
            } else {
                // 4
                angle += 2*pi;
            }
        } else {
            if (dty > 0) {
                // 2
                angle += pi;
            } else {
                // 3
                angle += pi;
            }
        }
		//}
	}
	*angle0 = angle;
	return 1;
}

/*
 void testangle()
 {
 PenSize(2,2);
 MoveTo(200,200);
 LineTo(200,200);
 while (1) {
 while (!Button()) {};
 while (Button()){};
 Point pt;
 GetMouse(&pt);
 double angle ;
 Pt2Angle(200,200,pt.h,pt.v,&angle);
 //("angle = %f\n",(float) angle);
 }
 }
 */


class Matrix3D
{
public:
	
    
	
    Graph2D by_x;
    Graph2D by_y;
    Graph2D by_z;
    
};

void CalculateCenter(Point3D *pt,long count,Point3D *center)
{
	double xx = 0;
	double yy = 0;
	double zz = 0;
	for (long i=0;i<count;i++) {
		xx += pt[i].x;
		yy += pt[i].y;
		zz += pt[i].z;
	}
	center->x = xx / count;
	center->y = yy / count;
	center->z = zz / count;
}

void SetCenterToZeroPoint(Point3D *pt,long count,Point3D center)
{
	for (long i=0;i<count;i++) {
		pt[i].x -= center.x;
		pt[i].y -= center.y;
		pt[i].z -= center.z;
	}
}
/*
 void OffsetCenter(Point3D *pt,Point3D center)
 {
 pt[0].x -= center.x;
 pt[0].y -= center.y;
 pt[0].z -= center.z;
 
 }
 */

double dabs(double v)
{
	if (v < 0) v = -v;
	return v;
}
char Map3Dto2D(double z,  Point3D *pt,double *x1,double *y1)
{
	if (0) {
		// 平行投影，沒有視覺距離效果。
		*x1 = pt->x;
		*y1 = pt->y;
		return 1;
	} else {
		if ((z - pt->z) <= 0) {
			*x1 = pt->x;
			*y1 = pt->y;
			return 0;
		} else {
			//視覺投影，廣角投影，具有視覺距離效果，但是會讓平面法線GetSurfaceAngleByZ()的計算產生誤差。
			*y1 = (pt->y * z / (z - pt->z));
			*x1 = (pt->x * z / (z - pt->z));
		}
	}
	return 1;
}

Point3D ArcTo3D(double y_degree_v, double y_degree_h, double r)
{
    Point3D pt;
	double h_r = sin(y_degree_v) * r;
	pt.x = cos(y_degree_h) * h_r;
	pt.y = cos(y_degree_v) * r;
	pt.z = sin(y_degree_h) * h_r;
    return pt;
}

void Rotate3Dto2D::Plot3D(Make3D &_3d,Plane *plane)
{
	Triangle *threePoint = _3d.data;
	for (long i=0;i<_3d.countPt;i+=1) {
        Point3Di firstPt;
		for (long j=0;j<3;j++) {
			Point3Di pt3d;
			Point3D r3d = Rotate3D(threePoint->pt[j]);
			if (MapToScreen(&r3d, pt3d))
            {
            }
            if (j == 0) {
                firstPt = pt3d;
            }
            Plot2D(pt3d.x,pt3d.y,j,plane,false);
            //threePoint->pt[j].flags
			
		}
        Plot2D(firstPt.x,firstPt.y,4,plane,true);
		threePoint += 1;
		//if (i > 5000) break;
        
	}
}
char PtToAngleZ(Point3D pt,double *result)
{
	double xy = pt.x*pt.x + pt.y*pt.y;
	double r_xy = sqrt(xy);
	double angle = 0;
	if ((pt.x >= 0) && (pt.y >= 0)) {
		//r_xy > 0
	} else {
		if (pt.x > 0) {
			if (pt.x > -pt.y) {
				//r_xy > 0
			} else {
				//r_xy = -r_xy;
			}
		} else {
			// y > 0
			if (pt.y > -pt.x) {
			} else {
				//r_xy = -r_xy;
			}
		}
	}
	if (Pt2Angle(0,0,r_xy, pt.z,&angle)) {
		
		*result = angle;
		return 1;
	}
	return 0;
}
/*
 void WaitButton()
 {
 while (not Button()) {};
 while (Button()) {};
 }
 */

long lineRasterDotCount;
long Plane::Fill3DSurface(Make3D &_3d,Rotate3Dto2D &view3d,//Rotate3DObject &spot_3d,
                          long dofilter)
{
	//(void)spot_3d; // to avoid warning only
	
	maxAngle = 0;
	minAngle = 4;
	//Triangle *tri1 = _3d.data;
	//char view1 = 1;
	lineRasterDotCount = 0;
	for (long i=0;i<_3d.countPt;i++) {
		Point3Di view_pt3di[3]; //視角
		Point3D view_pt3d[3];
		char valid = 1;
        
		for (short j=0;j<3;j++) { // this loop need 4 ticks for bunny rabit
			view_pt3d[j] = view3d.Rotate3D(_3d.data[i].pt[j]);
			valid = valid && view3d.MapToScreen(&view_pt3d[j],view_pt3di[j]);
		}
		
		if (valid) {
			/*
             Point3Di spot_pt3di[3]; //光源
             Point3D spot_pt3d[3];
             if (dofilter >= 1) {
             for (short j=0;j<3;j++) { // this loop need 4 ticks for bunny rabit
             spot_pt3d[j] = spot_3d.Rotate3D(pt[j]); // 2 ticks for bunny rabit
             valid = valid && spot_3d.MapToScreen(spot_pt3d[j],spot_pt3di[j]);
             }
             }
             */
			if (valid) {
                
				double  spotAngle = 0;
                // spotAngle = GetSurfaceAngleByZ(spot_pt3d[0],spot_pt3d[1],spot_pt3d[2]);
                // get spot,光源
				
				
				double  viewAngle = 0;
				double  realViewAngle = 0;
				if (1) {
					if  (dofilter >= 2) {
						realViewAngle = _3d.data[i].GetSurfaceAngleByView(view3d.eyePt);
						//GetSurfaceAngleByView(view3d.rotateEyePt, view_pt3d[0],view_pt3d[1],view_pt3d[2]);
						// GetSurfaceAngleByView need 3 ticks for bunny rabit
						//
					}
					// 使用「視角」與「法向量」夾角，GetSurfaceAngleByView() 光源比率才會正常
					// get spot,光源
					
					
					
					//使用真空間座標，會造成  GetSurfaceAngleByZ() 視角  不正確。產生正反面的著色誤差。
				} else {
					Point3D viewpt[3];
					for (short k =0;k<3;k++) {
						//因為MapToScreen使用視覺投影（近光源 廣角投影），非平行光 投影（遠光源、日光），
						//因此，GetSurfaceAngleByZ必須使用投影後的視覺座標(假空間座標)，而非真空間座標，
						//否則會造成正反面的誤差。
						viewpt[k].x = view_pt3di[k].x;
						viewpt[k].y = -view_pt3di[k].y; //因為視覺投影需要配合螢幕up-down (Y-座標還原)
						viewpt[k].z = view_pt3di[k].z;
					}
					Triangle tri(viewpt[0],viewpt[1],viewpt[2]);
					
					viewAngle = tri.GetSurfaceAngleByZ();
                    //GetSurfaceAngleByZ(viewpt[0],viewpt[1],viewpt[2]); // get spot,光源
					
				}
				if ( dofilter < 3) continue;
				if (realViewAngle < 0) {
					
					//continue;	// 背面不顯示
				} else {
					
				}
				if (realViewAngle > maxAngle)  maxAngle = realViewAngle; // to display message
				if (realViewAngle < minAngle) minAngle = realViewAngle; // to display message
                
				spotAngle = realViewAngle;
				
                FillSurfTriangleFast(&view_pt3di[0],&view_pt3di[1],
                                     &view_pt3di[2],spotAngle,realViewAngle); // 5 ticks bunny
				
			} else {
				
			}
		}
		
		//if (i > 3000) break;
	}
	
	//char buff[256];
	//dsprintf("lineRasterDotCount %d TriangleCount %d ",lineRasterDotCount,_3d.countPt);
	//buff[0] = strlen(buff+1);
	//MoveTo(0,30);DrawString((unsigned char *)buff);
	return lineRasterDotCount;
}

Rotate3Dto2D::Rotate3Dto2D(Point3D eye,Point3D upperEyePt0,Point2D displayCenter2D0,double eyeUpRotateDegree0)
{
	
	windowCenter = displayCenter2D0;
	upperEyePt = upperEyePt0;
	eyeUpRotateDegree = eyeUpRotateDegree0;
	
	eyePt = eye;
}

void Rotate3Dto2D::SetTargetCenter( Point3D center3D0)
{
    
	center3D = center3D0;
    
	upperEyePt.x -= center3D.x;
	upperEyePt.y -= center3D.y;
	upperEyePt.z -= center3D.z;
    
	eyePt.x -= center3D.x;
	eyePt.y -= center3D.y;
	eyePt.z -= center3D.z;
    
	Point3D keepEye = eyePt;
    
	rotateEyePt = eyePt;
	InitRotateByY();
	RotateByY(rotateEyePt, &rotateEyePt);
	eyePt = rotateEyePt;
	InitRotateByX();
	RotateByX(rotateEyePt, &rotateEyePt);
	eyePt = keepEye;
	
	RotateByY(upperEyePt, &upperEyePt);
	RotateByX(upperEyePt, &upperEyePt);
	InitRotateByZ();
	RotateByZ(upperEyePt, &upperEyePt);
	/*
     nnz =   y * x_sin   // nnzy
     + z * y_cos* x_cos  // nnzz
     - x * y_sin * x_cos; // nnzx
     nnx = 	  z * (y_sin* z_cos +  y_cos* x_sin* z_sin)  // nnxz
     + x * (y_cos* z_cos  -  y_sin* x_sin* z_sin)  //nnxx
     -  y * x_cos * z_sin  ;  // nnxy
     nny	=
     x * (y_cos * z_sin + y_sin* x_sin* z_cos)  // nnyx
     + y * x_cos* z_cos    // nnyy
     + z * (y_sin * z_sin  -  y_cos* x_sin* z_cos )   // nnyz
     */
	
	nnzy = R_byX.rt_sin;
	nnzz =  R_byY.rt_cos* R_byX.rt_cos;
	nnzx = R_byY.rt_sin * R_byX.rt_cos;
	nnxz = (R_byY.rt_sin* R_byZ.rt_cos +  R_byY.rt_cos* R_byX.rt_sin* R_byZ.rt_sin);
	nnxx = (R_byY.rt_cos* R_byZ.rt_cos  -  R_byY.rt_sin* R_byX.rt_sin* R_byZ.rt_sin);
	nnxy = R_byX.rt_cos * R_byZ.rt_sin;
	nnyx = (R_byY.rt_cos * R_byZ.rt_sin + R_byY.rt_sin* R_byX.rt_sin* R_byZ.rt_cos);
	nnyy = R_byX.rt_cos* R_byZ.rt_cos;
	nnyz =  (R_byY.rt_sin * R_byZ.rt_sin  -  R_byY.rt_cos* R_byX.rt_sin* R_byZ.rt_cos );
	
}

Rotate3Dto2D::~Rotate3Dto2D()
{
}

void Rotate3Dto2D::InitRotateByX()
{
	double degree;
	char valid = Pt2Angle(0,0, eyePt.y, eyePt.z,&degree) ;
	
	
	if (valid) {
		degree = degree * 180 / pi;
		
		degree = 90-degree;
	}
	
	R_byX.G2DAngle(degree);
    
}

inline void Rotate3Dto2D::RotateByX(Point3D pt,Point3D *npt)
{
	R_byX.RotateG2D(pt.y, pt.z, &npt->y,&npt->z);
	npt->x = pt.x;
    
}

void Rotate3Dto2D::InitRotateByY()
{
	double degree;
	char valid = Pt2Angle(0,0, eyePt.z, eyePt.x,&degree) ;
	if (valid) {
		degree = degree * 180 / pi;
		degree = -degree;
	}
	R_byY.G2DAngle(degree);
}

inline void Rotate3Dto2D::RotateByY( Point3D pt,  Point3D *npt)
{
	
	R_byY.RotateG2D(pt.z, pt.x, &npt->z,&npt->x);
	npt->y= pt.y;
    
}

void Rotate3Dto2D::InitRotateByZ() // eye view up-side-down
{
	//if (not byZ.valid) {
    double degree;
    char valid = Pt2Angle(0,0, upperEyePt.x, upperEyePt.y,&degree);
    
    if (valid) {
        degree = degree * 180 / pi;
        //("by z degree %f\n",(float)degree);
        degree = 90-degree;
    }
    
    R_byZ.G2DAngle(degree + eyeUpRotateDegree);
	//}
}

inline void Rotate3Dto2D::RotateByZ(Point3D pt,Point3D *npt) // eye view up-side-down
{
	/*if (not byZ.valid) {
     double degree;
     char valid = Pt2Angle(0,0, upperEyePt.x, upperEyePt.y,&degree);
     
     if (valid) {
     degree = degree * 180 / pi;
     //("by z degree %f\n",(float)degree);
     degree = 90-degree;
     }
     
     byZ.Angle(degree + eyeUpRotateDegree);
     }
     */
	R_byZ.RotateG2D(pt.x,pt.y,&npt->x,&npt->y);
	npt->z = pt.z;
}

Point3D Rotate3Dto2D::Rotate3D(Point3D pt)
{
	//double x,y;
	pt -= center3D;
	
	if (rotate3DFast) {
		Point3D npt;
		npt.z = pt.y * nnzy + pt.z * nnzz - pt.x * nnzx;
		npt.x = pt.z * nnxz + pt.x * nnxx - pt.y *nnxy;
		npt.y = pt.x * nnyx + pt.y * nnyy + pt.z * nnyz;
		return npt;
	} else {
		RotateByY(pt, &pt);
		RotateByX(pt, &pt);
		RotateByZ(pt, &pt); // keep up-down
	}
	return pt;
}


char Rotate3Dto2D::MapToScreen( Point3D *pt,Point3Di  &pt2)
{
	double x,y;
	if (not Map3Dto2D(rotateEyePt.z, pt, &x,&y)) {
		return 0;
	}
	pt2.x = x * scalex + windowCenter.x;
	pt2.y = -y * scaley + windowCenter.y;
	pt2.z = pt->z;
	pt2.flag = 0;
	return 1;
}



void Rotate3Dto2D::Plot2D(double x,double y,char plot,Plane *plane,char finished)
{
	
	//if (plane) {
    if ( plot == 0) {
        plane->MoveTo(x,y);
        //plane->LineTo(x+1,y);
    } else {
        plane->LineTo(x,y,finished);
    }
	//} else {
    //if (not plot) {
    //	MoveTo(x,y);
    //	LineTo(x,y);
    //} else {
    //	LineTo(x,y);
    //}
	//}
    
}


double func6(double x,double z)
{
	return cos(x) * sin(z) * sin (x*z);
}

double func2(double x,double z)
{
	return cos(x*x) * sin(z);
}
double func3(double x,double z)
{
	return cos(x*z) * sin(z);
}
double func4(double x,double z)
{
	double v = 1 - x*x - z*z;
	if (v > 0) {
		return sqrt(v);
	}
	return 0;
}

double func1(double x,double z)
{
	return sin(func4(x,z)*3);
}

double func5(double x,double z)
{
	return (cos(x) *sin(z));
    
}



void Make3D::Get3DCenter(Point3D *center,Point3D *ptmax,Point3D*ptmin)
{
	
	*ptmax = pt3max0;// = Point3D(-10000000000,-10000000000,-10000000000,0);
	*ptmin = pt3min0;// = Point3D(10000000000,10000000000,10000000000,0);
	double x = 0;
	double y = 0;
	double z = 0;
	Triangle *tri1 = data;
	for (long i=0;i<countPt;i++) {
		for (long j=0;j<3;j++) {
			x += tri1->pt[j].x;
			y += tri1->pt[j].y;
			z += tri1->pt[j].z;
			
			if (tri1->pt[j].x > ptmax->x) ptmax->x = tri1->pt[j].x;
			if (tri1->pt[j].y > ptmax->y) ptmax->y = tri1->pt[j].y;
			if (tri1->pt[j].z > ptmax->z) ptmax->z = tri1->pt[j].z;
			if (tri1->pt[j].x < ptmin->x) ptmin->x = tri1->pt[j].x;
			if (tri1->pt[j].y < ptmin->y) ptmin->y = tri1->pt[j].y;
			if (tri1->pt[j].z < ptmin->z) ptmin->z = tri1->pt[j].z;
		}
		tri1++;
	}
	center->x = x / countPt;
	center->y = y / countPt;
	center->z = z / countPt;
}


Make3D::Make3D()
{
	pt3max0.SetPt(-10000000000,-10000000000,-10000000000,0);
	pt3min0.SetPt(10000000000,10000000000,10000000000,0);
	data = 0;
	countPt = 0;
}
Make3D::~Make3D()
{
	if (data) delete data;
}
#define bunnyCount  16301

#include "bunny.cp"
void Make3D::Bunny()
{
	//data = (Point3D*)malloc((bunnyCount*4) *sizeof(Point3D));
	data = (Triangle*)malloc(bunnyCount * sizeof(Triangle));
	//long index = 0;
	for (long i=0;i<bunnyCount;i++) {
		
		double *pt1 = &vertices[face_indicies[i][0]][0];
		double *pt2 = &vertices[face_indicies[i][1]][0];
		double *pt3 = &vertices[face_indicies[i][2]][0];
		data[i].pt[0].SetPt(pt1[0],pt1[1],pt1[2],0);
		data[i].pt[1].SetPt(pt2[0],pt2[1],pt2[2],1);
		data[i].pt[2].SetPt(pt3[0],pt3[1],pt3[2],1);
		data[i].GetFaVector();
        
        
	}
	countPt = bunnyCount;
}


void  Make3D::MakeCurve(funcx func)
{
	long count = 0;
	indexh = 0;
	indexv =0;
	for (double x = rangex1;x < rangex2;x += rangeStep) {
		indexv++;
		for (double z = rangey1;z < rangey2;z += rangeStep) {
			count++;
		}
	}
	indexh = count / indexv;
	
	count += count;
	Point3D* data2 = (Point3D*)malloc(count *sizeof(Point3D));
	long index = 0;
	
	
	for (double x = rangex1;x < rangex2;x += rangeStep) {
		char plot = 0;
		for (double z = rangey1;z < rangey2;z += rangeStep) {
			double y = func(x,z);
			
			//Point3D pt;
			data2[index++].SetPt(x * scale,y * scale,z * scale,plot);
			// = pt;
            
			plot = 1;
		}
	}
	countPt = count /2;
    if (0) {
        for (double z = rangey1;z < rangey2;z += rangeStep) {
            char plot = 0;
            for (double x = rangex1;x < rangex2;x += rangeStep) {
                double y = func(x,z);
                
                data2[index++].SetPt( x * scale,y * scale,z * scale,plot);
                
                //data2[index++] = pt;
                plot = 1;
            }
        }
        countPt = count ;
    }
	
	//data = data2; //return;
	
	ConvertToSerface(data2);
	free(data2);
}
void Debugger()
{
    
}

void Make3D::ConvertToSerface(Point3D*data2)
{
	
	// 轉為三角面
	long count = (indexh-1) * (indexv-1) * 2 * 3;
	data = (Triangle*)malloc(sizeof(Triangle) * count);
	if (data == 0) Debugger();
	//Point3D *buff = data;
	countPt = 0;
	//Point3D *bf102 = 0;
	Triangle *triBuff = data;
	for (long vv=0;vv<indexv-1;vv++) {
		for (long hh=0;hh<indexh-1;hh++) {
            //	if (countPt == 102) {
            //Debugger();
			//	bf102 = buff;
			//}
			long index = indexh * vv + hh;
			
			
			triBuff->pt[0] = data2[index];
			triBuff->pt[1] = data2[index+1];
			triBuff->pt[2] = data2[index + indexh +1];
			triBuff->GetFaVector();
			triBuff++;
			
			triBuff->pt[0] = data2[index];
			triBuff->pt[1] = data2[index + indexh + 1];
			triBuff->pt[2] = data2[index + indexh];
			triBuff->GetFaVector();
			triBuff++;
			
			countPt += 2;
		}
		
	}
	//free(data2);
    
	//countPt = count;
	
}

void CalculateViewCenter(Point3D *viewCenter,Point3D &centerScreen,Point3D &theEyePt)
{
	*viewCenter = centerScreen - theEyePt;
	double rr = viewCenter->x *viewCenter->x + viewCenter->y* viewCenter->y + viewCenter->z * viewCenter->z;
	rr = sqrt(rr);
	//if ( rr > 100) {
    rr = 100/rr; // 100 means the  distance from eye to screen, not from eye to 3d object
	//} else {
	//	rr = 0.5;
	//}
	viewCenter->x *= rr;
	viewCenter->y *= rr;
	viewCenter->z *= rr;
	*viewCenter += theEyePt;
}

enum DoPlot {
	iNone = 0,
	iPlot3d = 1,
	iPlotSurface = 2
};

void Test3d2()

{
	
	Make3D data_3d;
	
	DoPlot doPlot = iNone;
	
	short testWhat = 4;
	switch (testWhat) {
		case 1:
			data_3d.MakeBezierSerf(); doPlot =   iPlotSurface;
			break;
		case 2:
			//test_fast_nurbs
			//test_ration_nurbs
			data_3d.test_fast_nurbs(); doPlot =  iPlotSurface;  //iPlot3d ;//
			break;
		case 3:
			data_3d.MakeCurve(func6); doPlot =    iPlotSurface;
			break;
		case 4:
			data_3d.Bunny();  doPlot = iPlotSurface;
			break;
	}
	
	Point3D centerScreen;
	centerScreen.SetPt(0,0,0,0);
	Point3D ptMax,ptMin;
	data_3d.Get3DCenter(&centerScreen,&ptMax,&ptMin);
	Point3D dtPt = ptMax-ptMin;
	double dtValue = dtPt.x;
	if (dtPt.y > dtValue) dtValue = dtPt.y;
	if (dtPt.z > dtValue) dtValue = dtPt.z;
	scale2d0 = 400 / dtValue;
	//scale2d0 = 1600;
	scale2dStep =  scale2d0 / 100;
    
    
	if (0) {
		Make3D _3d2;
		_3d2.MakeCurve(func2);
		Point3D offset;
		offset.SetPt(200,200,200,0);
		_3d2.Offset3D(offset);
		
		data_3d.Append3D(&_3d2);
	}
	
	Point2D displayCenter2D(300,300);
    
	/*
     //
     //GetPort(&myPort);
     Rect portRect;
     GetPortBounds(localPort,&portRect);
     
     Rect srcRect = portRect;
     GWorldPtr myGWorld;
     OSErr theErr = NewGWorld(&myGWorld,32,&srcRect,0,0,0);
     
     SetPort(myGWorld);
     const BitMap *srcBits = GetPortBitMapForCopyBits(myGWorld);
     PixMap ** pixel = (PixMap **)srcBits->baseAddr;
     LockPixels(pixel);
     */
    long width = 400;
    long rowBytes = width * 4;
    long height = 400;
    long theSize = rowBytes * height;
	char *buff = (char*)malloc(theSize);//GetPixBaseAddr(pixel);//(char*)malloc(theSize);
    
    
	//long wide = portRect.right;
	//long high = portRect.bottom;
    
	//long rowBytes = GetPixRowBytes(pixel);
    
	//long theSize = high*rowBytes;;
	
	//memset(buff,theSize,0);
	
    
    //	unsigned long ticks = TickCount();
	//char first1 = 1;
    
	//while (1)
	//for (double i=0;i<360;i += 1)
	//{
    //float random = fabs((Random() / 16384));
    //char doit = WaitKey();
    //if (doit == 2) break;
    //if (not doit) {
    //	if (not first1) continue;
    //	first1 = 0;
    //	float hhr = fabs((Random() / 4096)) + 5;
    //	float vvr = fabs((Random() / 4096)) + 3;
    //("hhr %f, vvr %f\n",hhr,vvr);
    //	degree_h += hhr;
    //	degree_v +=  vvr;
    
    
    if (degree_h >= 360) degree_h -=360;
    //} else {
    //ticks = TickCount();
    //}
    Plane plane(buff,rowBytes,width,height);
    Point3D upperEyePt;
    Point3D theEyePt;
    Point3D theSpotPt;
    
    theEyePt = ArcTo3D(degree_v *pi/180,degree_h *pi/180,viewDistance); //眼睛
    theSpotPt = ArcTo3D(degree_v *pi/180,(degree_h+60) *pi/180,viewDistance);	//光源
    upperEyePt = ArcTo3D((degree_v-45) *pi/180,degree_h *pi/180,viewDistance); //指定「上下左右」
    
    
    Rotate3Dto2D view3d(theEyePt, upperEyePt, displayCenter2D, upSideDown);
    view3d.SetScale(scale2d0,scale2d0); //scale2d0
    Point3D viewCenter;
    CalculateViewCenter(&viewCenter,centerScreen,theEyePt);
    view3d.SetTargetCenter(viewCenter);
   
    
    //long tickn = (TickCount()-ticks);
    switch (doPlot) {
        case iNone:
            break;
        case iPlot3d:
            view3d.Plot3D(data_3d,&plane);
            break;
        case iPlotSurface:
        {
            Rotate3Dto2D spot3d(theSpotPt, upperEyePt, displayCenter2D,upSideDown); // 光源
            spot3d.SetScale(scale2d0,scale2d0); //scale2d0
            spot3d.SetTargetCenter(viewCenter);
            char testSpeed = 0;
            if (testSpeed) {
                
                for (long k = 0;k<=3;k++) {
                    
                    lineCount = 0;
                    long countTotal = plane.Fill3DSurface(data_3d,view3d,k);
                    (void)countTotal;
                    
                    
                }
            } else {
                rotate3DFast = 1;
                
                long countTotal = plane.Fill3DSurface(data_3d,view3d,3);
                (void)countTotal;
                
            }
        }
            break;
    }
    
    
    
    
    
    
    //const BitMap *targetBits = GetPortBitMapForCopyBits(localPort);
    
    //SetPort(localPort);
    //unsigned long ticker = TickCount();
    //long loop = 200;
    //for (long i=0;i<loop;i++) {
    //	CopyBits(srcBits,targetBits, &srcRect, &portRect,0,0); // copy bits from offset screen to window on screen
    
    //}
    //ticker = TickCount() - ticker;
    //printf("copybit loop %d , ticks %d\n",loop,ticker);
    //MoveTo(portRect.left+5,portRect.bottom-20);
    //DrawString("\p scale:q/w, zoom:a/z, rotate:arrow key, upSideDown:1/2, stop: s");
    //SetPort(myGWorld);
    
    //unsigned long ticks;Delay(1,&ticks);
    //if (Button()) Debugger();
	//}
    
	//ticks = TickCount() - ticks;
	//printf("ticks second = %d\n",ticks / 60);
}



void Test3d()
{
	void Test3d3();
	void Test3d2();
	
	Test3d2() ;
}


void Make3D::Offset3D(Point3D &pt)
{
	for (long i=0;i<countPt;i++) {
		for (long j=0;j<3;j++) {
			data[i].pt[j].x += pt.x;
			data[i].pt[j].y += pt.y;
			data[i].pt[j].z += pt.z;
		}
	}
}


void Make3D::Append3D(Make3D *next1)
{
	long newCount = countPt + next1->countPt;
	Triangle *newData = (Triangle *)malloc(newCount * sizeof(Triangle));
	if (newData == 0) {
		Debugger();
	} else {
		long theSize = countPt * sizeof(Triangle);
		memcpy(newData,data,theSize);
		memcpy((char*)newData  + theSize,next1->data,next1->countPt * sizeof(Triangle));
		//delete data;
		free(data);
		data = newData;
		countPt += next1->countPt;
	}
}

Graph2D::Graph2D()
{
	G2DAngle(0);
	valid = 0;
}


Graph2D::Graph2D(double ang)
{
	G2DAngle(ang);
}

void Graph2D::G2DAngle(double ang)
{
	double pi1= pi * ang/180;
	
	rt_cos = cos(pi1);
	rt_sin = sin(pi1);
	valid = 1;
	
}

Point3D &Point3D::operator=(Point3D next)
{
	x = next.x;
	y = next.y;
	z = next.z;
	flags = next.flags;
	return *this;
}

Point3D &Point3D::operator+=(Point3D next)
{
	x += next.x;
	y += next.y;
	z += next.z;
	return *this;
}

Point3D &Point3D::operator-=(Point3D next)
{
	x -= next.x;
	y -= next.y;
	z -= next.z;
	return *this;
}

Point3D Point3D::operator+(Point3D next)
{
	Point3D n1;
	n1.x = x + next.x;
	n1.y = y + next.y;
	n1.z = z + next.z;
	return n1;
}

Point3D Point3D::operator-(Point3D next)
{
	Point3D n1;
	n1.x = x - next.x;
	n1.y = y - next.y;
	n1.z = z - next.z;
	return n1;
}

Point3D Point3D::operator/(double value)
{
	Point3D n1;
	n1.x = x / value;
	n1.y = y / value;
	n1.z = z / value;
	return n1;
}
Point3D Point3D::operator*(double value)
{
	Point3D n1;
	n1.x = x * value;
	n1.y = y * value;
	n1.z = z * value;
	
	return n1;
}

void Point3D::SetPt(double x1,double y1,double z1,char plot1)
{
	flags = plot1;
	x = x1;
	y = y1;
	z = z1;
}


/*  Subroutine to calculate the sum of the nonrational basis functions (see \eq {6--87}).

    C code for An Introduction to NURBS
    by David F. Rogers. Copyright (C) 2000 David F. Rogers,
    All rights reserved.
    
    Name: sumrbas.c
    Language: C
    Subroutines called: none
    Book reference: Chapter 7, Section 7.1, Alg. p.309
    
    b[]         = array containing the polygon net points
                    b[1] = x-component
                    b[2] = y-component
                    b[3] = z-component
                    b[4] = homogeneous coordinate weighting factor
                    Note: Bi,j = b[] has dimensions of n*m x 4 with j varying fastest
                     The polygon net is n x m
    mbasis[,]  = array containing the nonrational basis functions for one value of w
    mpts       = the number of polygon vertices in w direction
    nbasis[,]  = array containing the nonrational basis functions for one value of u
    npts       = the number of polygon vertices in u direction
    sum        = sum of the basis functions
*/

float sumrbas(float*b,float*nbasis,float*mbasis,int npts,int mpts)
/*
int npts,mpts;
    
float b[],nbasis[],mbasis[];
*/
{

    int i,j,jbas,j1;
    float sum;
    
 /* calculate the sum */

    sum = 0;
/*    printf("npts,mpts %d %d \n", npts,mpts);*/

    for (i = 1; i <= npts; i++){
        if (nbasis[i] != 0.){
            jbas = 4*mpts*(i-1);
            for (j = 1; j <= mpts; j++){
/*                printf("i,j,jbas %d %d %d \n",i,j,jbas);*/
                if (mbasis[j] != 0.){
                    j1 = jbas + 4*(j-1) + 4;
/*                    printf("in sumrbas j1 = %d \n",j1);*/
                    sum = sum + b[j1]*nbasis[i]*mbasis[j];
                }
            }
        }
    }
    return(sum);
}

/*  Subroutine to generate B-spline basis functions for open knot vectors

    C code for An Introduction to NURBS
    by David F. Rogers. Copyright (C) 2000 David F. Rogers,
    All rights reserved.
    
    Name: basis.c
    Language: C
    Subroutines called: none
    Book reference: p. 279

    c        = order of the B-spline basis function
    d        = first term of the basis function recursion relation
    e        = second term of the basis function recursion relation
    npts     = number of defining polygon vertices
    n[]      = array containing the basis functions
               n[1] contains the basis function associated with B1 etc.
    nplusc   = constant -- npts + c -- maximum number of knot values
    t        = parameter value
    temp[]   = temporary array
    x[]      = knot vector
*/

//#include     <stdio.h>

void basis(int c,float t,int npts,int *x,float*n)
/*
int c,npts;
int x[];
float t;
float n[];
*/
{
    int nplusc;
    int i,k;
    float d,e;
    float temp[36];

    nplusc = npts + c;

/*        printf("knot vector is \n");
        for (i = 1; i <= nplusc; i++){
            printf(" %d %d \n", i,x[i]);
        }
        printf("t is %f \n", t);
*/

/* calculate the first order basis functions n[i][1]    */

    for (i = 1; i<= nplusc-1; i++){
        if (( t >= x[i]) && (t < x[i+1]))
            temp[i] = 1;
        else
            temp[i] = 0;
    }

/* calculate the higher order basis functions */

    for (k = 2; k <= c; k++){
        for (i = 1; i <= nplusc-k; i++){
            if (temp[i] != 0)    /* if the lower order basis function is zero skip the calculation */
                   d = ((t-x[i])*temp[i])/(x[i+k-1]-x[i]);
            else
                d = 0;

            if (temp[i+1] != 0)     /* if the lower order basis function is zero skip the calculation */
                e = ((x[i+k]-t)*temp[i+1])/(x[i+k]-x[i+1]);
            else
                e = 0;

            temp[i] = d + e;
        }
    }

    if (t == (float)x[nplusc]){        /*    pick up last point    */
         temp[npts] = 1;
    }

/* put in n array    */

    for (i = 1; i <= npts; i++) {
        n[i] = temp[i];
    }
}


/*
    Subroutine to generate a B-spline open knot vector with multiplicity
    equal to the order at the ends.
    
    c            = order of the basis function
    n            = the number of defining polygon vertices
    nplus2       = index of x() for the first occurence of the maximum knot vector value
    nplusc       = maximum value of the knot vector -- $n + c$
    x()          = array containing the knot vector
*/

void knot(int n,int c,int *x)

//int n,c;
//int x[];

{
    int nplusc,nplus2,i;

    nplusc = n + c;
    nplus2 = n + 2;

    x[1] = 0;
        for (i = 2; i <= nplusc; i++){
            if ( (i > c) && (i < nplus2) )
                x[i] = x[i-1] + 1;
        else
                x[i] = x[i-1];
        }
}


/*
    C code from An Introduction to NURBS
    by David F. Rogers. Copyright (C) 2000 David F. Rogers,
    All rights reserved.

    Book reference: Chapter 7, Section 7.10, p. 248

    name: rbsurf.c
 
    programmer: David F. Rogers
 
    date: 25 December 1989, modified 16 April 1990 and July 2000
 
    history: Developed from the algorithm in MECG 2nd and the original
             Fortran algorithm called bsurf.for (See the ICCAS'82 paper
             by Rogers and Satterfield). Modified for correct incremental
             calculation of change in homogeneous coordinate (see the
             Rogers and Adlum paper in the Bezier 80th birthday issue
             of CAD.
 
    language: C
 
    purpose:  Subroutine to calculate a Cartesian product rational B-spline
              surface using open uniform knot vectors.
 
    method: During the first pass through the algorithm calculate and
            hold basis and sum function in arrays. Subsequent passes
            do not require recalculation of these functions.
 
            Use an incremental method to recalculate the surface while
            a single defining net point or homogeneous weight is changed
            dynamically.
 
            Note: this routine is 20 times faster than that in the
            pseudocode in the book.
 
 
    subroutines called: basis.c, knot.c, sumrbas.c
 
    header files: rbsurf.h
 
    variable list:
 
    b[]         = array containing the polygon net points
                  b[1] = x-component
                  b[2] = y-component
                  b[3] = z-component
                  b[4] = h-component
                  Note: Bi,j = b[] has dimensions of n*m*3 with j varying fastest
                        The polygon net is n x m
    itest       = value indicating whether the surface set-up parameters changed
                  p_itest = a pointer to itest
    k           = order in the u direction
    l           = order in the w direction
    mbasis[]    = array containing the nonrational basis functions for one value of w (see \eq{5--84})
                  it has dimensions of mpts
    mjlw[]      = array containing the nonrational basis functions for all values of w (see \eq{5--84})
                  it has dimensions of p2*mpts
    mpts        = the number of polygon vertices in w direction
    nbasis[]    = array containing the nonrational basis functions for one value of u (see \eq{5--84})
                  it has dimensions of npts
    niku[]      = array containing the nonrational basis functions all values of u (see \eq{5--84})
                  it has dimensions of p1*npts
    npts        = the number of polygon vertices in u direction
    p1          = number of parametric lines in the u direction
    p2          = number of parametric lines in the w direction
    q[]         = array containing the resulting surface
                  q[1] = x-component
                  q[2] = y-component
                  q[3] = z-component
                       for a fixed value of u the next m elements contain
                       the values for the curve q[u[sub i],w] q has dimensions
                       of p1*p2*3. The display surface is p1 x p2
    rsumij[i3] = array containing all the sum values for all u,w. it has
                 dimensions of p1*p2
 
                 Note: the BSSD program should be set up to allow 6th order
                 rational B-splines is both u and w. The maximum values of
                 the appropriate parameters should be
                     npts =  50 ... max number of net points in the u direction
                     mpts =  20 ... max number of net points in the w direction
                     p1   = 150 ... max number of parametric lines in the u direction
                     p2   =  60 ... max number of parametric lines in the w direction
                     k    =   6 ... max order in the u direction
                     l    =   6 ... max order in the w direction
                 Since the zeroth element of the array is ignored 1 must be
                 added to all array dimensions. Thus q[27001], b[4001],
                 nbasis[51],mbasis[21],niku[7501],mulw[1201],rsumij[9001],
                 x[57],y[27]
*/
 
//#include <stdio.h>
//#include <stdlib.h>

#include "rbsurf.h"
void Debugger();
 
 float sumrbas(float*b,float*nbasis,float*mbasis,int npts,int mpts);
 void basis(int c,float t,int npts,int *x,float*n);
 
void rbsurf(float *b,int k,int l,int npts,int mpts,int p1,int p2,int *p_itest,int ibnum,float*bold,
        float*niku,float*mjlw,float*rsumij,float*savrsumij,float*q)
 /*
int k,l;
int npts,mpts;
int p1,p2;
int *p_itest;
int ibnum;
 
float b[],q[];
float bold[];
float niku[];
float mjlw[];
float rsumij[];
float savrsumij[];
 */
{
 
/*   allows for 20 data points with basis function of order 5 */
 
    int i,ibas,j,j1,jbas;
    int icount,scount,tcount,i1,i2,i3;
    int uinc,winc;
    int ninc,minc;
    int nplusc,mplusc;
    int iindex,jindex;
//    int x[30],y[30];
 
   // float nbasis[30],mbasis[30];
    float pbasis;
    float sum;//,sumrbas();
    float u,w;
    float stepu,stepw;
    float bx,by,bz,bh;
    float sumnew,sumold,sumratio;
 
/*  int stack_probe;
    fprintf(stderr, "rbsurf:\t\t&stack_probe = %lu\n", (long)&stack_probe); */
/*
    printf("in rbsurf.c \n");
*/
    nplusc = npts + k;
    mplusc = mpts + l;
/*
    check if a new surface needs to be generated.
     
    itest must be equal to zero initially to get the first surface.  If the
    number of net points, the order, or the number of parametric lines
    change in either the u or w parametric directions then a new surface
    must be generated. Otherwise the basis functions and the summation
    functions do not change when a defining polygon vertex is moved. When a
    homogeneous weight factor is changed the sum function must also be
    recalculated. However, the non-rational basis functions need not be
    recalculated. The assumption is that only one thing will change at a
    time. itest is a measure of the change.  If this is not the case then
    the calling program must force itest to zero to correctly generate the
    surface.
*/
    float *mbasis = (float*)malloc(sizeof(float) * (mpts + 1));
 float *nbasis = (float*)malloc(sizeof(float) * (npts + 1));
 int *y = (int*)malloc(sizeof(int) * (mplusc + 1));
 int*x = (int*)malloc(sizeof(int)* (nplusc + 1));
 
    if (*p_itest != (nplusc + mplusc + p1 + p2)){
/*
    printf("calculating basis sum functions \n");
*/
/*  zero the arrays */
     
        for (i = 1; i <= nplusc; i++){
            x[i] = 0.;
        }
        
        for (i = 1; i <= mplusc; i++){
            y[i] = 0.;
        }
        
        for (i = 1; i <= npts; i++){
            nbasis[i] = 0.;
        }
        
        for (i = 1; i <= mpts; i++){
            mbasis[i] = 0.;
        }
 
/*   generate the open uniform knot vectors */
 
        knot(npts,k,x);       /*  calculate u knot vector */
        knot(mpts,l,y);       /*  calculate w knot vector */
 
/*
        printf("u-knot vector = ");
        for (i = 1; i <= nplusc; i++){
            printf("  %d",x[i]);
        }
        printf("\n\n");
 
        printf("w-knot vector = ");
        for (i = 1; i <= mplusc; i++){
            printf("  %d",y[i]);
        }
        printf("\n\n");
*/
        icount = 1;
 
/*  calculate and store the basis functions */
 
        stepu = (float)x[nplusc]/(float)(p1-1);
        stepw = (float)y[mplusc]/(float)(p2-1);
/*
        printf("stepu = %f \n",stepu);
        printf("stepw = %f \n\n",stepw);
*/
        i1 = 1;
        i2 = 1;
        i3 = 1;
 
/*  calculate the Nik's at each u parametric value */
 
        u = 0.;
        for (uinc = 1; uinc <= p1; uinc++){
            if ((float)x[nplusc] - u < 5e-6){
                u = (float)x[nplusc];
            }
            basis(k,u,npts,x,nbasis);    /* basis function for this value of u */
/*
            printf("basis function for u = %f",u);
            for (i = 1; i <= npts; i++){
                printf("  %f",nbasis[i]);
            }
            printf("\n");
*/
            for (i = 1; i <= npts; i++){
                niku[i1] = nbasis[i];
                i1 = i1 + 1;
            }
            u = u + stepu;
        }
/*
        printf("\nu-basis functions\n\n");
        printf("I1,p1,npts = %d %d %d \n",i1-1, p1, npts);
 
        for (i = 1; i <= p1; i++){
            for (j = 1; j <= npts; j++){
                printf(" %f ",niku[(i-1)*npts + j]);
            }
            printf("\n");
        }
        printf("\n");
*/
 
/*
        getchar();
*/
 
/*  calculate the Mjl's at each w parametric value */
 
        w = 0.;
        for (winc = 1; winc <= p2; winc++){
            if ((float)y[mplusc] - w < 5e-6){
                w = (float)y[mplusc];
            }
            basis(l,w,mpts,y,mbasis);    /* basis function for this value of w */
/*
            printf("basis function for w = %f",w);
            for (i = 1; i <= mpts; i++){
                printf("  %f",mbasis[i]);
            }
            printf("\n");
*/
            for (j = 1; j <= mpts; j++){
                mjlw[i2] = mbasis[j];
                i2 = i2 + 1;
            }
            w = w + stepw;
        }
/*
        printf("\nw-basis functions\n\n");
        printf("I2 = %d \n",i2-1);
 
        for (i = 1; i <= p2; i++){
            for (j = 1; j <= mpts; j++){
            printf(" %f ",mjlw[(i-1)*mpts + j]);
            }
            printf("\n");
        }
        printf("\n");
*/
 
/*
        getchar();
*/
 
/*  calculate the sum function at each parametric value */
 
        for (uinc = 1; uinc <= p1; uinc++){
            for (i = 1; i <= npts; i++){
                ibas = (uinc-1)*npts + i;
                nbasis[i] = niku[ibas];
            }
            for (winc = 1; winc <= p2; winc++){
                for (j = 1; j <=   mpts /*p2*/  ; j++){
                    jbas = (winc-1)*mpts + j;
                    mbasis[j] = mjlw[jbas];
                }
                sum = sumrbas(b,nbasis,mbasis,npts,mpts);
/*              printf("returned from sumrbas. uinc, winc, u,w, sum = %d %d %f %f %f \n",uinc, winc, u,w,sum);*/
                if (sum is 0.){
                    printf("Error - Sum of the basis functions = 0 This is most likely caused\n");
                    printf("by all zero homogeneous weighting factors. Program stops.\n");
                   Debugger(); //exit(0);
                }
                rsumij[i3] = (1/sum);
                i3 = i3 + 1;
            }
        }
/*
        printf("\nsum function\n\n");
        printf("I3 = %d \n",i3-1);
 
        for (j = 1; j <= p2; j++){
            for (i = 1; i <= p1; i++){
                printf(" %f ",rsumij[(j-1)*p1 + i]);
            }
            printf("\n");
        }
        printf("\n\n");
*/
        *p_itest = 0;
        }

    free(nbasis);
    free(mbasis);
    free(x);
    free(y);
    
 
/*  generate the complete rational B-spline surface */
 
    if (*p_itest is 0){             /* is is equivalent to ==  see rbsurf.h */
/*
        printf("calculating complete surface\n\n");
*/
        for (i = 1; i <= 3*p1*p2; i++){
            q[i] = 0.;
        }
 
        icount = 1;
    
        for (uinc = 1; uinc <= p1; uinc++){
            for (winc = 1; winc <= p2; winc++){
                scount = (uinc-1)*p2 + winc;
                for (i = 1; i <= npts; i++){
                    jbas = 4*mpts*(i-1);
                    ninc = (uinc-1)*npts + i;
                    if (niku[ninc] != 0.){
                        for (j = 1; j <= mpts; j++){
                            j1 = jbas +4*(j-1) + 1;
                            minc = (winc-1)*mpts + j;
                            if (mjlw[minc] !=0.){
                                pbasis = b[j1+3]*niku[ninc]*mjlw[minc]*rsumij[scount];
                                q[icount] = q[icount]+b[j1]*pbasis;  /* calculate surface point */
                                q[icount+1] = q[icount+1]+b[j1+1]*pbasis;
                                q[icount+2] = q[icount+2]+b[j1+2]*pbasis;
/*
                                printf("uinc,winc,i,jbas,ninc,j,j1,minc,scount\n");
                                printf("%d %d %d %d %d %d %d %d %d \n",uinc,winc,i,jbas,ninc,j,j1,minc,scount);
                                printf("niku[ninc],mjlw[minc],rsumij[scount],pbasis\n");
                                printf("%f %f %f %f \n\n",niku[ninc],mjlw[minc],rsumij[scount],pbasis);
                                printf("building surface %f %f %f \n\n",q[icount],q[icount+1],q[icount+2]);
*/
                            }
                        }
                    }
                }
/*              printf("surface point %d %d %f %f %f \n\n",uinc,winc,q[icount],q[icount+1],q[icount+2]);*/
                icount = icount + 3;
             }
        }
        *p_itest = nplusc + mplusc + p1 + p2;
        return;
    }
 
 
/*  calculate the incremental change to the surface */
 
        bx = b[ibnum] - bold[1];
        by = b[ibnum+1] - bold[2];
        bz = b[ibnum+2] - bold[3];
        bh = b[ibnum+3] - bold[4];
 
    if ((bx != 0.) || (by != 0.) || (bz != 0.) || (bh != 0.)){
 
/*  if true surface unchanged -- no calculation is needed
    if not true surface has changed -- do incremental calculation */
 
 
/*  printf("calculating incemental change -- bold,bx, by, bz, bh = \n %f %f %f %f %f %f %f %f \n",bold[1],bold[2],bold[3],bold[4],bx,by,bz,bh);*/
 
 
/*  calculate the i,j index for Bij from ibnum, where ibnum is
    assumed to be the lineal number of the x-component of Bij      */
 
        iindex = (ibnum/4/mpts) + 1;     /* depends on integer arithmatic to work */
        jindex=(ibnum-4*mpts*(iindex-1))/4 + 1;
 
/*  printf("ibnum,iindex,jindex %d %d %d \n",ibnum,iindex,jindex);*/
 
/*  for the special case of the homogeneous weighting factor changing
    the sum function must be recalculated for each value of u,w        */
 
    if (bh != 0.){
/*
        printf("save the old sum function \n");
*/
        for (i1 = 1; i1 <= p1*p2; i1++){
            savrsumij[i1] = rsumij[i1];
        }
/*
        printf("\nthe save sum function is \n\n");
 
        for (j = 1; j <= p2; j++){
                        for (i = 1; i <= p1; i++){
                                printf(" %f ",savrsumij[(j-1)*p1+i]);
                        }
                        printf("\n");
                        }
                printf("\n");
*/
 
/*
        printf("calculating new sum function \n");
*/
                tcount = 1;
        for (uinc = 1; uinc <= p1; uinc++){
            ninc = (uinc -1)*npts + iindex;
            for (winc = 1; winc <= p2; winc++){
                minc = (winc-1)*mpts + jindex;
/*
                printf("tcount, rsumij[tcount] = %d %f \n",tcount,rsumij[tcount]);
                printf("uinc,winc,ninc,niku[ninc],minc,mjlw[minc] = \n %d %d %d %f %d %f \n",uinc,winc,ninc,niku[ninc],minc,mjlw[minc]);
*/
                if ((niku[ninc] != 0.) && (mjlw[minc] != 0.)){
                    sumold = 1./(rsumij[tcount]);
                    sumnew = sumold + niku[ninc]*mjlw[minc]*(b[ibnum+3]-bold[4]);
                    rsumij[tcount] = 1./sumnew;
                }
/*
                printf("tcount,sumold,sumnew,rsumij = %d %f %f %f \n", tcount,sumold,sumnew,rsumij[tcount]);
*/
                tcount = tcount + 1;
            }
        }
    }
/*
    printf("\nsum function after incremental change \n\n");
 
    for (j = 1; j <= p2; j++){
        for (i = 1; i <= p1; i++){
            printf(" %f ",rsumij[(j-1)*p1+i]);
        }
        printf("\n");
    }
    printf("\n");
*/
 
/*  calculate the change in the surface for each u,w */
/*
        printf("incremental surface calculation \n\n");
*/
        icount = 1;
        for (uinc = 1; uinc <= p1; uinc++){
            ninc = (uinc -1)*npts + iindex;
            if (niku[ninc] != 0.){
                for (winc = 1; winc <= p2; winc++){
                    minc = (winc-1)*mpts + jindex;
                    if (mjlw[minc] !=0.){
                        scount = (uinc-1)*p2 + winc;
                        if (bh is 0.){
/*                          printf("space coordinate changed \n\n");*/
                            pbasis = b[ibnum+3]*niku[ninc]*mjlw[minc]*rsumij[scount];
/*
                            printf("uinc,winc,ninc,niku[ninc],minc,mjlw[minc] = %d %d %d %f %d %f \n",uinc,winc,ninc,niku[ninc],minc,mjlw[minc]);
                            printf("scount,rsumij[scount],pbasis = %d %f %f \n",scount,rsumij[scount],pbasis);
*/
                            q[icount] = q[icount]+bx*pbasis;  /* calculate surface point */
                            q[icount+1] = q[icount+1]+by*pbasis;
                            q[icount+2] = q[icount+2]+bz*pbasis;
/*
                            printf("icount, qx qy qz = %d %f %f %f \n",icount,q[icount],q[icount+1],q[icount+2]);
*/
                        }
                        else{
/*
                            printf("homogeneous coordinate changed \n\n");
*/
                            pbasis = niku[ninc]*mjlw[minc]*rsumij[scount];
                            sumratio = rsumij[scount]/savrsumij[scount];
/*
                            printf("uinc,winc,ninc,niku[ninc],minc,mjlw[minc] = %d %d %d %f %d %f \n",uinc,winc,ninc,niku[ninc],minc,mjlw[minc]);
                            printf("scount,savrsumij[scount],rsumij[scount],pbasis = %d %f %f %f \n",scount,savrsumij[scount],rsumij[scount],pbasis);
*/
                            q[icount] = q[icount]*sumratio+bh*b[ibnum]*pbasis;  /* calculate surface point */
                            q[icount+1] = q[icount+1]*sumratio+bh*b[ibnum+1]*pbasis;
                            q[icount+2] = q[icount+2]*sumratio+bh*b[ibnum+2]*pbasis;
/*
                            printf("icount, qx qy qz = %d %f %f %f \n",icount,q[icount],q[icount+1],q[icount+2]);
*/
                        }
                    }
                    icount = icount + 3;
                }
            }
            else{
                icount = icount + 3*p2;
            }
        }
    }
    bold[1] = b[ibnum];
    bold[2] = b[ibnum+1];
    bold[3] = b[ibnum+2];
    bold[4] = b[ibnum+3];
}


//http://www.nar-associates.com/nurbs/c_code.html

/*
    Test program for C code from An Introduction to NURBS
    by David F. Rogers. Copyright (C) 2000 David F. Rogers,
    All rights reserved.
    
    Name: trbsurf.c
    Purpose: Test the fast rational B-spline surface generator.

    Language: C
    Subroutines called: rbsurf.c sumrbas.c knot.c basis.c
    Book reference:

*/

//#include <stdio.h>
//#include <stdlib.h>
//#include "rotate.h"

/* #include "rbsurf.h"*/
void rbsurf(float *b,int k,int l,int npts,int mpts,int p1,int p2,int *p_itest,int ibnum,float*bold,
        float*niku,float*mjlw,float*rsumij,float*savrsumij,float*q);

void Make3D::test_fast_nurbs()
{

    int i;//,i1,i2;
    int npts,mpts;
    int k,l;
    int p1,p2;
    int itest;
    int ibnum;
    int plusminus;

//    int ch;
    
    static float b[81];
 //   static float q[126];
   // static float niku[126];
  //  static float mjlw[126];
  //  static float rsumij[126];
  //  static float savrsumij[126];
   float bold[5];

    float change;

//    int stack_probe;
/*  fprintf(stderr, "main:\t\t&stack_probe = %lu\n", (long)&stack_probe); */
    fflush(stderr);

/*  set net and surface parameters */

    npts = 5;     /* use npts = 5 for asymmetrical testing -- see below */
    mpts = 4;
    k = 3;
    l = 3;

     p1 = 50;
    p2 = 50;
    float *q = (float*) calloc(sizeof(float) , 3*p1*p2 + 1); // the buffer must be clear ,so we use calloc() instead of malloc()

    itest = 0;    /* set to zero to get full surface calculation on 1st pass */

/*  printf("k,l,npts,mpts,p1,p2 = %d %d %d %d %d %d \n",k,l,npts,mpts,p1,p2);*/

/*  zero arrays */

    for (i = 1; i <= 4*npts; i++){
            b[i] = 0.;
        }

    for (i = 1; i <= 3*p1*p2; i++){
        q[i] = 0.;
    }
    float *niku = (float *)malloc(sizeof(float) * (npts * p1 + 1));
    for (i = 1; i <= npts*p1; i++){
        niku[i] = 0.;
    }
    float *mjlw = (float *)malloc(sizeof(float) *(mpts*p2 + 1));
    for (i = 1; i <= mpts*p2; i++){
        mjlw[i] = 0.;
    }
    float *rsumij = (float*) malloc(sizeof(float) * (p1*p2 + 1));
    float *savrsumij = (float*) malloc(sizeof(float) * (p1*p2 + 1));
    for (i = 1; i <= p1*p2; i++){
        rsumij[i] = 1.;
        savrsumij[i] = 1.;
    }

/*  define polygon net */

    b[1] = -15.;
    b[2] = 0.;
    b[3] = 15.;
    b[4] = 1;
    b[5] = -15.;
    b[6] = 5.;
    b[7] = 5.;
    b[8] = 1;
    b[9] = -15.;
    b[10] = 5.;
    b[11] = -5.;
    b[12] = 1;
    b[13] = -15.;
    b[14] = 0.;
    b[15] = -15.;
    b[16] = 1;//x

    b[17] = -5.;
    b[18] = 5.;
    b[19] = 15.; //x
    b[20] = 1;
    b[21] = -5.;
    b[22] = 10.;//x
    b[23] = 50.;
    b[24] = 1;
    b[25] = -5.;//x
    b[26] = -30.;
    b[27] = -5.;
    b[28] = 1;//x
    b[29] = -5.;
    b[30] = 5.;
    b[31] = -15.;//x
    b[32] = 1;

    b[33] = 5.;
    b[34] = 5.;
    b[35] = 15.;
    b[36] = 1;
    b[37] = 5.;
    b[38] = 10.;
    b[39] = 5.;
    b[40] = 1;
    b[41] = 5.;
    b[42] = 10.;
    b[43] = -5.;
    b[44] = 1;
    b[45] = 5.;
    b[46] = 0.;
    b[47] = -15.;
    b[48] = 1;

    b[49] = 15.;
    b[50] = 0.;
    b[51] = 15.;
    b[52] = 1;
    b[53] = 15.;
    b[54] = 5.;
    b[55] = 5.;
    b[56] = 1;
    b[57] = 15.;
    b[58] = 5.;
    b[59] = -5.;
    b[60] = 1;
    b[61] = 15.;
    b[62] = 0.;
    b[63] = -15.;
    b[64] = 1;

/*  change n1 to 5 and uncomment the b[] assignments below
    to get a 5 x 4 polygon for asymmetrical testing */


    b[65] = 15.;
    b[66] = 0.;
    b[67] = 15.;
    b[68] = 1;
    b[69] = 15.;
    b[70] = -5.;
    b[71] = 5.;
    b[72] = 1;
    b[73] = 15.;
    b[74] = -5.;
    b[75] = -5.;
    b[76] = 1;
    b[77] = 15.;
    b[78] = -5.;
    b[79] = -15.;
    b[80] = 1;

//    printf("\nPress Enter to start the timing. You need to use a stop watch.");
//    ch=getchar();

/*  To generate single surface uncomment the next line and comment out
    all the statements below the next except the last } labelled end main.
*/

/*  rbsurf(b,k,l,npts,mpts,p1,p2,&itest,ibnum,bold,niku,mjlw,rsumij,savrsumij,q); */

//    printf("start\n\n");

/*  generate multiple surfaces for checking incremental calculation and timing */

    plusminus = 1;
    change = 4;
    long varient  = 2; //varient may be cahnge to 30000? what does it mean?
    for (i = 1; i<varient; i++){
/*        printf("i = %d \n",i); */
        rbsurf(b,k,l,npts,mpts,p1,p2,&itest,ibnum,bold,niku,mjlw,rsumij,savrsumij,q);
           ibnum = 21;
           if (i == 1.){              /* assign bold after first pass */
               bold[1] = b[ibnum];
               bold[2] = b[ibnum+1];
               bold[3] = b[ibnum+2];
               bold[4] = b[ibnum+3];
/*             printf("i = %d and bold = %f %f %f \n",i,bold[ibnum],bold[ibnum+1],bold[ibnum+2]); */
           } /* end if */

/*  change the 4 in the for loop above to 10000 or more
    and uncomment the next two lines for timing.
*/

/*
    Uncomment the following two statements to get a valid timing loop
    for a change in the homogeneous weighting factor.
*/

    b[ibnum+3] = b[ibnum+3] + plusminus*change;
    plusminus = -plusminus;
/*    printf("h= %f \n",b[ibnum+3]); */

/*
    Uncomment the following two statements to get a valid timing loop
    for a change in a polygon net vertex.
*/




//    b[ibnum] = - b[ibnum];


    } /* end of main for loop */

//    printf("\ndone");
//    printf("\nPress Enter to list the results of the last calculation.");
//    ch=getchar();

/*  print only the last result */

//    printf("\nPolygon points\n\n");

 //   for (i1 = 1; i1 <= 4*npts*mpts; i1=i1+4){
 //       printf(" %f %f %f %f\n",b[i1],b[i1+1],b[i1+2],b[i1+3]);
//    }

//    printf("\nPress Enter to see the surface points.");
//    ch=getchar();

//    printf("\nSurface points\n\n");

 //   for (i2 = 1; i2 <= 3*p1*p2; i2=i2+3){
  //      printf("%f, %f, %f \n",q[i2],q[i2+1],q[i2+2]);
 //   }
    ConvertTo3DPoint(p1, p2, q);
    free(q);
    free(niku);
    free(mjlw);
    free(rsumij);
    free(savrsumij);

} /* end main */


/*  Subroutine to calculate a \bzr surface (see Eq.(5.3))

    C code for An Introduction to NURBS
    by David F. Rogers. Copyright (C) 2000 David F. Rogers,
    All rights reserved.
    
    Name: bezsurf.c
    Language: C
    Subroutines called: none
    Book reference: p. 299
    
    b(,)  = array containing the polygon vertices
             b(,1) = x-components
             b(,2) = y-components
             b(,3) = z-components
             Note: Bi,j = b(,) has dimensions of n*m x 3 with j varying fastest
     Basis = function to calculate the Bernstein basis value
     Factrl= function to calculate the factorial of a number
     jin   = Bernstein basis function in the u direction (see Eq.(5.2))
     kjm   = Bernstein basis function in the w direction (see Eq.(5.2))
     m     = one less than the number of polygon vertices in w direction
     n     = one less than the number of polygon vertices in u direction
     Ni    = factorial function for the Bernstein basis
     p1    = number of parametric lines in the u direction
     p2    = number of parametric lines in the w direction
     q(,)  = position vectors for points on the surface
             q(,1) = x-components
             q(,2) = y-components
             q(,3) = z-components
                     for a fixed value of u the next m elements contain
                     the values for the curve q(u(sub i),w) q has dimensions
                     of p1*p2 x 3
*/

//#include <stdio.h>


/* function to calculate the factorial */

float factrl(int n)
{
    static int ntop=6;
    static float a[33]={1.0,1.0,2.0,6.0,24.0,120.0,720.0}; /* fill in the first few values */
    int j1;

    if (n < 0) printf("\nNegative factorial in routine FACTRL\n");
    if (n > 32) printf("\nFactorial value too large in routine FACTRL\n");

    while (ntop < n) { /* use the precalulated value for n = 0....6 */
        j1 = ntop++;
        a[n]=a[j1]*ntop;
    }
    return a[n]; /* returns the value n! as a floating point number */
}

/* function to calculate the factorial function for Bernstein basis */

float Ni(int n,int i)
{
    float ni;
    ni = factrl(n)/(factrl(i)*factrl(n-i));
    return ni;
}

/* function to calculate the Bernstein basis */

float Basis(int n,int i,float t)
{
    float basis;
    float ti; /* this is t^i */
    float tni; /* this is (1 - t)^i */

    /* handle the special cases to avoid domain problem with pow */

    if (t==0. && i == 0) ti=1.0; else ti = pow(t,i);
    if (n==i && t==1.) tni=1.0; else tni = pow((1-t),(n-i));
    basis = Ni(n,i)*ti*tni; /* calculate Bernstein basis function */
    return basis;
}

/* Bezier surface subroutine */

void bezsurf(float* b, int n, int m, long p1, long p2, float *q)
/*
int n;
int m;
int p1;
int p2;

float b[];
float q[];
*/
{
    int i;
    int j;
//    int k;
//    int i1;
    int j1;
    int jbas;
    int uinc;
    int winc;
    int icount;
//    int ch;

    float u;
    float w;
    float jin;
    float kjm;
    float stepu;
    float stepw;
    
    float factrl(int);
    float Ni(int,int);
    float Basis(int,int,float);

    icount = 1;
    stepu = 1.0/((float)(p1-1));
    stepw = 1.0/((float)(p2-1));

    u=0.0;
    
    for (uinc = 1; uinc <= p1; uinc++){  /* for fixed u calculate various w's */
        if (1.0 - u < 5e-6) u=1.0; /* fix up the u = 1 value because of float */
        w = 0.0;
        for (winc = 1; winc <= p2; winc++){
            if (1.0 - w < 5e-6) w=1.0; /* fix up the w = 1 value because of float */
            for (i = 0; i <= n; i++){
                jin = Basis(n,i,u); /* Bernstein basis function in the u direction (see Eq.(5.2)) */
                if (jin != 0.){ /* don't bother no contribution */
                    jbas = 3*(m+1)*i; /* column index for lineal array*/
                    for (j = 0; j <= m; j++){
                        kjm = Basis(m,j,w);  /* Bernstein basis function in the w direction (see Eq.(5.2)) */
                        if (kjm !=0.){ /* don't bother no contribution */
                            j1 = jbas + 3*j + 1;
                            q[icount] = q[icount]+b[j1]*jin*kjm; /* calculate the surface points */
                            q[icount+1] = q[icount+1]+b[j1+1]*jin*kjm;
                            q[icount+2] = q[icount+2]+b[j1+2]*jin*kjm;
                        }
                    }
                }
            }
            icount = icount + 3;
            w = w + stepw;
        }
        u = u + stepu;
    }
}
/*
    Test program for C code from An Introduction to NURBS
    by David F. Rogers. Copyright (C) 2000 David F. Rogers,
    All rights reserved.
    
    Name: tbzsurf.c
    Purpose: Test Bezier surface generator
    Language: C
    Subroutines called: bezsurf.c
    Book reference: Chapter 5, Alg. p. 299
*/

 //   #include <stdio.h>
 //   #include <stdlib.h>
 //   #include "rotate.h"
    
void bezsurf(float* b, int n, int m, long p1, long p2, float *q);


    
void Make3D::MakeBezierSerf()
{
    indexv = 40; // p1
    indexh = 40; // p2

//    int i;
    int npts,mpts;
    int n,m;

    float b[61];
    float * surfaceResult = (float*) calloc(sizeof(float) , 3* indexh*indexv + 1); // the buffer must be clear ,so we use calloc() instead of malloc()

/*
    Data for the standard test control net.
    Comment out to use file input.
*/

    npts = 4;
    mpts = 4;
    n = npts-1;
    m = mpts-1;



    //for (i = 1; i <= 3*npts; i++){
    //    b[i] = 0.;
    //}

    //for (i = 1; i <= 3*p1*p2; i++){
    //    q[i] = 0.;
    //}

/*
    This is a standard test control polygon from Ex. 5.3, p. 166
    Comment out to use file input <filename>.pnp
*/

    b[1] = -35.;
    b[2] = 0.;
    b[3] = 25.;
    b[4] = -15.;
    b[5] = 15.;
    b[6] = 5.;
    b[7] = -15.;
    b[8] = 5.;
    b[9] = -5.;
    b[10] = -15.;
    b[11] = 0.;
    b[12] = -15.;

    b[13] = -5.;
    b[14] = 5.;
    b[15] = 35.;
    b[16] = -5.;
    b[17] = 5.;
    b[18] = 5.;
    b[19] = -5.;
    b[20] = 5.;
    b[21] = -5.;
    b[22] = -5.;
    b[23] = 5.;
    b[24] = -15.;

    b[25] = 5.;
    b[26] = 5.;
    b[27] = 15.;//
    b[28] = 5.;
    b[29] = 50.;
    b[30] = 5.;//
    b[31] = 5.;
    b[32] = -50.;
    b[33] = -5.;//
    b[34] = 5.;
    b[35] = 5.;
    b[36] = -15.;//

    b[37] = 15.;
    b[38] = 0.;
    b[39] = 15.;
    b[40] = 15.;
    b[41] = 5.;
    b[42] = 50.;
    b[43] = 15.;
    b[44] = 5.;
    b[45] = -5.;
    b[46] = 15.;
    b[47] = 0.;
    b[48] = -15.;

/*       hdrlen = 80; */

/*
    Uncomment the file input statement below and comment out the standard
    control net data above to use file input.
*/

/*  get polygon netpoint file */

/*     rdpnp(header,&hdrlen,&k,&l,&npts,&mpts,b); */


    bezsurf(b,n,m,indexv,indexh,surfaceResult);


    
    
    
    ConvertTo3DPoint(indexv, indexh, surfaceResult);
    free(surfaceResult);
}
void Make3D::ConvertTo3DPoint(long p1,long p2,float *surfaceResult)
{
    indexv = p1;
    indexh = p2;
    countPt = indexv * indexh;
    Point3D* data2 = (Point3D*)malloc(sizeof(Point3D) * countPt);
    for (long i = 0;i<countPt;i++) {
        data2[i].x = surfaceResult[i*3+1];
        data2[i].y = surfaceResult[i*3+2];
        data2[i].z = surfaceResult[i*3+3];
        data2[i].flags = 0;
    }
    
    
    
    ConvertToSerface(data2);
    free(data2);
}
