#define double float

class Pixel {
public:
    union {
        struct { unsigned char reserved,red,green,blue;} color;
        long pvalue;
    };
};
class Point2D{
public:
    Point2D(double x1=0,double y1=0) {x=x1;y=y1;};
    double x,y;
};

typedef struct {
	short x;
	short y;
	
} Point2Di;

typedef  struct {
	Point2Di  pt[2];
} Point2DPair;

typedef struct {
	short x;
	short y;
	float z;
	char flag;
} Point3Di;

typedef  struct {
	Point3Di  pt[2];
} Point3DPair;

class Point3D {
public:
    //Point3D(){};
    //Point3D(short value);
    //Point3D(double x,double y,double z,char plot = 0);
    Point3D &operator=(Point3D new1);
    Point3D operator+(Point3D next);
    Point3D &operator+=(Point3D next);
    Point3D &operator-=(Point3D next);
    Point3D operator/(double value);
    Point3D operator*(double value);
    void SetPt(double x,double y,double z,char plot = 0);
    Point3D operator-(Point3D next);
    
    double x,y,z; // double
    char flags;
};
enum LeftOrRight {
	iPtAtLeft = 0,
	iPtAtRight = 1
};

class Triangle {
public:
    Triangle();
    Triangle(Point3D &pt1,Point3D &pt2,Point3D &pt3);
    void SetPt(Point3D &pt1,Point3D &pt2,Point3D &pt3);
    Point3D pt[3];
    Point3D fa_vector;
    Point3D averagePt;
    
    double GetSurfaceAngleByView( Point3D eyePt);
    double GetSurfaceAngleByZ();
    void GetFaVector();
};




typedef float ZBUFFER;
class Make3D;
class Rotate3Dto2D;
class Plane {
public:
    Plane() {};
    Plane(char *buff,long rowBytes,long wide,long high);
    ~Plane();
    
    void SetPlane(char *buff,long rowBytes1,long wide,long high);
    virtual void MoveTo(double x,double y);
    virtual void LineTo(double x,double y,char finished);
    void FillTriangle(Point2D pt1,Point2D pt2,Point2D pt3);
    void PairLine(Point2DPair *pp, char byx, short pairNow, double index0,Point2D pt0,Point2D pt1);
    
    void Move3DTo(const Point3Di &);
    void Line3DTo(const Point3Di &);
    void Line3DToH(const Point3Di &pt0,const Point3Di &pt);
    void FillSurfTriangle( Point3Di *pt1, Point3Di * pt2, Point3Di * pt3,double spotAngle,double viewAngle);
    void FillSurfTriangleFast( Point3Di *pt1, Point3Di * pt2, Point3Di * pt3,double spotAngle,double viewAngle);
    
    void Pair3DLine(Point3DPair *pp,  LeftOrRight ptLeftOrRight, long index_d,const Point3Di &pt0,const Point3Di &pt1);
    long Fill3DSurface(Make3D &_3d,Rotate3Dto2D &view3d, long dofilter);
    void FillTriangleFast02Left(Point3Di pt1,Point3Di pt2, Point3Di pt3);
    
    void FillX(Point3Di &plot1, Point3Di &plot2,long pty);
    
    
    char *pixelBuffer;
    ZBUFFER *zBuffer0;
    long fix_mapWide;
    long fix_mapHigh;
    long rowBytes0;
    long high0;
    long wide0;
    long fix_x0;
    long fix_y0;
    double double_z0;
    Pixel eyeAngleColor;
};



typedef void (*MapPointCallBack)(Plane *plane,long ref,Point3D pt,char plot);
class BezierCurve {
public:
    BezierCurve();
    //BezierCurve(BezierCurve next);
    BezierCurve(Point3D *pt_4arrays);
    //Point3D *pt;
    Point3D pt[4];
    BezierCurve &operator+=(BezierCurve next);
    BezierCurve &operator=(BezierCurve next);
    BezierCurve operator*(double value);
    BezierCurve operator/(double value);
    BezierCurve operator+(BezierCurve next);
    BezierCurve operator-(BezierCurve next);
};

class PlotBezier {
public:
    PlotBezier(Plane *plane,long ref,MapPointCallBack);
    
    
    Plane *plane;
    long refCon;
    MapPointCallBack MapPoint;
    
    void doMoveTo(Point3D pt);
    void doLineTo(Point3D pt);
    void Bezier2dn(Point2D *pt,long count);
    
    void Bezier3d(
                  double x0, double y0, double z0,// start point
                  double x1, double y1, double z1, // first control point
                  //	double x2, double y2, double z2, // last control point
                  double x3, double y3 ,double z3 // end point
                  );
    void Bezier3d(
                  double x0, double y0, double z0,// start point
                  double x1, double y1, double z1, // first control point
                  double x2, double y2, double z2, // last control point
                  double x3, double y3 ,double z3 // end point
                  );
    void Bezier3d(Point3D p0,Point3D p1,Point3D p2,Point3D p3);
    //	double x0, double y0, double z0,// start point
    //	double x1, double y1, double z1, // first control point
    //	double x2, double y2, double z2, // last control point
    //	double x3, double y3 ,double z3 // end point
    //	);
    void BezierSurface(BezierCurve &p0,BezierCurve &p1,BezierCurve &p2,BezierCurve &p3);
    void Bezier2d(
                  float x0, float y0, // start point
                  float x1, float y1, // first control point
                  //	const int x2, const int y2, // last control point
                  float x3, float y3  // end point
                  );
    
    void Bezier2d(
                  float x0, float y0, // start point
                  float x1, float y1, // first control point
                  float x2, float y2, // last control point
                  float x3, float y3  // end point
                  );
};

typedef double (*funcx)(double x,double z);

char Pt2Angle(double x1,double y1,double x2,double y2, double *angle0);


class Make3D
{
public:
    Make3D();
    ~Make3D();
    void MakeCurve(funcx func);
    
    void Get3DCenter(Point3D *center,Point3D *ptmax,Point3D*ptmin);
    void Offset3D(Point3D &pt);
    void Append3D(Make3D *next1);
    void Bunny();
    void MakeBezierSerf();
    void ConvertToSerface(Point3D *);
    void ConvertTo3DPoint(long p1,long p2,float *surfaceResult);
    void test_ration_nurbs();
    void test_fast_nurbs();
    
    Triangle *data;
    long countPt;
    long indexv;
    long indexh;
    Point3D pt3max0;// = Point3D(-10000000000,-10000000000,-10000000000,0);
    Point3D pt3min0;// = Point3D(10000000000,10000000000,10000000000,0);
    
};

class Graph2D {
public:
    char valid;
    Graph2D();
    Graph2D(double ang);
    double	rt_cos,  rt_sin;
    
    inline void RotateG2D(double x,double y,double *nx,double *ny)  {
        *nx = x * rt_cos - y * rt_sin ;
        *ny = x * rt_sin + y * rt_cos;
    };
    
    void G2DAngle(double ang);
    
};

class Rotate3Dto2D { //3D轉2D
    
public:
    Rotate3Dto2D(Point3D eye,Point3D upperEyePt,Point2D center2D,double eyeUpRotateDegree0);
    ~Rotate3Dto2D();
    
    Point3D center3D;
    Point3D eyePt;
    Point2D windowCenter;
    double scalex;
    double scaley;
    
    void SetScale(double x,double y) {scalex =x;scaley = y;};
    void Plot2D(double x,double y,char plot,Plane *plane,char finished);
    Point3D rotateEyePt;
    Point3D upperEyePt; //用此來確定「上」下左右，否則在3D空間無法確認方向感。
    double eyeUpRotateDegree;
    char  MapToScreen( Point3D *pt,Point3Di  &pt2);
    Point3D Rotate3D(Point3D pt);
    Graph2D R_byX;
    Graph2D R_byY;
    Graph2D R_byZ;
    double nnzy,nnzx,nnzz;
    double nnxx,nnxy,nnxz;
    double nnyx,nnyy,nnyz;
    void InitRotateByZ();
    void InitRotateByY();
    void InitRotateByX();
    
    
    inline void RotateByX(Point3D pt,Point3D *npt);
    inline void RotateByY (register Point3D pt,register Point3D *npt);
    inline void RotateByZ(Point3D pt,Point3D *npt);
    
    void SetTargetCenter( Point3D center3D0);
    void Plot3D(Make3D &_3d,Plane *);
};

double dabs(double v);
void SwapPoint(Point3D *pt1,Point3D *pt2);
void SwapPoint(Point3Di *pt1,Point3Di *pt2);
//double GetSurfaceAngleByZ(const Point3D &pt1,const Point3D & pt2,const Point3D & pt3);
//double GetSurfaceAngleByView( Point3D eyePt, Point3D &pt1, Point3D & pt2, Point3D & pt3);
void Delay(long time);
enum  {
 	iFillTriangle = 1,
 	iGetSurfaceAngle = 2,
 	iDoMapScreen = 4
 	
};
//long Fill3DSurface(Make3D &_3d,Rotate3DObject &view3d,Rotate3DObject &spot3d, Plane *plane,long DoFilter );

Point3D ArcTo3D(double y_degree_v, double y_degree_h, double r);
void CalculateViewCenter(Point3D *viewCenter,Point3D &centerScreen,Point3D &theEyePt);
double func6(double x,double z);
double func1(double x,double z);
