import Flutter
import UIKit
import Photos

public class Candidate_Plugin : NSObject, FlutterPlugin
{
    public static func register(with registrar: FlutterPluginRegistrar) {
        
    }
    
    public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
        switch (call.method) {
        case "setPaths":
            let dict = call.arguments as? [String: String]
           
            if (plugin0 == nil) {
                plugin0 = MyPlugin();
            }
            plugin0?.setFlutterPaths(dict!)
            //plugin0?.setUpFirst();
            result(true);
            break;
        case "activateOCR":
            result(true); //這裏是在建立camera以前被呼叫，沒有實際作為。
            break;
        case "checkForPermission":
            checkForPermission(result: result)
            break;
        default:
            result(FlutterMethodNotImplemented)
        }
    }
    
    private func checkForPermission(result: @escaping FlutterResult)-> Void {
        checkForCameraPermission() { (accepted) in
            if accepted{
                self.checkForStoragePermission() { (accepted) in
                    if accepted{
                        result(true)
                    } else {
                        result(false)
                    }
                }
            } else {
                result(false)
            }
        }
        
    }
    
    
    private func checkForStoragePermission(handleFinish: @escaping (_ isOK:Bool)->())-> Void {
        let storageStatus = PHPhotoLibrary.authorizationStatus()
        
        if storageStatus != PHAuthorizationStatus.authorized {
            PHPhotoLibrary.requestAuthorization { status in
                switch status {
                case .authorized:
                    handleFinish(true)
                    break;
                default:
                    handleFinish(false)
                    break;
                }
            }
        } else {
            handleFinish(true)
        }
    }
    
    private func checkForCameraPermission(handleFinish:@escaping (_ isOK:Bool)->())-> Void {
        let cameraStatus = AVCaptureDevice.authorizationStatus(for: .video)
        if cameraStatus != .authorized {
            AVCaptureDevice.requestAccess(for: AVMediaType.video) { granted in
                if granted {
                    handleFinish(true)
                } else {
                    handleFinish(false)
                }
            }
        } else {
            handleFinish(true)
        }
    }
}



public class SwiftiOSCameraPlugin: NSObject {
    static let  candidatePlugin : Candidate_Plugin =  Candidate_Plugin()
    
    
    
    public static func register(with registrar: FlutterPluginRegistrar) {
        let candidate_channel = FlutterMethodChannel(name: "my_desktop_channel", binaryMessenger: registrar.messenger())
        registrar.addMethodCallDelegate(candidatePlugin, channel: candidate_channel)
        
        
        let factory = iOSCameraViewFactory(with: registrar)
        registrar.register(factory, withId: "plugins.flutter.io/my_camera")
    }
    
    
    
}
