
//
import Flutter
import Photos
import AVFoundation
import CoreMotion


extension FlutterViewController {
    
}

var plugin0 : MyPlugin?;

public class iOSCameraView : NSObject, FlutterPlatformView ,AVCaptureVideoDataOutputSampleBufferDelegate
{
    
    var captureSession0: AVCaptureSession!
    var cameraPreview: UIView;
    var videoOutput : AVCaptureVideoDataOutput!
    var camera11: AVCaptureDevice?
    var photoSelected : Double
    let minimumZoom: CGFloat = 1.0
    let maximumZoom: CGFloat = 10.0
    var defaultWidth: Double = 0
    var defaultHeight: Double = 0
    var sessionPreset: AVCaptureSession.Preset = .photo
    var flashType: AVCaptureDevice.FlashMode = .auto
    var torchType: AVCaptureDevice.TorchMode = .off
    var fileNamePrefix: String = ""
    var maxSize: Int? = nil
    var orientationLast = UIInterfaceOrientation(rawValue: 0)!
    var motionManager: CMMotionManager?
    var focusRectColor: UIColor?
    var focusRectSize: CGFloat?
    var oldFocus:Double = 0;
    var oldExpose:Double = 0;
    var oldZoom:Double = 0;
    var oldISO:Double = 0;
    var autoValue: Int = 0;
    
    
    var focusSquare: CameraFocusSquare?
    
    var videoPreviewLayer0: AVCaptureVideoPreviewLayer!
    
    public func view() -> UIView {
        return cameraPreview
    }
    
    func setupCamera(_ focus:Double, zoom:Double, expose:Double, iso:Double, area:Double )
    {
        
        //plugin0!.setup(focus!, expose: expose!, zoom: zoom!, iso: iso!)
        do {
            try self.camera11!.lockForConfiguration()
        } catch {
            print("Could not lock camera")
        }
        //if (self.oldZoom != zoom) {
        self.photoSelected = area
        captureSession0.sessionPreset = FindSize(self.photoSelected)
            self.camera11!.videoZoomFactor = minimumZoom + (CGFloat)(zoom * Double(maximumZoom-minimumZoom));
            self.oldZoom = zoom;
        //}
       // if ((self.oldExpose != expose) || (self.oldISO != iso)) {
            let format = self.camera11?.activeFormat
            
            let maxTime :CMTime = format!.maxExposureDuration
            let minTime :CMTime = format!.minExposureDuration
            let usePower:Double = 10
            
            let max:Double = plugin0!.pow(Double(maxTime.value) / Double(maxTime.timescale), with:1/usePower) //pow 為了讓sliderbar 比較線性
            let min:Double = plugin0!.pow(Double(minTime.value) / Double(minTime.timescale), with:1/usePower)
            var exposureDuration:Double = expose * (max - min) + min
            exposureDuration = 1 / plugin0!.pow(exposureDuration ,with:usePower); //pow 為了讓sliderbar 比較線性
            if (exposureDuration < Double(maxTime.timescale) / Double(maxTime.value)) {
                exposureDuration = Double(maxTime.timescale) / Double(maxTime.value)
            }
            if (exposureDuration > Double(minTime.timescale) / Double(minTime.value)) {
                exposureDuration = Double(minTime.timescale) / Double(minTime.value)
            }
            let  exposure :CMTime = CMTimeMake(value: 1, timescale: Int32(exposureDuration))
            
            let isoValue :Float = Float(iso) * (format!.maxISO - format!.minISO) + format!.minISO;
            //("cmtime %d, iso %d\n",exposure.timescale,iso);
            self.camera11?.setExposureModeCustom(duration: exposure, iso: isoValue, completionHandler: { (CMTime) in
                
            })
            
            self.oldExpose = expose
            self.oldISO = iso
            
       // }
       // if (self.oldFocus != focus) {
            self.camera11?.setFocusModeLocked(lensPosition: Float(focus), completionHandler: { (CMTime) in
                
            })
            self.oldFocus = focus
      //  }
        
        self.camera11!.unlockForConfiguration()
    }
    
    
    
    
    init(_ frame: CGRect, viewId: Int64, args: Any?, with registrar: FlutterPluginRegistrar) {
        self.cameraPreview = UIView(frame: frame) // 此時的frame 是 0,0,0,0
        if (false) {
            //使用相機圖層預覽，相機圖層預覽不會顯示自動對焦與白平衡過程，會誤判。無法判斷為何突然不能辨識。
            app!.myPreviewImage = nil;//UIImageView(frame:self.myPreview.bounds); //
        } else {
            //使用自己裁切照片預覽，可以明確看到光線變化與對焦過程，得知何時會無法辨識。
            app!.myPreviewImage = UIImageView(frame:self.cameraPreview.bounds);
        }
        app!.cameraPreview = self.cameraPreview;
        
     
        app!.cameraViewChannel = FlutterMethodChannel(name: "plugins.flutter.io/my_camera/\(viewId)", binaryMessenger: registrar.messenger())
        
       // stillImageOutput = AVCaptureStillImageOutput()
        photoSelected = 0;
        super.init()
        
        NotificationCenter.default.addObserver(self, selector: #selector(onResume), name:
                                                UIApplication.willEnterForegroundNotification, object: nil)
        
        NotificationCenter.default.addObserver(self, selector: #selector(onPause), name:
                                                UIApplication.didEnterBackgroundNotification, object: nil)
        
        //NotificationCenter.default.addObserver(self, selector: #selector(orientationChanged), name:  Notification.Name("UIDeviceOrientationDidChangeNotification"), object: nil)
        
        if let dict = args as? [String: Any] {
            let focusRectColorRed = (dict["focusRectColorRed"] as? CGFloat)
            let focusRectColorGreen = (dict["focusRectColorGreen"] as? CGFloat)
            let focusRectColorBlue = (dict["focusRectColorBlue"] as? CGFloat)
            let focusRectSize = (dict["focusRectSize"] as? CGFloat)
            self.focusRectSize = focusRectSize
            let red: CGFloat! = (focusRectColorRed ?? 12) / 255
            let green: CGFloat! = (focusRectColorGreen ?? 199) / 255
            let blue: CGFloat! = (focusRectColorBlue ?? 12) / 255
            
            self.focusRectColor = UIColor.init(red: red, green: green, blue: blue, alpha: 255)
            
            let fileNamePrefix: String = (dict["fileNamePrefix"] as? String)!
            self.fileNamePrefix = fileNamePrefix
            
            let sessionPreset: String = (dict["sessionPreset"] as? String)!
            if (sessionPreset == "photo") {
                self.sessionPreset = .photo
            } else if (sessionPreset == "high") {
                self.sessionPreset = .high
            } else if (sessionPreset == "medium") {
                self.sessionPreset = .medium
            } else if (sessionPreset == "low") {
                self.sessionPreset = .low
            }
            
            let initialCameraType = (dict["initialCameraType"] as? String)!
            
            let videoDevices = AVCaptureDevice.devices(for: AVMediaType.video)
            for device in videoDevices {
                if (initialCameraType == "front") {
                    if device.position == AVCaptureDevice.Position.front {
                        self.camera11 = device
                        break
                    }
                } else if (initialCameraType == "rear") {
                    if device.position == AVCaptureDevice.Position.back {
                        self.camera11 = device
                        break
                    }
                }
            }
            
            let flashType = (dict["flashType"] as? String)!
            if (flashType == "autoFlash") {
                if let camera = self.camera11 {
                    if (camera.isFlashModeSupported(.auto)) {
                        self.torchType = .off
                        self.flashType = .auto
                    } else {
                        self.torchType = .off
                        self.flashType = .off
                    }
                }
            } else if (flashType == "off") {
                self.torchType = .off
                self.flashType = .off
            } else if (flashType == "on") {
                if (self.camera11!.isFlashModeSupported(.on)) {
                    self.torchType = .off
                    self.flashType = .on
                } else {
                    self.torchType = .off
                    self.flashType = .off
                }
            } else if (flashType == "torch") {
                if (self.camera11!.isTorchModeSupported(.on)) {
                    self.flashType = .off
                    self.torchType = .on
                } else {
                    self.torchType = .off
                    self.flashType = .on
                }
            }
            
            let maxSize = (dict["maxSize"] as? Int)
            self.maxSize = maxSize
            
            if let camera = self.camera11 {
                if (camera.hasTorch) {
                    do {
                        try camera.lockForConfiguration()
                    } catch {
                        print("Could not lock camera")
                    }
                    
                    camera.flashMode = self.flashType
                    camera.torchMode = self.torchType
                    camera.focusMode = .continuousAutoFocus
                    
                    camera.exposureMode  = .continuousAutoExposure
                    //camera.whiteBalanceMode = .continuousAutoWhiteBalance
                    if (camera.isConnected) {
                        if (camera.isWhiteBalanceModeSupported(.autoWhiteBalance)) {
                            camera.whiteBalanceMode = .autoWhiteBalance
                        } else if (camera.isWhiteBalanceModeSupported(.continuousAutoWhiteBalance)) {
                            camera.whiteBalanceMode = .continuousAutoWhiteBalance
                            
                        }
                    }
                }
                
                // unlock your device
                camera.unlockForConfiguration()
            }
        }
        
       // handleCamera(0,height0:0)
        /*
        print("motionManager = CMMotionManager()");
        motionManager = CMMotionManager()
        motionManager?.accelerometerUpdateInterval = 0.2
        motionManager?.gyroUpdateInterval = 0.2
        motionManager?.startAccelerometerUpdates(to: (OperationQueue.current)!, withHandler: {
            (accelerometerData, error) -> Void in
            if error == nil {
                print("outputAccelertionData")
                self.outputAccelertionData((accelerometerData?.acceleration)!)
            } else {
                print("error " + "\(error!)")
            }
        })
        */
        app!.cameraViewChannel!.setMethodCallHandler { call, result in
            #if DEBUG
                print("----" + call.method)
            #endif
            if (call.method == "setPaths") {
                let dict = call.arguments as? [String: String]
              
               
                self.setFlutterPaths(dict!)
                result(true)
            }
            if (call.method == "deactivateOCR") {
                
              
               
                self.deactivateOCR()
                result(true)
            }
            if (call.method == "activateOCR") {
                self.onResume(); self.onPause(); //因為iOS打開相機有凍住現象，加此行有改善作用。2022/03/05
                self.activateOCR()
                result(true)
            }
            
            if (call.method == "setSliders") {
                
                if let dict = call.arguments as? [String: Any] {
                    if (plugin0 != nil) {
                        plugin0!.suspendThread()
                    }
                    //  "對焦:","曝光:","ISO:"
                    let iValue  = dict["autoCamera"] as? Int;
                    self.autoValue = iValue!;
                    
                  
                    if (self.autoValue < 2) {
#if DEBUG
                            print("setSliders auto")
                        #endif
                        //自動
                        
                        if (self.camera11 != nil) {
                        do {
                            try self.camera11!.lockForConfiguration()
                        } catch {
                            print("Could not lock camera")
                        }

                        // 2021/12/04 把自動持續 continuousAutoFocus/continuousAutoExposure 改為自動鎖定 autoFocus/autoExpose。
                        // 因為自動持續會不斷變動照片畫質，影像辨識效能。
                        if (self.autoValue == 0) {
                            //全自動
                            self.camera11!.focusMode = .continuousAutoFocus
                            self.camera11!.exposureMode = .continuousAutoExposure
                        } else {
                            //半自動
                            self.camera11!.focusMode = .autoFocus //.continuousAutoFocus
                            self.camera11!.exposureMode = .autoExpose //.continuousAutoExposure
                        }
                        let camera = self.camera11!
                        if (camera.isConnected) {
                            if (camera.isWhiteBalanceModeSupported(.autoWhiteBalance)) {
                                camera.whiteBalanceMode = .autoWhiteBalance
                            } else if (camera.isWhiteBalanceModeSupported(.continuousAutoWhiteBalance)) {
                                camera.whiteBalanceMode = .continuousAutoWhiteBalance
                                
                            }
                        }
                        self.camera11!.unlockForConfiguration()
                        }
                        self.oldFocus = 0
                        self.oldExpose = 0
                        self.oldISO = 0
                        
                        //self.camera11!.videoZoomFactor = self.minimumZoom + (CGFloat)(zoom * Double(self.maximumZoom - self.minimumZoom));
                        if (dict.keys.contains("遠近:")) {
                            let zoom  = dict["遠近:"] as? Double;
                        
                            self.updateZoom(scale: CGFloat(1 + zoom! * 9));
                            self.oldZoom = zoom!;
                        }
                    } else {
                        //2021/12/04 停用手動設定，因為已經把自動持續改為自動鎖定，自動鎖定有很好的效果。
                        //2021/12/07 發現光線不足時，手動設定有很好的表現，因此恢復使用。
#if DEBUG
                            print("setSliders manual")
                        #endif
                        if (dict.index(forKey: "對焦:") != nil) {
                            //let valueDelta  = dict["色差:"];
                           
                            
                            let focus  = dict["對焦:"] as? Double;
                            let expose   = dict["曝光:"] as? Double;
                            let zoom  = dict["遠近:"] as? Double;
                            let iso  = dict["ISO:"] as? Double;
                            let area = dict["面積:"] as? Double;
                            self.setupCamera(focus!,zoom: zoom!,expose: expose!,iso: iso!,area:area!)
                            
                        }
                    }
                    
                }
                result(nil)
                let tap = UITapGestureRecognizer(target: self, action: #selector(self.handleTap(_:)))  //tabToFocus, turn off by jas 2021/03/12
                let pinchRecognizer = UIPinchGestureRecognizer(target: self, action:#selector(self.pinch(_:)))
                self.cameraPreview.addGestureRecognizer(pinchRecognizer)
                self.cameraPreview.addGestureRecognizer(tap)
                self.cameraPreview.backgroundColor = UIColor.black.withAlphaComponent(0.3)
            } else if call.method == "setCameraViewSize" {
                let dict = call.arguments as? [String: Double]
                let width :Double = dict!["cameraWidth"]!
                let height :Double = dict!["cameraHeight"]!
#if DEBUG
                print("setCameraViewSize handleCamera")
                #endif
                self.onPause();
                self.handleCamera(width,height0: height)
                result(true)
            } else if call.method == "setPhotoFeedBack" {
                let dict = call.arguments as? [String: Int]
                let value : Int = dict!["feedBack"]!
               
                plugin0?.setPhotoFeedBack(Int32(value))
                result(true)
            } else if call.method == "getPublicDirectory" {
                let paths = NSSearchPathForDirectoriesInDomains(.sharedPublicDirectory, .userDomainMask, true)
                let path = paths.first
                result(path)
            }  else if call.method == "waitForCamera" {
                result(nil)
            }  else if call.method == "getZoom" {
                result(self.oldZoom)
            } else if call.method == "captureImage" {
                if let dict = call.arguments as? [String: Any] {
                    if let maxSize = (dict["maxSize"] as? Int) {
                        self.maxSize = maxSize
                    }
                }
                //self.saveToCamera()
                result(nil)
            } else if call.method == "setPreviewRatio" {
                result(nil)
            } else if call.method == "getFlashType" {
                var flashTypes = [String]()
                
                if let camera = self.camera11 {
                    if camera.isFlashModeSupported(.auto) {
                        flashTypes.append("autoFlash")
                    }
                    if camera.isFlashModeSupported(.on) {
                        flashTypes.append("on")
                    }
                    if camera.isFlashModeSupported(.off) {
                        flashTypes.append("off")
                    }
                    
                    if camera.isTorchModeSupported(.on) {
                        flashTypes.append("torch")
                    }
                }
                
                result(flashTypes)
            } else if call.method == "turnOff" {
#if DEBUG
                print("turnOff stopRunning")
                #endif
                self.captureSession0.stopRunning()
                
                result(nil)
            } else if call.method == "turnOn" {
                
                self.captureSession0.startRunning();
                
                result(nil)
            } else if call.method == "switchCamera" {
                let videoDevices = AVCaptureDevice.devices(for: AVMediaType.video)
                for device in videoDevices {
                    if (self.camera11?.position == .front) {
                        if device.position == AVCaptureDevice.Position.back {
                            self.camera11 = device
                            break
                        }
                    } else if (self.camera11?.position == .back) {
                        if device.position == AVCaptureDevice.Position.front {
                            self.camera11 = device
                            break
                        }
                    }
                }
#if DEBUG
                print("switchCamera handleCamera");
                #endif
                self.handleCamera(0,height0:0)
                
                result(nil)
            } else if call.method == "setFlashType" {
                if let dict = call.arguments as? [String: Any] {
                    if let flashType = (dict["flashType"] as? String) {
                        if (flashType == "autoFlash") {
                            if (self.camera11!.isFlashModeSupported(.auto)) {
                                self.torchType = .off
                                self.flashType = .auto
                            } else {
                                self.torchType = .off
                                self.flashType = .off
                            }
                        } else if (flashType == "off") {
                            self.torchType = .off
                            self.flashType = .off
                        } else if (flashType == "on") {
                            if (self.camera11!.isFlashModeSupported(.on)) {
                                self.torchType = .off
                                self.flashType = .on
                            } else {
                                self.torchType = .off
                                self.flashType = .off
                            }
                        } else if (flashType == "torch") {
                            if (self.camera11!.isTorchModeSupported(.on)) {
                                self.flashType = .off
                                self.torchType = .on
                            } else {
                                self.torchType = .off
                                self.flashType = .on
                            }
                        }
                    }
                    
                    if (self.camera11!.hasTorch) {
                        do {
                            try self.camera11!.lockForConfiguration()
                        } catch {
                            print("Could not lock camera")
                        }
                        
                        self.camera11!.flashMode = self.flashType
                        self.camera11!.torchMode = self.torchType
                    }
                    
                    // unlock your device
                    self.camera11!.unlockForConfiguration()
                    
                }
                
                result(nil)
            } else if call.method == "setSessionPreset" {
                if let dict = call.arguments as? [String: Any] {
                    if let sessionPreset = (dict["sessionPreset"] as? String) {
                        if (sessionPreset == "low") {
                            self.sessionPreset = .low
                        } else if (sessionPreset == "medium") {
                            self.sessionPreset = .medium
                        } else if (sessionPreset == "high") {
                            self.sessionPreset = .high
                        } else if (sessionPreset == "photo") {
                            self.sessionPreset = .photo
                        }
                    }
                }
#if DEBUG
                print("setSessionPreset handleCamera");
                #endif
                self.handleCamera(0,height0:0)
                
                result(nil)
            } else if call.method == "setFocus" {
                if let dict = call.arguments as? [String: Any] {
                    let x = (dict["x"] as? CGFloat)
                    let y = (dict["y"] as? CGFloat)
                    
                    if y != nil && x != nil {
                        self.setFocus(touchPoint: CGPoint.init(x: x!, y: y!))
                    }
                   
                }
                
                result(nil)
            }
#if DEBUG
            print("end of " +  call.method)
            #endif
        }
        
       
    }
    
    @objc func onResume() {
        print ("onResume\n");
        //setupLivePreview(0,height0: 0)
        oldZoom = 0;
        oldISO = 0;
        oldFocus = 0;
        oldExpose = 0;
        //activateOCR();
        plugin0?.activateOCR()
        print("onResume handleCamera");
        handleCamera( 0,height0: 0)
    }
    
    func pauseLivePreview() {
        if (self.captureSession0 != nil) {
#if DEBUG
            print("pauseLivePreview stopRunning")
            #endif
            self.captureSession0.stopRunning();
        }
    }
    
    @objc func onPause() {
#if DEBUG
        print ("onPause\n");
        #endif
        pauseLivePreview()
    }
    
    func outputAccelertionData(_ acceleration: CMAcceleration) {
        var orientationNew: UIInterfaceOrientation
        
        if acceleration.x >= 0.75 {
            orientationNew = .landscapeLeft
        } else if acceleration.x <= -0.75 {
            orientationNew = .landscapeRight
        } else if acceleration.y <= -0.75 {
            orientationNew = .portrait
        } else if acceleration.y >= 0.75 {
            orientationNew = .portraitUpsideDown
        } else {
            // Consider same as last time
            return
        }
        
        if orientationNew == orientationLast {
            return
        }
        
        orientationLast = orientationNew
    }
    
    
    @objc func handleTap(_ sender: UITapGestureRecognizer? = nil) {
        let touchPoint:CGPoint = sender!.location(in: sender!.view)
        
        setFocus(touchPoint: touchPoint)
    }
    
    func setFocus(touchPoint: CGPoint!) {
        
        let devicePoint: CGPoint = (self.videoPreviewLayer0).captureDevicePointConverted(fromLayerPoint: touchPoint)
        
        if let device = self.camera11 {
            
            if let fsquare = self.focusSquare {
                
               
                fsquare.updatePoint(touchPoint)
            } else {
                self.focusSquare = CameraFocusSquare(touchPoint: touchPoint, borderColor: self.focusRectColor!, borderWidth: self.focusRectSize!)
                self.cameraPreview.addSubview(self.focusSquare!)
                
                self.focusSquare?.setNeedsDisplay()
            }
            
            self.focusSquare?.animateFocusingAction()
            
            do {
                if (device.isFocusPointOfInterestSupported){
                    try device.lockForConfiguration()
                    
                   // let supporttedPhotoFormatAndFrameRate = device.formats;//.videoSupportedFrameRateRanges[0];
                   
                    // Int32(maxFrameRate)
                    // 如果要設定framerate，需要選擇正確的 照片格式與解析度 device.activeFormat,否則無法正確。不設定則通常是 30 fps
                    //device.activeVideoMinFrameDuration = CMTimeMake(value: 1, timescale: Int32(maxFrameRate) )
                    //device.activeVideoMaxFrameDuration = CMTimeMake(value: 1, timescale: 15);
                    device.focusPointOfInterest = devicePoint
                    if (self.autoValue == 0) {
                        //全自動
                        self.camera11!.focusMode = .continuousAutoFocus
                        self.camera11!.exposureMode = .continuousAutoExposure
                    } else {
                        //半自動
                        self.camera11!.focusMode = .autoFocus //.continuousAutoFocus
                        self.camera11!.exposureMode = .autoExpose //.continuousAutoExposure
                    }
                    //device.focusMode = .autoFocus
                    //device.exposureMode  = .autoExpose
                    
                    // try AVCaptureDeviceInput(device: device)
                    if (device.isConnected) {
                        if (device.isWhiteBalanceModeSupported(.autoWhiteBalance)) {
                            device.whiteBalanceMode = .autoWhiteBalance
                        } else if (device.isWhiteBalanceModeSupported(.continuousAutoWhiteBalance)) {
                            device.whiteBalanceMode = .continuousAutoWhiteBalance
                            
                        }
                    }
                    device.unlockForConfiguration()
                }
            } catch {
                // just ignore
            }
        }
    }
    
    func updateZoom(scale factor: CGFloat) {
        guard let device = self.camera11 else { return }
        do {
            try device.lockForConfiguration()
            defer { device.unlockForConfiguration() }
            device.videoZoomFactor = factor
            
        } catch {
            print("\(error.localizedDescription)")
        }
    }
    
    @objc func pinch(_ pinch: UIPinchGestureRecognizer) {
        guard let device = self.camera11 else { return }
        
        // Return zoom value between the minimum and maximum zoom values
        func minMaxZoom(_ factor: CGFloat) -> CGFloat {
            return min(min(max(factor, minimumZoom), maximumZoom), device.activeFormat.videoMaxZoomFactor)
        }
        
        
        
        let newScaleFactor = minMaxZoom(pinch.scale * CGFloat(1 + oldZoom * 9))
        
        switch pinch.state {
        case .began: fallthrough
        case .changed: updateZoom(scale: newScaleFactor)
        case .ended:
            oldZoom = (Double(minMaxZoom(newScaleFactor)) - 1) / 9
            //("oldZoom \(oldZoom)")
            updateZoom(scale: CGFloat(1 + oldZoom * 9))
            
            var dict: [String: Double] = [String:Double]()
            
            dict["setZoom"] = oldZoom;
            
            app!.cameraViewChannel!.invokeMethod("setZoom", arguments: dict)
        default: break
        }
    }
    public func captureOutput(_ output: AVCaptureOutput,
                              didOutput sampleBuffer: CMSampleBuffer,
                              from connection: AVCaptureConnection)
    {
        plugin0?.captureOutput(output, didOutput: sampleBuffer, from: connection);
        return;
        
        guard let frame :CVImageBuffer = CMSampleBufferGetImageBuffer(sampleBuffer) else {
            debugPrint("unable to get image from sample buffer")
            return
        }
        print("did receive image frame")
        // process image here
    }
    private func setFlutterPaths(_ params:[String:String]) {
       
        plugin0?.setFlutterPaths(params)
    }
    func deactivateOCR()
    {
        onPause()
        plugin0?.deactivateOCR()
        
    }
    
    func activateOCR()
    {
        
        
        onResume()
    }
    
    private func handleCamera(_ width0 : Double, height0 : Double) {
        if (captureSession0 == nil) {
            captureSession0 = AVCaptureSession()
            
            
           // stillImageOutput = AVCapturePhotoOutput()
            
            videoOutput = AVCaptureVideoDataOutput()
            
            captureSession0.sessionPreset = sessionPreset
            do {
                if let camera = self.camera11 {
                    #if DEBUG
                    print("camera = self.camera11 ok");
                    #endif
                    let input = try AVCaptureDeviceInput(device: camera)
                    if captureSession0.canAddInput(input) /*&& captureSession0.canAddOutput(stillImageOutput) */ {
                        captureSession0.addInput(input)
                      //  captureSession0.addOutput(stillImageOutput)
                        
                    } else {
                        print("addInput failure")
                    }
                    if  captureSession0.canAddOutput(videoOutput) {
                        self.videoOutput.videoSettings = [(kCVPixelBufferPixelFormatTypeKey as NSString) : NSNumber(value: kCVPixelFormatType_32BGRA)] as [String : Any]
                        
                        self.videoOutput.setSampleBufferDelegate(self, queue: DispatchQueue(label: "my.image.handling.queue"))
                        
                        
                        captureSession0.addOutput(videoOutput)
                        let connection: AVCaptureConnection? = self.videoOutput.connection(with: AVMediaType.video);
                        connection?.videoOrientation = .portrait
                    } else {
                        print("captureSession0.canAddOutput failure");
                    }
                    
                    
                }
            } catch let error  {
                print("Error Unable to initialize back camera:  \(error.localizedDescription)")
            }
            
        }
        //if (width0 > 0) {
        
        setupLivePreview( width0 , height0: height0)
        
        //}
    }
    
    
    func FindSize(_ select : Double) -> AVCaptureSession.Preset
    { //iOS
        return AVCaptureSession.Preset.hd1280x720; //2022/02/10 發行時採用固定解析度。
        
        let items = [
            AVCaptureSession.Preset//.hd4K3840x2160, 解析度太高佔用記憶體導致閃退。
                .hd1920x1080,
                .hd1280x720,
                .iFrame960x540

        ];
        var candidates : Array<AVCaptureSession.Preset> = [];
        for  item1 in items {
            if (captureSession0.canSetSessionPreset(item1)) {
                candidates.append(item1)
            }
        }
        let index = Double(candidates.count - 1) * select;
        return candidates[Int(index)];
    }
    
    func setupLivePreview(_ width0  : Double, height0 : Double) {
        if (videoPreviewLayer0 != nil) {
            videoPreviewLayer0.removeFromSuperlayer()
            
            if ((defaultWidth != width0) && (defaultHeight != height0)) {
           //     videoPreviewLayer0 = nil
            }
        }
       
       
        captureSession0.sessionPreset = FindSize(self.photoSelected)
        //("AVCaptureVideoPreviewLayer 1")
        if (videoPreviewLayer0 == nil) {
            // 如果已經使用中，移除重新取得會花掉很多時間，原因不明。
            videoPreviewLayer0 = AVCaptureVideoPreviewLayer(session: captureSession0)
        }
        //("AVCaptureVideoPreviewLayer 2")
        #if DEBUG
        print("width0  \(width0) ");
        #endif
        if (width0 > 0) {
            defaultWidth = width0
            defaultHeight = height0
        }
        
        var theRect2 : CGRect = self.cameraPreview.bounds
       
        theRect2.size.width = CGFloat(self.defaultWidth);
        theRect2.size.height = CGFloat(self.defaultHeight);
       
        self.cameraPreview.frame = theRect2
        
        
        self.videoPreviewLayer0.frame = theRect2;
       
        self.videoPreviewLayer0.videoGravity = .resizeAspectFill
        
        self.videoPreviewLayer0.connection?.videoOrientation = .portrait
        
        
        if (app!.myPreviewImage != nil) {
            //使用自己加工過的預覽畫面
            
            if (app!.myPreviewImage?.superview  == nil) {
                self.cameraPreview.addSubview(app!.myPreviewImage!);
            }
            if (app!.myPreviewImage != nil) {
                app!.myPreviewImage!.frame = self.cameraPreview.bounds
                
            }
        } else {
            //使用video的預覽功能
            cameraPreview.layer.addSublayer(self.videoPreviewLayer0) // videoPreviewLayer 已經在工作當中，只要不加入即不會顯示。
        }
        var theRect : CGRect = self.cameraPreview.bounds
        if (theRect.size.width == 0) {
            theRect.size.width = CGFloat(width0);
            theRect.size.height = CGFloat(height0);
        }
        DispatchQueue.global(qos: .userInitiated).async { //[weak self] in
#if DEBUG
            print("startRunning")
            #endif
            self.captureSession0.startRunning()
            
            /*
            // somehow the first time running is faster than the getView from FlutterNativeView function
            let seconds = 0.1 //0.5 需要延遲足夠時間，才能確定 frame已經設定完成，否則是 0,0,0,0 就無法正常顯示預覽畫面。
            DispatchQueue.main.asyncAfter(deadline: .now() + seconds) {
               
               // if (app!.myPreviewImage != nil) {
                //這裡會變成是大畫面，而螢幕只出現左上角一塊，導致顯示與辨識的區塊大小不同。
                //因為這裡得到 實際解析度，而iOS UI用的是虛擬螢幕解析度，這可能跟高倍率螢幕有關。
               //     var theRect : CGRect = self.cameraPreview.bounds
               //     app!.myPreviewImage!.frame = theRect
               // }
                if (self.camera11!.hasTorch) {
                    do {
                        try self.camera11!.lockForConfiguration()
                    } catch {
                        print("Could not lock camera")
                    }
                    
                    self.camera11!.flashMode = self.flashType
                    self.camera11!.torchMode = self.torchType  //手電筒, 火炬；火把
                }
                
                // unlock your device
                self.camera11!.unlockForConfiguration()
            }
             */
        }
    }
    /*
    func rotateImage(image: UIImage) -> UIImage? {
        if self.camera11?.position == .front {
            if self.orientationLast == UIInterfaceOrientation.landscapeRight {
                return UIImage(cgImage: image.cgImage!, scale: 1.0, orientation: .downMirrored)
            } else if self.orientationLast == UIInterfaceOrientation.landscapeLeft {
                return UIImage(cgImage: image.cgImage!, scale: 1.0, orientation: .upMirrored)
            } else if self.orientationLast == UIInterfaceOrientation.portrait {
                return UIImage(cgImage: image.cgImage!, scale: 1.0, orientation: .leftMirrored)
            } else if self.orientationLast == UIInterfaceOrientation.portraitUpsideDown {
                return UIImage(cgImage: image.cgImage!, scale: 1.0, orientation: .rightMirrored)
            }
        } else if self.camera11?.position == .back {
            if self.orientationLast == UIInterfaceOrientation.landscapeRight {
                return UIImage(cgImage: image.cgImage!, scale: 1.0, orientation: .up)
            } else if self.orientationLast == UIInterfaceOrientation.landscapeLeft {
                return UIImage(cgImage: image.cgImage!, scale: 1.0, orientation: .down)
            } else if self.orientationLast == UIInterfaceOrientation.portrait {
                return UIImage(cgImage: image.cgImage!, scale: 1.0, orientation: .right)
            } else if self.orientationLast == UIInterfaceOrientation.portraitUpsideDown {
                return UIImage(cgImage: image.cgImage!, scale: 1.0, orientation: .left)
            }
        }
        
        return image
    }
     */
    
    func saveToCamera() {
        
    }
    /*
    func saveImage(image: UIImage) -> Bool {
        autoreleasepool {
            let rotatedImage = rotateImage(image: image)!
            let newImage = resizeImage(image: rotatedImage)!
            guard let data = newImage.jpegData(compressionQuality: 1) ?? newImage.pngData() else {
                return false
            }
            guard let directory = try? FileManager.default.url(for: .documentDirectory, in: .userDomainMask, appropriateFor: nil, create: false) as NSURL else {
                return false
            }
            
            let timestamp = NSDate().timeIntervalSince1970
            let myTimeInterval = TimeInterval(timestamp)
            let time = NSDate(timeIntervalSince1970: TimeInterval(myTimeInterval))
            let dateFormatterGet = DateFormatter()
            dateFormatterGet.dateFormat = "yyyyMMdd_HHmmss"
            
            let fileURL = directory.appendingPathComponent("\(self.fileNamePrefix)_\(dateFormatterGet.string(from: time as Date)).jpg")
            if !FileManager.default.fileExists(atPath: fileURL!.path) {
                FileManager.default.createFile(atPath: fileURL!.path, contents: data, attributes: nil)
            } else {
                do {
                    try data.write(to: fileURL!)
                } catch {
                    print(error.localizedDescription)
                }
            }
            
            var dict: [String: String] = [String:String]()
            
            dict["path"] = fileURL?.path
            app!.cameraViewChannel!.invokeMethod("onImageCaptured", arguments: dict)
            return true
        }
    }
    
    func resizeImage(image: UIImage) -> UIImage? {
        if (self.maxSize == nil) {
            return image
        }
        let scale = CGFloat(self.maxSize!) / image.size.width
        let newWidth = image.size.width * scale
        let newHeight = image.size.height * scale
        UIGraphicsBeginImageContext(CGSize(width: newWidth, height: newHeight))
        image.draw(in: CGRect(x: 0, y: 0, width: newWidth, height: newHeight))
        let newImage = UIGraphicsGetImageFromCurrentImageContext()
        UIGraphicsEndImageContext()
        
        return newImage
    }
     */
}

public class iOSCameraViewFactory : NSObject, FlutterPlatformViewFactory {
    var _registrar: FlutterPluginRegistrar
    
    init(with registrar: FlutterPluginRegistrar) {
        _registrar = registrar
    }
    
    public func create(withFrame frame: CGRect, viewIdentifier viewId: Int64, arguments args: Any?) -> FlutterPlatformView {
        return iOSCameraView(frame, viewId: viewId, args: args, with: _registrar)
    }
    
    public func createArgsCodec() -> FlutterMessageCodec & NSObjectProtocol {
        return FlutterStandardMessageCodec.sharedInstance()
    }
}
// setActiveVideoMinFrameDuration
