
import 'dart:async';
import 'dart:io';
import 'package:flutter/material.dart';
import 'package:flutter_spinkit/flutter_spinkit.dart';
import 'MyBottomBar_app.dart';
import 'main_mlpr.dart';

abstract class HomePageCommon extends StatefulWidget
{
  HomePageCommon?parentPage; // nextPage to push/pop 2023/05/17
  String get pageTitle;
  bool circleSpined = false;
  Function()refreshHomeUITitle; // 使用bottomBarItem,換頁時通知首頁更新表頭。 在繼承class內使用。因為bottomBarItem不會自動更新表頭。
  List<Widget> _pageAction = [];
  Widget ?myLeading;
  Function ?backtoParent;

  HomePageCommon(keyName, this.refreshHomeUITitle) : super(key: PageStorageKey<String>(keyName));
  HomePageCommon.noStorage( this.refreshHomeUITitle) : super();

  List<Widget>get pageActions {
    return _pageAction;
  }

  Widget ? get getLeading  {
    return myLeading; //back to parent
  }

  set pageActions(List<Widget>value) {
    _pageAction = value;
  }

  Future<void> FinishWithMessage(context,message)
  {
    Completer<void>result = Completer<void>();
    if (message.isNotEmpty) {
      //AskAlertWith(context, '提醒', message, 'OK').then((value) {

      currentPageP = null;
      resetManagedPage = true;
      rootState?.setState(() {  });
      result.complete();
      //});
    } else {
      currentPageP = null;
      resetManagedPage = true;
      rootState?.setState(() {  });
      result.complete();
    }
    return result.future;
  }

  Widget LayoutWithSpinCircle(Widget defaultLayout)
  {
    if (importBusy) {
      return SpinKitCircle(color: Colors.blue); //當背景啟動轉入文件時，popUntil 需要更新畫面導致記憶體不足，所以遮斷更新動作。
    }
    if (circleSpined == false) {
      return defaultLayout;
    } else {
      //轉換過程如果動作很快，將不會看到此畫面。2022/08/20
      return Stack(
          children: [
            defaultLayout,
            Container( // 遮斷編輯畫面，防止在等待時誤觸。
              color: Colors.grey.withAlpha(128), // ok
              child: SpinKitCircle(color: Colors.blue), //一個轉動的等待畫面。 轉動效果會反覆的觸發螢幕自動更新。
            ),

          ]
      );
    }
  }

}


class myBottomItems extends BottomNavigationBarItem
{
  HomePageCommon ?thePage;


  myBottomItems({
    required icon,
    label,

    this.thePage
  }) : super(icon: icon,
    label:label,

  ) {

  }
  final PageStorageBucket _bucket = PageStorageBucket();


  HomePageCommon pushPage(HomePageCommon newPage,updateCallback()) //2023/05/17
  {
    newPage.parentPage = thePage;
    thePage = newPage;
    //  pageStack.add( thePage!);
    newPage.backtoParent = (){
      popPage();
      updateCallback(); // 經過 pushPage以後，parentPage 已經不在 state trees 上，這表示 parentPage.setState 已經 無效。
    };
    Future.delayed(Duration(milliseconds: 100),(){
      if (rootState!= null) {
        if (rootState!.mounted) {
          rootState!.setState(() {

          });
        }
      }
    });
    return thePage!;
  }

  HomePageCommon? popPage()  //2023/05/17
  {
    if (thePage != null) {
      if (thePage!.parentPage != null) {
        thePage = thePage!.parentPage;
        // pageStack.removeLast();
      }
    }
    Future.delayed(Duration(milliseconds: 100),(){
      if (rootState!= null) {
        if (rootState!.mounted) {
          rootState!.setState(() {

          });
        }
      }
    });
    return thePage;
  }

}
