



import 'dart:async';
import 'dart:convert';
import 'dart:io';
import 'package:archive/archive_io.dart';
import 'package:file_picker/file_picker.dart';
import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';

//import 'package:ocr_flutter_my/mlpr_package/registerBottomBar.dart';
import 'HomePageCommon.dart';
import 'PageUIMobileCameraScanner.dart';

import 'package:shared_preferences/shared_preferences.dart';
import 'PageAbout.dart';


import 'channel.dart';
import 'main_mlpr.dart';


bool resetManagedPage = false; //轉入資料後需要更新。
class MyBottomBarPage_app extends HomePageCommon //手機版本首頁
{


  MyBottomBarPage_app(Function() callbackToUpdate) : super('MyBottomBarPage',callbackToUpdate);
  @override
  State<StatefulWidget> createState() {
    return _stateMyBottomBarPage();
  }

  @override
  // TODO: implement pageTitle
  String get pageTitle => '車牌辨識';
}

String importMessage = '';
bool importBusy = false;

class _stateMyBottomBarPage extends State<MyBottomBarPage_app> {

  StreamSubscription ?_intentDataStreamSubscription; //資料轉入時被動呼叫


  @override
  void initState()
  {
    super.initState();
    rootState = this;


  }


  @override
  void dispose() {

    _intentDataStreamSubscription!.cancel();

    super.dispose();
  }


  @override
  Widget build(BuildContext context) {

    if (resetManagedPage) {
      resetManagedPage = false;
      currentPageP = null;
      bottomBarItems = null; //這樣才能更新個別頁面的內容。
    }
    bottomBarItems ??= app_setup_iconItems_forBottomBar();

    if (selectedIndexBars >= 0) {
      needResetDrawerTitle = true;
      currentPageP = bottomBarItems!.elementAt(selectedIndexBars);

    } else {
      return Text('');
    }

    String useTitle = '';
    List<Widget>pageActions = [];
    Widget ?useLeading;
    if (currentPageP != null) {
      useTitle = currentPageP!.thePage!.pageTitle;
      pageActions = currentPageP!.thePage!.pageActions;
      useLeading = currentPageP!.thePage!.getLeading; //左上角，大多是「回上頁」
    }

    double fontSize = 9;
    if (pageActions.isEmpty) {
      fontSize = 11;
    }

    Widget useTitleWidget = Text(useTitle, style: TextStyle(fontSize: fontSize));
    if (needResetDrawerTitle) {
      needResetDrawerTitle = false;
      Future.delayed(Duration(
          seconds: 1), () { //2023/03/15 發現 切換 社區後到 掃描畫面，AppBar title 顯示舊的社區名字，因為 掃描畫面更新但drawer build 沒有更新。
        //('useTitle $useTitle, currentPage $currentPageP');
        if (currentPageP == null) { //轉入資料後會被清空
          setState(() {
            needResetDrawerTitle = true;
          });
        } else {
          String pageTitle = currentPageP!.thePage!.pageTitle;
          if (useTitle != pageTitle) {
            setState(() {

            });
          }
        }
        if (currentPageP != null) {
          if (pageActions.length != currentPageP!.thePage!.pageActions.length) {
            setState(() {

            });
          }
        }
      });
    }
    Color unselectedIconColor = Colors.grey; // ok

    return Scaffold(
      appBar: AppBar(
        leading: useLeading,
        title: useTitleWidget,
        actions:pageActions,
      ),

      bottomNavigationBar: BottomNavigationBar(
        items: bottomBarItems!,
        currentIndex: selectedIndexBars,
        selectedItemColor:  Colors.amber[800],
        unselectedItemColor: unselectedIconColor ,
        onTap: (index) { // _onItemTapped
          selectedIndexBars = index;
          setState(() {

          });
        },//_onItemTapped,
      ),

      body: currentPageP!.thePage!,

    );
  }

  void DelayToUpdate()
  {
    Future.delayed(Duration(milliseconds: 100),(){
      setState(() {});
    });
  }

  List<myBottomItems> app_setup_iconItems_forBottomBar() //手機版本app首頁
  {
    List<myBottomItems> resultItems =  <myBottomItems>[

      myBottomItems(
        icon: Icon(Icons.help_center),
        label: '簡介',
        thePage: PageAbout(DelayToUpdate),
      ),

      myBottomItems(
        icon: Icon(Icons.camera),
        label: '辨識',
        thePage: PageUIMobileCameraScanner( callback:DelayToUpdate),
      ),
    ];

    resultItems.forEach((element) {
      bottomItemMaps[element.label!] = element; //為了後面方便找到
    });
    return resultItems;
  }



}




String CheckIfZipped(String filePath) {
  if (filePath.endsWith('.mlprdoc')) {
    return filePath; // format OK
  }

  File fref = File(filePath);
  if (fref.existsSync()) {
    // android ,可能是暫存檔 .mlprdoc ,也可能是暫存檔 .zip
    RandomAccessFile rfile1 = fref.openSync(mode: FileMode.read);

    String mlprdocHead = readBytesSync(rfile1, 7);
    if (mlprdocHead == 'mlprdoc') { //檔案表頭
      // int version2 = Read4Byte(rfile); //版本
      //  if (version2 == binFile.version) {
      rfile1.closeSync();
      return filePath; // format OK
      // }
    }

    rfile1.closeSync();


    // android下有可能是暫存檔 .tmp, 但內容是 mlprdoc  或 zip
    RandomAccessFile rfile2 = fref.openSync(mode: FileMode.read);
    int version2 = Read4Byte(rfile2); //zip head 0x04034b50
    if (version2 == 0x04034b50) { // zip head 0x04034b50
      //is zip file
      List<String> names = DoUnzip(filePath);
      if (names.isNotEmpty) {
        rfile2.closeSync();
        return names[0]; //只處理一個檔案。
      }
    }
  }
  return '';
}

String DoFilter(String src)
{
  if (src.contains('/')) {
    String name = src
        .split('/')
        .last;
    if (name.substring(0, 1) == '.') {
      return '';
    } else if (name.endsWith('mlprdoc')) {
      return src;
    }
  }
  if (src.substring(0, 1) == '.') {
    return '';
  } else if (src.endsWith('mlprdoc')) {
    return src;
  }
  return '';
}

void Write4Byte(RandomAccessFile rfile,int value)
{
  for (int i=0;i<4;i++) {
    int result = rfile.writeByteSync(value);
    if (result!=1) {
      debugPrint('RandomAccessFile writeByteSync error $result');
    }
    value >>= 8;
  }
}

int Read4Byte(RandomAccessFile rfile) {
  try {
    int b1 = rfile.readByteSync();
    int b2 = rfile.readByteSync();
    int b3 = rfile.readByteSync();
    int b4 = rfile.readByteSync();
    if (b1+b2+b3+b4 < 0) {
      return -1;
    }
    if (b4 < 0) {
      return -1;
    }
    int value = (b4 << 24) + (b3 << 16) + (b2 << 8) + b1;
    return value;
  }
  catch  ( e) {
    if (e is FileSystemException) {
      debugPrint('FileSystemException');
    } else {
      //(e.toString());
    }
  }
  return -1;
}


void writeStringSync(RandomAccessFile rfile,String theStr)
{
  List<int> datas = utf8.encode(theStr);
  int bytes = datas.length;
  Write4Byte(rfile, bytes);
  rfile.writeFromSync(datas);
}


String readStringSync(RandomAccessFile rfile, {int limit=0})
{
  int bytes = Read4Byte(rfile);
  if (bytes < 0) {
    return '';
  }
  if (limit > 0) {
    if (bytes > limit) {
      return '';
    }
  }
  List<int>  texts = Uint8List(bytes);
  rfile.readIntoSync(texts);
  try {
    return utf8.decode(texts);
  } catch (e) {
    //(e.toString());
    return '';
  }
}

String readBytesSync(RandomAccessFile rfile, int bytes)
{
  List<int>  texts = Uint8List(bytes);
  rfile.readIntoSync(texts);
  try {
    return utf8.decode(texts);
  } catch (e) {
    //(e.toString());
    return '';
  }
}

State ?rootState;



//appPref
bool get alertIfFound {

  return false;

}

set alertIfFound(bool value)
{

}

bool get keepScreenOnWhileScanning { //保持螢幕常亮2023/05/31

  return false;
}

set keepScreenOnWhileScanning(bool value)
{

}

Widget ImportButton(context)
{
  return TextButton(child:Text('轉入',style: TextStyle(fontSize:10, color: Colors.white),),
    onPressed: (){
      if (Platform.isIOS) { // 因為 iOS 有bug：allowedExtensions 無效，所以需要另外處理。
        FilePicker.platform.pickFiles(
          dialogTitle: '請選擇管制車牌文件檔案:',
          type: FileType.any,
          //  allowedExtensions: ['mlprdoc','zip' ], //,'zip'  ,ios 無效，macos 有效
          allowMultiple: false,

        ).then((FilePickerResult ?result) {
          //('FilePickerResult:' + result.toString());
          if (result != null) {
            if (result.files.isNotEmpty) {
              DoGotFile(context,result.files[0].path!);
            }
          }
        });
      } else {

        FilePicker.platform.pickFiles(
          dialogTitle:'請選擇管制車牌文件檔案:',
          type: FileType.custom,
          allowedExtensions: ['mlprdoc','zip'], //  ,ios 無效，macos 有效
          allowMultiple:false,

        ).then((FilePickerResult ?result) {
          //('FilePickerResult:' + result.toString());
          if (result != null) {
            if (result.files.isNotEmpty) {
              DoGotFile(context,result.files[0].path!);

            }
          }
        });
      }

    }, );
}


List<String> DoUnzip(String srcPath)  //2022/10/03 chengansun@gmail.com
{
  List<String>items = [];
  final bytes = File(srcPath).readAsBytesSync();

// Decode the Zip file
  final archive = ZipDecoder().decodeBytes(bytes);

// Extract the contents of the Zip archive to disk.
  for (final file in archive) {
    final filename = file.name;
    if (file.isFile) {
      //('filename  $filename');
      String name = DoFilter(filename); //因為 壓縮檔案內可能包含 看不見的檔名。在macOS壓縮，會有一個 .xxxx.mlprdoc
      if (name.isNotEmpty) {
        if (filename.endsWith('mlprdoc')) {
          String newPath = sharePath + '/' + name;

          final data = file.content as List<int>;
          File(newPath)
            ..createSync(recursive: true)
            ..writeAsBytesSync(data);
          items.add(newPath);
        }
      }
    } else {
      Directory('out/' + filename).create(recursive: true);
    }
  }
  return items;
}


void DoGotFile(context,String path0) {
  pendingImport = path0;
  // ???? 出對話窗會當機，因為是背景狀態，無法保證前景是在哪一個畫面。
  //('DoGotFile before Navigator.popUntil');
  currentPageP = null;
  importBusy = true;
  Navigator.popUntil(context, (route) {
    String name = route.settings.name ?? '';
    if (name == '/') {
      debugPrint('DoGotFile  Navigator.popUntil (name == /)');
      rootState!.setState(() {});
      return true;
    }
    return false;
  });
}


bool needResetDrawerTitle = true;


//bool workingPathReady = false;

String pendingImport = '';

List<myBottomItems>?bottomBarItems;
Map<String,myBottomItems> bottomItemMaps = {};
myBottomItems ?currentPageP;
int selectedIndexBars = 0;

String sharePath = '';