
import 'dart:io';
import 'package:flutter/material.dart';
import 'package:url_launcher/url_launcher.dart';
import 'HomePageCommon.dart';
import 'MyBottomBar_app.dart';
import 'main_mlpr.dart';



Widget InfoFirstPage_querystolen()
{

  String aboutMessage =
      '這個版本需要用到較大的RAM與較多的CPU 核心，'
      '有可能您的手機可以順利安裝但無法順利工作，或工作過程造成手機發熱。\n\n'
      ;

  InlineSpan spans = TextSpan(children: [
    TextSpan(text: aboutMessage, style: TextStyle(fontSize: 20, color: Colors.black)),

  ]
  );
  return ListView(
    children: <Widget>[
      RichText(text: spans),
      RichText(text: spans_brief_help),
      ContactMeByEmail(),
      ContactMeByHTTP(),
    ],
  );
}


Widget InfoFirstPage_manager() {
  String aboutMessage =

      '這個程式經由相機動態取像，辨識車牌號碼之後儲存，'
      '再經由操作者編輯輸入車牌號碼的管制資料，做為以後查詢使用。'
      '例如學校或工廠大門的車輛進出管理登記，或社區共用停車位的車輛管理登記。\n\n'
      '這個版本需要用到較大的RAM與較多的CPU 核心，'
      '有可能您的手機可以順利安裝但無法順利工作，或工作過程造成手機發熱。\n\n'

      ;


  InlineSpan spans = TextSpan(children: [
    TextSpan(text: aboutMessage, style: TextStyle(fontSize: 20, color: Colors.black)),

  ]
  );

  return ListView(

    //mainAxisAlignment: MainAxisAlignment.center,
    children: <Widget>[
      RichText(text: spans),
      RichText(text: spans_brief_help),
      ContactMeByEmail(),
      ContactMeByHTTP(),
    ],
  );
}


Widget showHelpAbout() { //showPageAbout

    return InfoFirstPage_manager(); //車牌管理  說明畫面。 //因為車牌管理+查車牌無法在android play store更新上架，所以另外開立一個app上架。

}

Widget ContactMeByEmail()
{
  String platform = (Platform.isAndroid)?'apk':'app';
  return TextButton(onPressed: (){
    final Uri url = Uri(
        scheme: 'mailto', // 在 macOS 桌機無效
        path: 'chengansun@gmail.com',
        queryParameters: {
          'subject': '車牌辨識$platform' ,
          // 'body': 'Default body'
        }
    );


    launchUrl(url);

  }, child: Text('chengansun@gmail.com'));
}


Widget ContactMeByHTTP()
{
  return TextButton(onPressed: (){
    Uri url = Uri(scheme:'http',host:'www.smartinside.com.tw');
    launchUrl(url);
  }, child: Text('http://www.smartinside.com.tw'));
}

String brief_helpMessage = '基於手機鏡頭做車牌辨識有先天上的限制，'
    '注意下列使用狀況，可以得到較好的辨識效果：\n\n'
    '1.手機鏡頭採用自動對焦需要時間，在光線均勻且充足的環境下，'
    '可以較快的取得照片，辨識率也會比較好；'
    '在陰影/日光反覆變動的環境，對焦效果不好，會導致效率變差或無法辨識。\n\n'
    '2.手機品牌/機型/規格差異很大，不同手機具有不同的效率表現，無法一概而論。'
    '本app採用多工模式運作，在多核心手機的效率會更好。\n\n'
    '3.相片處理需要較大的RAM，如果手機RAM不足，可能引發逾時閃退。\n\n'
    '4.手機鏡頭的快門不快，無法應付快速移動的目標，最佳辨識車牌的鏡頭移動速度必須低於時速10公里。\n\n'
    '5.手機鏡頭有效的車牌辨識距離建議在10公尺以內。實際應用跟手機鏡頭的等效焦距有關。\n\n'
    '6.在靜止情況下，手機晃動也會導致無法對焦。在移動的車上使用手機對窗外，辨識移動的車牌，效果不好。\n\n'
    '7.手機效能有限，連續辨識車牌的效率，大約一秒鐘可以辨識三張照片。實際操作時看到出現於手機畫面上的車牌，'
    '不一定來得及辨識。\n\n'
    '8.車牌號碼辨識字母需要較大顯示點數，如果字母太小，即使在手機螢幕可以肉眼辨識，手機app也將無法辨識，'
    '可以適度拉近車牌讓號碼顯示字母變大，可以提高辨識率。\n\n'
    '9.車牌辨識受到字型與車牌格式雙重限制，如果您發現辨識率太低，可能是字型或格式不在app的預設條件內，可以跟我聯絡。'
    '期待您能提供車牌照片樣本以利改善辨識準確率\n\n'
'\n\n'
'如有使用上的建議，或發現問題，歡迎跟我聯絡，感謝！';



InlineSpan spans_brief_help = TextSpan(children: [
  TextSpan(text: brief_helpMessage, style: TextStyle(fontSize: 20, color: Colors.black)),
  //TextSpan(text: smallHint,style: TextStyle(fontSize: 12, color: Colors.red)),
]
);


class PageAbout extends HomePageCommon
{

  PageAbout(callback):super('PageAbout', callback);

  @override
  State<StatefulWidget> createState() {
    return _statePageAbout();
  }

  @override
  String get pageTitle => '簡介';

}

class _statePageAbout extends State<PageAbout> {
  @override
  Widget build(BuildContext context) {
    return SafeArea( // 避開圓角畫面或無邊框彎曲畫面。
        child: Container(
          padding: EdgeInsets.all(10),
          child: showHelpAbout(),
        ));
  }

}