//library mlpr_pkg;

import 'dart:async';
import 'dart:io';
import 'dart:typed_data';
import 'package:flutter/cupertino.dart';

import 'HomePageCommon.dart';
import 'MyBottomBar_app.dart';
import 'channel.dart';
import 'main_mlpr.dart';
import 'native_camera.dart';
import 'package:flutter/material.dart';
import 'package:getwidget/getwidget.dart';
import 'package:keep_screen_on/keep_screen_on.dart';


//掃描中清單，跟 歷史清單的資料來源相同，但顯示的UI不同。
class PageUIMobileCameraScanner extends HomePageCommon {
  bool animating = false; //2022/04/27 偵測animation 是否已經結束
  ScrollController listview_controller2 = ScrollController(keepScrollOffset:true);
  String my_apartName = '';

  PageUIMobileCameraScanner( {callback}) : super('PageUIMobileCameraScanner', callback) ;

  @override
  UIMobileCameraScannerState createState() => UIMobileCameraScannerState();

  @override
  String get pageTitle => my_apartName +'：掃描車牌';
}

class ImageItemDesktop {
  ImageItemDesktop(this.image, this.text, this.info, this.remark);

  Image image;
  String text;
  String info;
  String remark;
}

class UIMobileCameraScannerState extends State<PageUIMobileCameraScanner> with WidgetsBindingObserver {
// WidgetsBindingObserver: didChangeAppLifecycleState
  List<String> pictureSizes = [];

  String recordingTitle = "錄影中";
  bool? recordingStatus = false;
  Image? history_defaultImage;



  int autoScrolling = 0;
  int handScrolling = 0;
  int needScrolling = 0;
  Timer? haltScrolling_timer2;
  int currentPagei = 1;
  Map<String, String> statusInfo = {};
  int? autoValue = null; // 0:"全自動"  1:"半自動"  2:"手動"
  List<String> autoMode = ["全自動", "半自動", "手動"];
  NativeCameraUint? cameraController = null;
  PageController pageController = new PageController(initialPage: 1);
  int askLocationPermission = 0;

  UIMobileCameraScannerState(); // default constructor

  void dumpdir(List<ImageItemDir> items) {
    items.forEach((element) {
      //(element.datePath);
    });
  }

  void DelayToUpdateFile() {
    //為了避免連續掃描時拖垮MCU，必須減少存檔次數。不影響換頁操作。

  }

  Future<void> setCameraAuto(sliderValues) {
    // sliderValues 雖然可以分為手動與自動，但已經於2021/12/04 停用手動，並且停用 自動持續 改用 自動鎖定。
    Completer result = new Completer<void>();

    if (cameraController != null) {
      debugPrint("----cameraController.setSliders");
      cameraController!.setSliders(sliderValues).then((value) {
        debugPrint("cameraController.setSliders----");
        return result.complete();
      });
    } else {
      result.complete();
    }
    return result.future;
  }

  Future getZoom() {
    Completer result = new Completer<double>();
    cameraController!.getZoom().then((value) {
      return result.complete(value);
    });
    return result.future;
  }

  List<Widget> MySlidersView(List<String> titles) {
    List<Widget> lists = [];

    titles.forEach((title) {
      if (sliderValues.containsKey(title)) {
      } else {
        sliderValues[title] = 0;
      }
      lists.add(Container(
          height: MediaQuery.of(context).size.height / 2 / 7,
          width: MediaQuery.of(context).size.width,
          child: Row(
            children: [
              Expanded(
                  flex: 2,
                  child: Text(
                    title,
                    style: TextStyle(color: Colors.green),
                  )),
              Expanded(
                  flex: 10,
                  child: Slider(
                      value: sliderValues[title],
                      autofocus: true,
                      onChanged: (double value) {
                        //("setState 3");
                        setState(() {
                          sliderValues[title] = value;
                          sliderValues["auto:"] = 2; //設定任何 slider值相當於手動操作

                          setCameraAuto(sliderValues);
                        });
                      })),
            ],
          )));
    });
    return lists;
  }



  TextStyleColor(int select) {
    if (select == autoValue) {
      return TextStyle(
        color: Colors.red,
      );
    } else {
      return TextStyle(
        color: Colors.blue,
      );
    }
  }


  List<String> sliderValuesTitles = ["對焦:", "曝光:", "ISO:", "面積:"]; //這裏出現的中文項目直接跟 android java/iOS swift 對應，不可單獨修改。
  Widget MySetupView() {
    //  if (autoValue == 2) {
    //手動設定才需要
    //   return Column(
    //      children: [
    //  MenuAndZoom(), //標題與zoom
    //       Column(
    // 手動項目
    //           children: MySlidersView(sliderValuesTitles),
    //        )
    //       ],
    //    );
    // } else {
    return MenuAndZoom(); //標題與zoom
    //  }
  }

  Widget HistoryView() {
    /*
    List<Directory> history2 = [];
    Directory dir = Directory(history_lpr_path);
    List<FileSystemEntity> entries = dir.listSync(recursive: false).toList();
    entries.forEach((fileOrDir) {
      if (fileOrDir is File) {

      } else if (fileOrDir is Directory) {
        history2.add(fileOrDir);
      }
    });

     */

    return Container(child: (history_defaultImage == null) ? Text('') : history_defaultImage);
  }

  Widget SetupCameraPreview() {
    // if (popupDefaultSyncRecognition == '車牌辨識') {
    //相機畫面預覽
    return GFFloatingWidget(
      //手動設定對焦，htc one a9 不支援手動對焦，小米手機cc9有支援。
        child: MySetupView(), //浮動控制項。
        body: camera1View! // myCameraView() //相機畫面預覽
    );

  }

  Widget myCameraView() {

    return  Container(
      //相機畫面預覽
      // height: 200,
      child: MyNativeCamera(
        setZoom: (value) {
          sliderValues["遠近:"] = value;

          setState(() {});

        },
        initialCameraType: CameraType.rear,
        onCameraCreated: _onCameraCreated,
        onImageCaptured_mobile_2: (Uint8List? imageBytes, String lpr_no, double match_score, double estimate_height, remark, dynamic params) {
          try {
            bool canUpdate = ((autoScrolling == 0) && (handScrolling == 0));
            // String lpr_path = params["lpr_path"];
            // String photo_path = params["photo_path"];
            // 參考：辨識結果  got1
            RecornitionResult result = RecornitionResult();
            result.texts = '$lpr_no, ${match_score.toStringAsFixed(2)}, ${estimate_height.toStringAsFixed(2)}';
            if (imageBytes != null) {
              result.image = Image.memory(imageBytes);
            }
            history_items.add(result);
            setState(() {

            });
          } catch (e) {
            debugPrint("mobile_Got1Bitmap error 2");
            debugPrint(e.toString());
          }
        },
        cameraPreviewRatio: CameraPreviewRatio.r16_9,
        focusRectColor: Colors.purple,
        focusRectSize: 200,
      ),
    );



  }

  void HaltScroll() {
    if (haltScrolling_timer2 != null) {
      haltScrolling_timer2!.cancel();
      haltScrolling_timer2 = null;
    }

    haltScrolling_timer2 = Timer(const Duration(seconds: 3), () {
      handScrolling = 0;
      haltScrolling_timer2 = null;
    });
  }


  Widget MakePage1_scanner_list_cell(BuildContext context, int index) {
    double useHeight = 80; //totalHeight / 5; //確保能夠顯示最少四行，因為有些消耗所以除5.

    return Container(
        height: useHeight,
        alignment: Alignment.centerLeft,
        child: GestureDetector(
          onTap: () {
            //掃描器下方
            //選到一張車牌


            //
          },
          child: Column(children: [
            //一個 cell 顯示兩行

            Expanded(
              // cell 第一行
                flex: 1,
                child: Text('index-$index')),//MakeLine_date_status(widget.myApart!.managedInfos!, index)), //MakeLine_date_status(index)),

            Expanded(
              // cell 第二行
                flex: 2,
                child: WorkingUILineImage(index)),
            Divider(
              color: Colors.black,
              thickness: 1,
            ),
          ]),
        ));
  }

  Widget WorkingUILineImage(index) {
    return Row(
      //左右兩欄
      children: [
        Expanded(
          //左
            flex: 6,
            child: Container(
              //為了靠左 才需要 Container
              alignment: Alignment.topLeft,
              child: Text('index $index'),//GetWorkingUICapturedImage(widget.myApart!.history_lpr_path,index),
            )),
        Expanded(
          //右
          flex: 4,
          child: //右邊 再分上下
          Text( 'index $index',
            //global_scannedHistorys[index].lpr_no,
            style: TextStyle(fontSize: 18),
          ),
        ),
      ],
    );
  }
  List<RecornitionResult> history_items = [];

  Widget makeCell(int index,double width,double height)
  {
    double textWidth = width * 0.6;
    double lprWidth = width - textWidth;
    return SizedBox(
        width: width,
        height: height,
        child:Row(children: [
          SizedBox(width: textWidth,child: Text(history_items[index].texts)),
        SizedBox(width: lprWidth,child: history_items[index].image??Text(''))
        ],)
    );
  }

  Widget page_scanner_temp(double width,double height) {
    //掃瞄器下方顯示區
    double cellHeight = 40;
    return Container(
      //辨識結果列表
      color: Colors.white,
      height: height , // fixed height
      child: NotificationListener<ScrollNotification>(
        // NotificationListener 監測 scrolling 狀態
          child: ListView.builder(
              controller: widget.listview_controller2,
              itemBuilder: (context, index) {
                return makeCell(index,width,cellHeight);
                //MakePage1_scanner_list_cell( context,  index);
              },
              itemCount: history_items.length,
              scrollDirection: Axis.vertical,
              //reverse: true, //show last item in top, this will scroll down every new item added
              shrinkWrap: true),
          onNotification: (scrollNotification) {
            //call from NotificationListener
            if (scrollNotification is ScrollStartNotification) {
              if (autoScrolling == 0) {
                if (handScrolling == 0) {
                  handScrolling = 1;
                  needScrolling = 0; // wait until new data arrived
                }
              }
            } else if (scrollNotification is ScrollUpdateNotification) {
            } else if (scrollNotification is ScrollEndNotification) {
              if (handScrolling == 1) {
                HaltScroll();
              }
            }
            if (scrollNotification.metrics.axisDirection == AxisDirection.down) {
            } else if (scrollNotification.metrics.axisDirection == AxisDirection.up) {}
            return true;
          }),
    );
  }

  List<Widget> UpdateInfo() {
    List<Widget> result = [];
    statusInfo.forEach((key, value) {
      result.add(Row(
        children: [Text(key), Text(value)],
      ));
    });
    if (result.length == 0) {
      result.add(Text("empty info"));
    }
    return result;
  }

  Widget showSetupButton() // 2023/03/15 昨天收到email來自「南宮o罪」建議增加提醒。
  {
    return IconButton(
      icon: Icon(Icons.settings),
      onPressed: () {
        if (mounted) {
          showAlertSetting(context).then((value) {
            KeepScreenOn.turnOn(on:keepScreenOnWhileScanning);
          });
        }
      },
    );
  }

  @override
  void initState() {
    debugPrint('animate ' + widget.animating.toString());
    super.initState();
    WidgetsBinding.instance.addObserver(this);
    widget.pageActions = <Widget>[
      //右上角設定
      //  showClearButton(),
      showSetupButton(),

    ];
  }

  @override
  void dispose() {
    widget.pageActions = [];

    WidgetsBinding.instance.removeObserver(this);

    KeepScreenOn.turnOff();
    super.dispose();
  }

  @override
  void didChangeAppLifecycleState(AppLifecycleState state) {
    super.didChangeAppLifecycleState(state);
    switch (state) {
      case AppLifecycleState.detached:
        debugPrint("AppLifecycleState.detached");
        break;
      case AppLifecycleState.inactive:
        debugPrint("AppLifecycleState.inactive"); //切換app到背景時，先呼叫inactive後呼叫paused

        break;

      case AppLifecycleState.paused: //按睡眠鍵時只呼叫paused
        debugPrint("AppLifecycleState.paused");
        deactivateOCR();
        break;
      case AppLifecycleState.resumed:
        {
          debugPrint("AppLifecycleState.resumed");
          activateOCR();
          setState(() {

            setCameraAuto(sliderValues);

          });
        }
        break;
    }
  }

  void animationHandler(status) {
    //改為 bottomBar以後已經不需要 animation, 2022/12/04
    if (status == AnimationStatus.completed) {
      ModalRoute.of(context)!.animation!.removeStatusListener(animationHandler);
      setState(() {
        widget.animating = false; //2022/04/27 偵測animation 是否已經結束
      });
    }
  }


  void ScrollBinding()
  {

    WidgetsBinding.instance.addPostFrameCallback((_) {
      //捲到最後一筆
      //("scroller");
      if ((handScrolling == 0) && (needScrolling == 1)) {
        autoScrolling = 1;
        //(" scrolling");
        widget.listview_controller2
            .animateTo(
          widget.listview_controller2.position.maxScrollExtent,
          duration: Duration(milliseconds: 500),
          curve: Curves.fastOutSlowIn,
        )
            .then((value) {
          if (autoScrolling > 0) {
            autoScrolling = 0;
          }
        });
      } else {
        //("scroller busy");
      }
    });
  }

  @override
  void deactivate()
  {
    super.deactivate();

  }


  Slider? zoomSlider = null;

  Widget NewZoomSlider(title, value) {
    zoomSlider = Slider(
        value: value,
        autofocus: true,
        onChanged: (double value) {
          debugPrint("setState 3");
          setState(() {
            sliderValues[title] = value;
            // sharedPref!.setDouble("setZoom", value);
            //sliderValues["auto:"] = 0;
            setCameraAuto(sliderValues);
          });
        });
    return zoomSlider!;
  }

  SaveSlider() {
    /*
    sliderValuesTitles.forEach((name) {
      sharedPref!.setDouble(name, sliderValues[name]);
    });
    sharedPref!.setDouble("遠近:", sliderValues["遠近:"]!);

     */
  }



  LoadSlider() {
    sliderValuesTitles.forEach((name) {
      double? value = 0;//sharedPref!.getDouble(name);
      if (value == null) {
        value = 0;
        //  sharedPref!.setDouble(name, value);
      }
      sliderValues[name] = value;
    });
    double? value2 = sliderValues['遠近:'];//zoomValue;//sharedPref!.getDouble("遠近:");
    if (value2 == null) {
      value2 = 0;
    }
    sliderValues["遠近:"] = value2;
  }

  Widget MenuAndZoom() {
    return Column(
      children: [
        // if (useQueryStolen)   MenuSetup1(),  // 2022/05/20 不再顯示 查贓車選項，直接工作。
        // 手動設定於正式發行只有查車牌選項，關閉自動半自動手動錄影四個項目。2022/02/10
        ZoomSlider(),
      ],
    );
  }

  Widget ZoomSlider() {
    String title = "遠近:";
    double ?value = sliderValues[title];
    if (value == null) {
      value = 0;
    }
    if (value == -1) {
      value = 0;
    }
    return Container(
      // Slider 必須預先設定寬度
        width: MediaQuery.of(context).size.width,
        child: Row(
          children: [
            Expanded(
                flex: 2,
                child: Text(
                  title,
                  style: TextStyle(color: Colors.green),
                )),
            Expanded(
              flex: 10,
              child: NewZoomSlider(title, value),
            ),
          ],
        ));
  }



  void LoadFirst1()
  {
/*
    if (sharedPref!.getBool("recordingStatus") == null) {
      sharedPref!.setBool("recordingStatus", false);
      recordingStatus = false;
    } else {
      recordingStatus = sharedPref!.getBool("recordingStatus");
    }
    if (sharedPref!.getInt("autoCamera") == null) {
      sharedPref!.setInt("autoCamera", 0);
    }
    autoValue = sharedPref!.getInt("autoCamera");

 */
    LoadSlider();
    //("setState 10");
  }

  @override
  Widget build(BuildContext context) {
    // ModalRoute.of(context)!.animation!.addStatusListener(animationHandler); //改為 bottomBar以後已經不需要 animation, 2022/12/04
    KeepScreenOn.turnOn(on: keepScreenOnWhileScanning); //保持螢幕常亮2023/05/31
    //('widget.goBack ' + widget.goBack.toString());
    if (Platform.isMacOS) {
      platform0 = "MacOS";
    } else if (Platform.isIOS) {
      platform0 = "IOS";
    } else if (Platform.isAndroid) {
      platform0 = "Android";
    } else {
      platform0 = "unknown";
    }
    if (loadFirst) {
      loadFirst = false;
      LoadFirst1();
    }
    if (widget.animating) {
      //2022/04/27 偵測animation 是否已經結束
      return Text(''); //Waiting... 需要讀取後才顯示UI
    }
    if (!mounted) {
      camera1View = null;
      // 因為 myCameraView 用到callback，必須重置。
    }
    camera1View ??= myCameraView(); // myCameraView 將會建立  channel00， 使用於 setMyPaths 以及native 的圖片溝通。
    return LayoutBuilder(builder: (BuildContext context, BoxConstraints constraints) {
      double width = constraints.maxWidth;
      double height = constraints.maxHeight;
      return scannerBody(width,height);
    });

  }

  Widget scannerBody(double width,double height) {
    ScrollBinding();
    double upperHeight = height / 2;
    double lowerHeight = height - upperHeight;
    return SafeArea(
      child: Column(
        children: [
          SizedBox(
            height:upperHeight,
            //上方
            child: SetupCameraPreview(), // 有浮動控制項  車牌辨識 iDoMLPR = true, or iDoMLPR = 1
          ),
          SizedBox(
            height:lowerHeight,
            //下方
            child: page_scanner_temp(width,lowerHeight), //顯示辨識結果
          ),
        ],
      ),
    );
  }
  Future _onCameraCreated(NativeCameraUint controller, double camera_width, double camera_height) async {
    this.cameraController = controller;
    if (recordingStatus!) {
      setPhotoFeedBack(1);
    } else {
      setPhotoFeedBack(0);
    }
    setCameraViewSizes(camera_width, camera_height);
    double? value = 0;//
    setState(() {
      sliderValues["遠近:"] = value;
    });
    autoValue = 0;//sharedPref!.getInt("autoCamera");
    sliderValues["autoCamera"] = 0;//sharedPref!.getInt("autoCamera");
    await setCameraAuto(sliderValues);
  }
}

Widget? camera1View;

Future<void> showAlertSetting(context) {
  Completer<void>result = Completer<void>();
  //2023/03/15 16:20 來自email 南宮o罪 的建議，增加搜尋提醒功能
  showDialog(
      barrierDismissible: false, //防止誤觸消失
      context: context,
      builder: (context) =>
          AlertDialog(
              content:
              Container(
                  height: MediaQuery.of(context).size.height / 2,
                  child:
                  Column(children: [
                    const Text("掃描車牌時"),

                    Row(children: [ Text("找到車牌時 提醒"),
                      Checkbox(value: alertIfFound, onChanged: (value) {
                        if (value != null) {
                          alertIfFound = value;
                        }
                      },),
                    ]),
                    Row(children: [ Text("掃描時螢幕保持常亮"),
                      Checkbox(value: keepScreenOnWhileScanning, onChanged: (value) {
                        if (value != null) {
                          keepScreenOnWhileScanning = value;
                        }
                        // Navigator.pop(context);
                      },),
                    ]),
                  ],)),
              actions: [ //左右排列的對話窗按鈕。
                TextButton(onPressed: () {
                  result.complete();
                  Navigator.pop(context);
                }, child: Text("設定")),
              ]
          )
  );
  return result.future;
}


bool loadFirst = true;
class RecornitionResult
{
  String texts = '';
  Image ?image;
}
Map<String, dynamic> sliderValues = {};