//library mlpr_pkg;

//2021/04/06 chengansun@gmail.com
//yyyy/mm/dd



import 'dart:async';
import 'dart:io';
import 'dart:typed_data';
import 'package:flutter/cupertino.dart';
import 'package:mutex/mutex.dart';
import 'main_mlpr.dart';
import 'channel.dart';

class MyDataBase {

  //int geoLocatorCount = 0;

  //double default_position_longitude = 0;
  //double default_position_latitude = 0;


  final mutext = Mutex();
  String path;
  String lpr_photo_path;
  MyApp app;

  Map<String, List<String>> records = {};

  MyDataBase(this.app, this.path, this.lpr_photo_path, {String ?texts}) {
    if (path == null) {
      path = "";
    }
    if (path != "") {
      try {
        List<String>items;
        if (texts == null) {
          File fref = File(path);
          if (fref.existsSync()) {
            texts = File(path).readAsStringSync();
          } else {
            fref.createSync(recursive: true);
            texts = "";
          }
        }
        if (texts.contains("\r\n")) {
          items = texts.split("\r\n");
        } else if (texts.contains("\r")) {
          items = texts.split("\r");
        } else if (texts.length > 0) {
          items = [texts];
        } else {
          items = [];
        }
        for (String record in items) {
          List<String> fields = record.split("\t");
          if (fields.length == 2) {
            List<String> details = fields[1].split(",");
            records[fields[0]] = details;
          }
        }
      } catch (e) {
        debugPrint("data base read error ");
        debugPrint(e.toString());
      }
    }
  }

  List<String> ? Find(String key) {
    if (records.containsKey(key)) {
      return records[key];
    } else {
      return null;
    }
  }

  void SaveFile() {
    String texts = "";
    File file = File(path);

    RandomAccessFile fref = file.openSync(mode: FileMode.write);

    try {
      //Uint8List tab = utf8.encode("\t");
      //Uint8List linefeed = utf8.encode("\r\n"); // 無法使用  writeStringSync("\r\n"); 因為被自動濾掉.
      records.forEach((key, List<String> values)
      //for (String key in records.keys) {
      {
        //print(key);
        if (key != "") {
          //List<String>values = records[key];


          fref.writeStringSync(key + "\t");
          int count = 0;
          values.forEach((element)
          //for (String element in values)
          {
            if (element != "") {
              if (count > 0) {
                fref.writeStringSync(",");
              }
              count++;
              fref.writeStringSync(element);
            }
          });


          fref.writeStringSync("\r\n");
          //fref.writeFromSync(linefeed);
        }
      });
    } catch (e) {
      debugPrint("error ");
      debugPrint(e.toString());
    }
    fref.close();
  }

  Timer ?timer1 = null;

  void SaveRecord(String key, List<String> datas) {
    records[key] = datas;
    if (timer1 != null) {
      timer1!.cancel();
      timer1 = null;
    }

    timer1 = Timer(const Duration(seconds: 10), () {
      SaveFile();
    });
  }

  void AppendRecord(String key, String date1) {
    mutext.acquire();
    List<String> ?datas = Find(key);
    if (datas == null) {
      datas = [];
    }
    datas.add(date1);
    SaveRecord(key, datas);
    mutext.release();
  }

  String SavePhotoImage(Uint8List image1, String lpr_no, String date1) {
    date1 = date1.replaceAll(" ", "+").replaceAll(":", "_");
    String fname = lpr_no + "-" + date1 + ".jpg";
    String lprpath = lpr_photo_path + "/" + fname;
    File(lprpath).writeAsBytesSync(image1);

    AppendRecord(lpr_no, date1);
    return lprpath;
  }


  void mobile_Save1CharBits(Uint8List imageBytes, String lpr_no, String photo_id, double match, dynamic params) {
    if (lpr_char_path != null) {
      //String owner_lpr_num = params["owner_lpr"]; //字母來自這張車牌組合。
      //辨識結果得到的單一字母圖形，儲存下來送到server做為訓練學習用途，改善OCR 準確率。因為原本字母樣本與車牌字體並不相符。
      String score = match.toStringAsFixed(4);
      String theChar = params["theChar"];

      if (theChar == "") {
        theChar = "?";
      }
      String subPath = lpr_char_path + "/" + theChar;
      Directory dir = Directory(subPath);
      if (dir.existsSync() == false) {
        dir.createSync(recursive: true);
      }
      //String remark = params["remark"];
      String divs = params["division"];
      int division = int.parse(divs);
      int high = params["char_height"];
      String lpr = params["lpr_no"];
      if (division == -1) {
        divs = "";
      }
      String remark = params["remark"];
      String lprpath = subPath + "/" + theChar + "_" + score + "_" + lpr + "_" + remark + ".jpg";
      try {
        File(lprpath).writeAsBytesSync(imageBytes);
      } catch (e) {
        debugPrint("mobile_Save1CharBits error ");
        debugPrint(e.toString());
      }
    }
  }


}


