//library native_camera;
//library mlpr_pkg;

import 'dart:async';
import 'dart:io';
import 'dart:typed_data';
import 'package:path_provider/path_provider.dart';
import 'main_mlpr.dart';
import 'native_camera.dart';
import 'package:flutter/material.dart';
import 'package:http_parser/http_parser.dart';
import 'package:http/http.dart' as http;
import 'package:getwidget/getwidget.dart';
import 'package:video_thumbnail/video_thumbnail.dart'; // may not work on macos ios?
import 'channel.dart';

/*
分析全部照片 藉以取得車牌字母樣本。
 */
class DesktopAnalyze extends StatefulWidget {
  final String id;

  const DesktopAnalyze({Key? key, this.id=''}) : super(key: key);

  @override
  _DesktopAnalyze createState() => _DesktopAnalyze();
}

class MyFileItems {
  String path;

  MyFileItems(this.path);

}

class _DesktopAnalyze extends State<DesktopAnalyze> {
  List<MyFileItems> itemLists = [];

  ScrollController listview_controller = ScrollController();

  Widget MakeCell(
    BuildContext context,
    int index,
  ) {
    return Text(itemLists[index].path);
  }

  void DoParseVideo(String path) async { //not work for macos 2021/05/28
    final uint8list = await VideoThumbnail.thumbnailData(
      video: path,
      imageFormat: ImageFormat.JPEG,
      //maxWidth: 128,
      timeMs: 0,
      // specify the width of the thumbnail, let the height auto-scaled to keep the source aspect ratio
      quality: 100,
    );
    Image image = Image.memory(uint8list!);
    debugPrint("image");

  }

  void DoParsePhotos(String path) {
    
    //呼叫 swift / objective-c / c++ 分析辨識照片，辨識結果透過 platform methodchannel onImageCaptured 回傳。
    DoParsePhotos(path); //.then((value) {
  }

  void DoParseFileList(Directory dir) {
    if (dir.path.contains("LPR-Captured")) {
      return;
    }
    List<FileSystemEntity> items = dir.listSync();
    items.forEach((FileSystemEntity element) {
      FileSystemEntity.isDirectory(element.path).then((isDir) {
        if (isDir) {
          String fname = element.path;
          if (fname.contains("/skip")) {
            //已經分析收集過
          } else {
            DoParseFileList(Directory(element.path));
          }
        } else {
          String name = element.path.toLowerCase();
          if (name.endsWith(".jpg") || name.endsWith(".bmp") ||
              name.endsWith(".png") ||
              name.endsWith(".jpeg")) {
            DoParsePhotos(name);
          } else {
            if (name.endsWith(".mov") ||
              name.endsWith(".mp4")) {
              DoParsePhotos(name);
            }
          }
        }
      });
    });
  }

  void BeginAnalyze() {
    MyApp.getMyDocumentsDirectory().then((value) {
      String path = value.path;
      List<String> items = path.split("/");
      items[items.length - 1] = "OCR-Photos-LPR";
      path = items.join("/");
      debugPrint("path: " + path);
      Directory dir = Directory(path);
      if (dir.existsSync()) {
        Timer.run(() {
          DoParseFileList(dir);
        });
      }
      debugPrint("BeginAnalyze");
    });
  }

  Widget AnalyzeFileLists() {
    return ListView.builder(
        controller: listview_controller,
        itemBuilder: (context, index) => MakeCell(context, index),
        itemCount: itemLists.length,
        scrollDirection: Axis.vertical,
        //reverse: true, //show last item in top, this will scroll down every new item added
        shrinkWrap: true);
  }

  Widget ShowHelp()
  {
    return
    SizedBox(
      width: 800,
    height:300,
    child:
      Text("以 flutter 分析全部照片並取得字母圖形, \n"
    "存放於 ~/Desktop/ocr-data/charbits。\n"
    "然後經手工調整正確歸類到正確的目錄 [~/Desktop/ocr-data/收集字體] 內，\n"
    "再使用xcode learnAlphaButtonAction --> DoParseCollects\n"
    "將字母圖形轉為樣本資料庫\n pattern_lpr.txt.")
    );
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: const Text('分析車牌收集字母'),
      ),
      body: SafeArea(

        child:
            Column(
              children: [
                Expanded(
                  flex: 2,
                  child:
                    ShowHelp(),

                ),
                Expanded(
                  flex: 5,
                    child: AnalyzeFileLists(),
                ),
              ],
            )
        ,
      ),
      floatingActionButton: FloatingActionButton( // 分析車牌收集字母
        heroTag: "test3",
        child: Icon(Icons.launch),
        onPressed: () {
          BeginAnalyze();
        },
      ),
    );
  }
}
