

import 'dart:async';
import 'dart:convert';
import 'dart:io';
import 'dart:math';
//import 'dart:typed_data';
import 'package:flutter/foundation.dart';
import 'package:flutter/services.dart';
//import 'package:flutter_archive/flutter_archive.dart';
import 'package:archive/archive.dart';
import 'package:flutter_ringtone_player/flutter_ringtone_player.dart';
//import 'package:multi_window/multi_window.dart';
import 'package:ocr_flutter_my/mlpr_package/MyBottomBar_app.dart';
//import 'package:ocr_flutter_my/mlpr_package/registerBottomBar.dart';
import 'PageAbout.dart';
import 'channel.dart';
import 'package:path_provider/path_provider.dart';
import 'desktop_analyze.dart';
import 'package:flutter/material.dart';
import 'package:package_info_plus/package_info_plus.dart';

// https://appicon.co/   app icon 產生器

bool hasPermission = false;

String webPath = '';


final listview_controller0 = ScrollController();
_MyAppState? appState = null;

HttpServer? desktop_server_ocr = null;
HttpServer? server_web = null;

String desktopPhotosUploads_path = '';

class MyApp extends StatefulWidget {
  final String id;

  MyApp(bool useQueryStolen0, {Key? key, this.id = ''}) : super(key: key) {




  }

  @override
  _MyAppState createState() {
    appState = _MyAppState();
    return appState!;
  }

  void desktop_Save1CharBits(Uint8List imageBytes, String theChar, double matchScore, String in_lpr_no, dynamic params) {
    if (lpr_char_path != null) {
      if (matchScore >= 1.0) {
        return; //不用存檔
      }
      //字母來自這張車牌組合 in_lpr_no。
      //辨識結果得到的單一字母圖形，儲存下來送到server做為訓練學習用途，改善OCR 準確率。因為原本字母樣本與車牌字體並不相符。
      String scoreText = theChar + "-" + matchScore.toStringAsFixed(4) + '-' + in_lpr_no;
      String subPath = lpr_char_path + "/" + theChar;
      Directory dir = Directory(subPath);
      if (dir.existsSync() == false) {
        dir.createSync(recursive: true);
      }
      DateTime dt = DateTime.now();
      int micro = dt.millisecondsSinceEpoch;
      String seq = micro.toString();
      if (in_lpr_no.length > 1) {
        seq = ""; //不要時間標籤，讓重複的發生覆蓋，只保留一份。
      }
      String lprpath = subPath + "/" + scoreText + "-" + seq + ".jpg";
      try {
        File(lprpath).writeAsBytesSync(imageBytes);
      } catch (e) {
        debugPrint("desktop_Save1CharBits error ");
        debugPrint(e.toString());
      }
    }
  }

  static Future<Directory> getMyDocumentsDirectory() async {
    final Completer<Directory> complete = new Completer<Directory>();
    if (kIsWeb) {
      getApplicationDocumentsDirectory().then((value) {
        complete.complete(value);
      });
    } else {
      if (Platform.isAndroid) {
        getExternalStorageDirectories().then((List<Directory>? value) {
          if (value != null) {
            Directory? internal = null;
            Directory? external = null;
            List<Directory> lists = value;
            lists.forEach((dir) {
              Match? matchPat = "/storage/emulated/".matchAsPrefix(dir.path);
              bool matched = matchPat != null;
              if (matched) {
                internal = dir;
              } else {
                external = dir;
              }
            });
            if (external == null) {
              external = internal;
            }
            complete.complete(external);
          } else {
            complete.complete(Directory.current);
          }
        });
      } else {
        getApplicationDocumentsDirectory().then((value) {
          complete.complete(value);
        }).onError((error, stackTrace) {
          complete.complete(Directory.current);
        });
      }
    }
    return complete.future;
  }
}

class _MyAppState extends State<MyApp> {
  bool busy_setting = true;
  /*MultiWindow get currentWindow => MultiWindow.current;
  MultiWindow? secondaryWindow;
  List<DataEvent> events = [];

   */
  TextEditingController? controller;

  @override
  void initState() {
    super.initState();
    if (Platform.isMacOS) {
      /*
      MultiWindow.current.setTitle(MultiWindow.current.key);
      controller = TextEditingController();
      currentWindow.events.listen((event) {
        // echo('Received event on self: $event');
        setState(() => events.add(event));
      });

      // mult window 彼此之間是獨立 task，global 不相同。
      // 因此，以下的程式將會自動被不同task執行。
      if (currentWindow.key != 'main') { // mult window 彼此之間是獨立task，global 不相同。
        MultiWindow.create('main', title: 'OCR desktop server').then(
              (value) => setState(() => secondaryWindow = value),
        );
      } else {
        currentWindow.setTitle('OCR desktop server');
      }

      if (currentWindow.key != "registerWindow") { // multi window 彼此之間是獨立task，global 不相同。
        MultiWindow.create('registerWindow', title: 'registerServer').then(
              (value) => setState(() => secondaryWindow = value),
        );
      }

       */
    }
  }

  _MyAppState() {
    //if (widget.needSetup) {
    //  widget.needSetup = false;
    if (kIsWeb) {
      busy_setting = false;
    } else {
      getVersions().then((value) {
        SetupApp().then((value) {
          busy_setting = false;
          setState(() {});
        });
      });
    }
    //}
  }


  Map<String, String> appversion = {};

  Future<void> getVersions() async {
    PackageInfo packageInfo = await PackageInfo.fromPlatform();
    appversion['appName'] = packageInfo.appName;
    appversion['packageName'] = packageInfo.packageName;
    appversion['version'] = packageInfo.version;
    appversion['buildNumber'] = packageInfo.buildNumber;
  }
  Future<void> SetupApp() {

    Completer complete = new Completer<void>();
    if (lpr_char_path == '') {
      if (kIsWeb) {
        //locationOK = true;
        //workingPathReady = true;
        complete.complete();
      } else {
        SetDesktopCallBack();

        SetupLocalDirs1().then((value) {


          /* 測試用序號
        20230608-09363763-01000001-debug+HEHFHCNCJFHHDPEBEDEGEFEGEKEKEHEGEDEDEDEEEADPEBEDEGEFEGEKEKEHEGEDEHEKEGEDDPEJEKECEDEFEGEEEDEBCMDBDADACMDBCMQFLQJHQKMEMMQHLHKBQGJLJA
        20230608-09363763-01000002-debug+HEHFHCNCJFHHDPEBEDEGEFEGEKEKEHEGEDEDEDEEEADPEBEDEGEFEHEAEAEAEKEFEFECEJEHDPEHECEHEBEBEHEFEKEHCMDBDADACMDCCMQFLQJHQKMEMMQHLHKBQGJLJA
        20230608-09363763-01000003-debug+HEHFHCNCJFHHDPEBEDEGEFEGEKEKEHEGEDEDEDEEEADPEBEDEGEFEHEAEAEAEKEFEFEFEFEGDPEHEEEFEDEJEFEJEAEGCMDBDADACMDDCMQFLQJHQKMEMMQHLHKBQGJLJA
        20230608-09363763-01000004-debug+HEHFHCNCJFHHDPEBEDEGEFEGEKEKEHEGEDEDEDEEEADPEBEDEGEFEHEAEAEAEKEFEFEKEDEBDPEHEHEAEBECEKEJEFEKCMDBDADACMDECMQFLQJHQKMEMMQHLHKBQGJLJA
        20230608-09363763-01000005-debug+HEHFHCNCJFHHDPEBEDEGEFEGEKEKEHEGEDEDEDEEEADPEBEDEGEFEHEAEAEAEKEFEGECEJEBDPEHEKECEFECEHEGEAECCMDBDADACMDFCMQFLQJHQKMEMMQHLHKBQGJLJA
        20230608-09363763-01000006-debug+HEHFHCNCJFHHDPEBEDEGEFEGEKEKEHEGEDEDEDEEEADPEBEDEGEFEHEAEAEAEKEFEGEFEBEJDPEJEAEHEDEEEBEDEBEFCMDBDADACMDGCMQFLQJHQKMEMMQHLHKBQGJLJA
        20230608-09363763-01000007-debug+HEHFHCNCJFHHDPEBEDEGEFEGEKEKEHEGEDEDEDEEEADPEBEDEGEFEHEAEAEAEKEFEGEHEFEADPEJECEBEFEJEDEJEDEGCMDBDADACMDHCMQFLQJHQKMEMMQHLHKBQGJLJA
        20230608-09363763-01000008-debug+HEHFHCNCJFHHDPEBEDEGEFEGEKEKEHEGEDEDEDEEEADPEBEDEGEFEHEAEAEAEKEFEGEKEFEDDPEJEDEDEJEEEGEFEAEJCMDBDADACMDJCMQFLQJHQKMEMMQHLHKBQGJLJA
        20230608-09363763-01000009-debug+HEHFHCNCJFHHDPEBEDEGEFEGEKEKEHEGEDEDEDEEEADPEBEDEGEFEHEAEAEAEKEFEHECEEEKDPEJEFEBEEEBEAEFEKEECMDBDADACMDKCMQFLQJHQKMEMMQHLHKBQGJLJA
        20230608-09363763-01000010-debug+HEHFHCNCJFHHDPEBEDEGEFEGEKEKEHEGEDEDEDEEEADPEBEDEGEFEHEAEAEAEKEFEHEFEFEKDPEJEGEKEEECEFEAEKEHCMDBDADACMDBDACMQFLQJHQKMEMMQHLHKBQGJLJA
        */
          String install_key = "20230608-09363763-01000001-debug+HEHFHCNCJFHHDPEBEDEGEFEGEKEKEHEGEDEDEDEEEADPEBEDEGEFEGEKEKEHEGEDEHEKEGEDDPEJEKECEDEFEGEEEDEBCMDBDADACMDBCMQFLQJHQKMEMMQHLHKBQGJLJA";


          //參考：設定路徑
           setMyPaths({"install_key": install_key,  "patterns": patternBinPath}).then((String?errorMessage) {
             if ((errorMessage != null) && (errorMessage.isNotEmpty)) {
                 showDialog(
                     barrierDismissible: false, //防止誤觸消失
                     context: context,
                     builder: (context) =>
                         AlertDialog(
                             content:
                             Container(
                                 height: MediaQuery.of(context).size.height / 2,
                                 child: Text(errorMessage) ),
                             actions: [ //左右排列的對話窗按鈕。
                               TextButton(onPressed: () {

                                 complete.complete();
                                 Navigator.pop(context);
                               }, child: Text("知道了")),
                             ]
                         )


                 );

             } else {
               complete.complete();
             }
           });

        });
        if (Platform.isMacOS) {

          //locationOK = true;
          WidgetsBinding.instance.addPostFrameCallback((_) {
            //捲到最後一筆

            if (listview_controller0.hasClients) {
              listview_controller0.animateTo(
                listview_controller0.position.maxScrollExtent,
                duration: Duration(milliseconds: 500),
                curve: Curves.fastOutSlowIn,
              );
            }
          });
        }
      }
    } else {
      complete.complete();
    }
    return complete.future;
  }

  void ShowImageInParseView(String path) {
    if (channel00 != null) {
      channel00!.invokeMethod('ShowImageInParseView', {"imagePath": path});
    }
  }

  Widget UseMobileOS() {
    if (server_web != null) {
      InternetAddress address = server_web!.address;
      int port = server_web!.port;

      return Center(child: Text(server_web!.address.toString() + ":" + port.toString()));
    } else {
      return Padding(
          padding: EdgeInsets.all(16.0),
          //首頁說明畫面
          child: showHelpAbout() // showPageAbout

          );
    }
  }

  bool firstLaunch = true;

  void PlayMyAlertSound() {
    FlutterRingtonePlayer().play(
      android: AndroidSounds.notification,
      ios: IosSounds.glass,
      looping: false,
      // Android only - API >= 28
      volume: 1,
      // Android only - API >= 28
      asAlarm: false, // Android only - all APIs
    );
  }

  @override
  void dispose() {

    super.dispose();
  }

  Widget myDrawerPageHome_app = MyBottomBarPage_app(() {}); //手機版本首頁UI

  @override
  Widget build(BuildContext context) {


      //手機版本

          return MaterialApp(
            //2022/11/15 修改操作 UI與流程。
            debugShowCheckedModeBanner: false,
            title: '車牌管理',
            theme: ThemeData(
              primarySwatch: Colors.blue,
            ),
            // initialRoute: 'About',
            // debugShowCheckedModeBanner: false,
            routes: {
              '/': (context) => myDrawerPageHome_app, //2022/11/15 修改操作 UI與流程。 // 有這一行，就不需要 home: xxxx()
            },
            // home: xxxx(paper),//Text('Flutter Demo Home Page'),
          );
          //return MyDrawerPage(); //2022/11/15 修改操作 UI與流程。
          //return ManagerWidget(); //經由選社區進入工作畫面。


      //手機版本

      //解壓縮完畢才進入主要操作畫面

  }
}

Widget AnalizeButton(context)
{
  return SizedBox(
    width: 80,
    child: TextButton(
      child: Text(
        "分析",
        style: TextStyle(color: Colors.white),
      ),
      onPressed: () {
        /*
        MultiWindow.create(
          'analyze',
          // size: size,
          title: '分析工具',
          alignment: Alignment.topLeft,
        );
        
         */
        Navigator.push(
          context,
          MaterialPageRoute(
            builder: (BuildContext context) {
              return DesktopAnalyze();
            },
          ),
        );

      },
    ),
  );
}


int portWebNumber = 0;
int portPhotoNumber = 0;
String host_ip_address = '';

void BindWebServer2() {
  print('BindWebServer2');
  retrieveIPAddress().then((value) {

    portWebNumber = runInBuildProductDebug ? 8081 : 8080;
    if (value != null) {
      host_ip_address = value.address;
      debugPrint('value.address $host_ip_address');
      HttpServer.bind(host_ip_address, portWebNumber).then((server) {
        // web 瀏覽器
        // web server
        // 負責 webapp 的監聽，webapp 是 flutter web compile to javascript , 獨立的目錄存放。
        server_web = server;
        server.listen((HttpRequest request) {
          Uri url = request.requestedUri;
          String host = url.host;
          if (request.method == 'GET') {

            String path = request.requestedUri.path;
            ShowWebMessage("(request.method == 'GET') path = $path");

            debugPrint("BindWebServer path " + path);
            if (path == "/assets/ip.txt") {
              request.response.headers.add('Content-Type', 'text/html');
              AppendCORS(request);
             request.response.statusCode = HttpStatus.ok;
              request.response.write(host + ':' + portWebNumber.toString()); //write body 以後就不能再修改 response.headers
            } else {
              httpWebServer_DoGetPage2(request);
            }
          } else if (request.method == "PUT") {
            httpWebServer_DoPut(request);
          } else if (request.method == "POST") {}

          request.response.close();
        });
        if (appState != null) {
          appState!.setState(() {});
        }
      }).onError((error, stackTrace) {
        print('error $error');
        print('stackTrace $stackTrace');
      });
    }
  }).onError((error, stackTrace) {
    if (appState != null) {
      appState!.setState(() {});
    }
  });
}

void SetDesktopCallBack() {
  channel00 = MethodChannel('my_desktop_channel'); //手機版與桌機版都有用到，但是手機版在建立camera以後會置換此變數。


  channel00!.setMethodCallHandler((MethodCall call) {
    Completer<dynamic> complete = Completer<dynamic>();
    switch (call.method) {
      case "onImageCaptured": //桌機電腦版本
        {
          dynamic params = call.arguments;
          Uint8List? imageBytes = null;
          if (call.arguments.containsKey("png")) {
            imageBytes = call.arguments["png"];
          }
          String lpr_no = call.arguments["lpr_no"];
          double match_score = call.arguments["match_score"];
          int match_count = call.arguments["match_count"];
          String remark = call.arguments["remark"];
          String lpr_path = call.arguments["lpr_path"];
          String photo_path = call.arguments["photo_path"];
          bool canUpdate = true;


        }
        complete.complete(null);
        break;

      default:
        throw MissingPluginException();
        complete.complete(null);
    }
    return complete.future;
  });
}

String defaultDocPath = '';
String workingPath = '';
Future<void> SetupLocalDirs1() {
  Completer<void> complete = new Completer<void>();

  MyApp.getMyDocumentsDirectory().then((defaultDocDir) {
    String docPath;

    //List<String> items = path.split("/");
    if (runInBuildProductDebug && Platform.isMacOS) {
      defaultDocPath = defaultDocDir.parent.path;
      docPath = defaultDocDir.parent.path + "/Desktop/mlpr-ocr"; //debug模式 放到桌面以方便檢視。 /Users/ansun/Desktop/ocr-data/

      //if (Platform.isMacOS) {
      // items[items.length - 1] = "Desktop"; //replace documents dir
      //}
    } else {
      defaultDocPath =  defaultDocDir.path;
      docPath = defaultDocDir.path + "/mlpr-ocr"; //  /Users/ansun/documents/
    }
    workingPath = docPath + "/ocr-data"; //因為使用multi-windows, workingPath 會有兩套路徑不同。
    debugPrint('workingPath = ' + workingPath);


    history_lpr_path_dekstop = workingPath + '/history_lpr';
    MakeDir(history_lpr_path_dekstop);
    //LoadUsers(workingPath); // load user_db // 準備好社區路徑
    webPath = docPath + "/ocr-web";

    desktopPhotosUploads_path = workingPath + "/uploadPhotos";
    Directory(desktopPhotosUploads_path).create(recursive: true);
    lpr_char_path = workingPath + "/charbits";
    Directory dir1 = Directory(lpr_char_path);
    if (!dir1.existsSync()) {
      dir1.createSync(recursive: true);
    } else {
      if (kDebugMode) {
        //除錯模式,可能需要手機字母樣本，需保留 charbits。
      } else {
        dir1.deleteSync(recursive: true); //刪除，避免膨脹，這是舊版忘記關掉收集樣本功能，新版刪除內容。
        dir1.createSync(recursive: true);
      }
    }

    UnZipCharPatterns().then((success) {
      unzip_busy = false;
      if (channel00 != null) {
        //android 解壓縮時應該還沒有建立通道。 但在桌機 macOS desktop 版本則已經建立。
        DoCheckForPermission().then((value) {
          //dekstop 在多視窗模式之下，DoCheckForPermission此api用到 methodChannel,因為 屬於不同的task，
          // 無法正確傳到 cocoa window. 只能用於主視窗，不能用於次視窗。
          hasPermission = value;
        });
      } else {
        hasPermission = true;
      }


      complete.complete();
      if (appState != null) {
        appState!.setState(() {});
      }
    }); //不管是MacOSDesktop 或 ios/android,都需要產生一個字母樣本檔案，但 desktop debug version 不使用。
  });
  return complete.future;
}

Future<InternetAddress?> retrieveIPAddress() async {
  //InternetAddress result;

  int code = Random().nextInt(255);
  var dgSocket = await RawDatagramSocket.bind(InternetAddress.anyIPv4, 0);
  dgSocket.readEventsEnabled = true;
  dgSocket.broadcastEnabled = true;
  Completer<InternetAddress?>? complete = Completer<InternetAddress?>();
  //Future<InternetAddress> ret =

  dgSocket.timeout(Duration(milliseconds: 100), onTimeout: (sink) {
    sink.close();
    if (complete != null) {
      debugPrint('time out error');
      complete!.completeError("time out error");
      //result = null;
    }
  }).expand<InternetAddress>((event) {
    if (event == RawSocketEvent.read) {
      Datagram? dg = dgSocket.receive();
      if (dg != null && dg.data.length == 1 && dg.data[0] == code) {
        dgSocket.close();
        //return [dg.address];
        if (complete != null) {
          debugPrint('complete.complete(dg.address)');
          complete!.complete(dg.address);
          complete = null;
          //result = null;
        }
      }
    }

    //if (complete != null) {
    //  debugPrint('complete.complete(null) 1');
    //  complete!.complete(null);
    // }
    return [];
  }).firstWhere((InternetAddress addr) {
    if (complete != null) {
      debugPrint('complete.complete(addr)');
      complete!.complete(addr);
    } else {
      debugPrint('complete.complete(null) 2');
      complete!.complete(null);
    }
    return true;
  }).onError((error, stackTrace) {
    if (complete != null) {
      debugPrint("firstWhere error, no IP address found");

      complete!.complete(null);
    }

    InternetAddress addr = InternetAddress("255.255.255.255");
    return addr;
  });

  dgSocket.send([code], InternetAddress("255.255.255.255"), dgSocket.port);
  return complete!.future;
}

void httpWebServer_DoGetPage2(HttpRequest request) {
  Uri url = request.requestedUri;
  int portNumber = url.port;
  String path = url.path;
  HttpHeaders headers = request.headers;
  List<String>? referers = headers["referer"];
  debugPrint("get path " + path);
  ShowWebMessage("get path " + path);
  String referer = "referer: ";
  String referFrom = "";
  if (referers != null) {
    referer += referers[0];
    referFrom = referers[0];
    //debugPrint("referer:");
    //debugPrint(referer);
  }
  String ipaddress = request.connectionInfo!.remoteAddress.address;
  ShowWebMessage(ipaddress + "\n" + path + "\n" + referer + "\n");
  if (path == "/") {
    request.response.headers.contentType = ContentType('text', 'html', charset: "utf-8");
    request.response.headers.set("X-Frame-Options", "ALLOW-FROM SAMEDOMAIN www.smartinside.com.tw  smartinside.com.tw mlpr.smartinside.com.tw"); // ALLOW-FROM http://www.smartinside.com.tw/
    request.response.headers.set("Content-Security-Policy", "frame-ancestors www.smartinside.com.tw  smartinside.com.tw mlpr.smartinside.com.tw");
    request.response.statusCode = HttpStatus.ok;
    String useHome_html = "";
    if ((referFrom == "http://www.smartinside.com.tw/") || (referFrom == "http://smartinside.com.tw/")) {
      useHome_html = webPath + "/ocr_iframe.html";
    } else  {
      useHome_html = webPath + "/ocr_home.html";
    }
    request.response.write(File(useHome_html).readAsStringSync(encoding: utf8)); //write body 以後就不能再修改 response.headers
  } else if (path == "/mlpr/") {
    request.response.headers.contentType = ContentType('text', 'html', charset: "utf-8");
    AppendCORS(request);
    request.response.headers.set("X-Frame-Options", "ALLOW-FROM SAMEDOMAIN www.smartinside.com.tw  smartinside.com.tw mlpr.smartinside.com.tw");
    request.response.headers.set("Content-Security-Policy", "frame-ancestors www.smartinside.com.tw smartinside.com.tw mlpr.smartinside.com.tw");
    request.response.statusCode = HttpStatus.ok;
    request.response.write(File(webPath + "/index.html").readAsStringSync(encoding: utf8)); //write body 以後就不能再修改 response.headers
  } else {
    if (path == '/favicon.ico') {
      path = '/favicon.png';
    }
    File fref = File(webPath + path);
    if (fref.existsSync()) {
      bool binary = false;
      if (path.endsWith(".json")) {
        request.response.headers.contentType = ContentType('text', 'plain', charset: "utf-8");
      } else if (path.endsWith(".js")) {
        request.response.headers.contentType = ContentType('text', 'javascript');
      } else if (path.endsWith(".ico")) {
        binary = true;
        path = "/favicon.png";
        request.response.headers.contentType = ContentType('image', 'png');
      } else if (path.endsWith(".png") || path.endsWith(".PNG")) {
        binary = true;
        request.response.headers.contentType = ContentType('image', 'png');
      } else if (path.endsWith(".jpg") || path.endsWith(".JPG")) {
        binary = true;
        request.response.headers.contentType = ContentType('image', 'jpeg');
      } else if (path.endsWith(".otf")) {
        binary = true;
        request.response.headers.contentType = ContentType('application', 'x-font-opentype');
      } else if (path.endsWith(".ttf")) {
        binary = true;
        request.response.headers.contentType = ContentType('application', 'x-font-ttf');
      } else if (path.endsWith(".txt")) {
        request.response.headers.contentType = ContentType('text', 'plain', charset: "utf-8");
      } else if (path.endsWith(".html")) {
        request.response.headers.contentType = ContentType('text', 'html', charset: "utf-8");
      } else {
        binary = true;
        request.response.headers.contentType = ContentType('application', 'octet-stream');
      }

      request.response.statusCode = HttpStatus.ok;

      if (binary == true) {
        request.response.add(fref.readAsBytesSync()); //write body 以後就不能再修改 response.headers
      } else {
        request.response.write(fref.readAsStringSync(encoding: utf8)); //write body 以後就不能再修改 response.headers
      }
    } else {
      request.response.statusCode = HttpStatus.notFound;
    }
  }
}

void httpWebServer_DoPut(HttpRequest request) {
  Uri url = request.requestedUri;
  String path = url.path;
  debugPrint("put path " + path);

  request.listen((Uint8List buff) {
    String value = String.fromCharCodes(buff);
    debugPrint("request.listen " + value);
  });
  request.response.statusCode = HttpStatus.ok;
  request.response.close();
}


void SendResponse2(HttpRequest request, String resultValue) {
  request.response.headers.add('Content-Type', 'text/plain');
  request.response.headers.contentType = ContentType("text", "plain", charset: 'utf-8');
  AppendCORS(request);
  request.response.statusCode = HttpStatus.ok;
  //resultValue = "       ";
  //("resultValue $resultValue");
  request.response.headers.contentLength = utf8.encode(resultValue).length; //加入這個欄位，才不會在response.body文字前多出一行長度。
  request.response.write(resultValue); //write body 以後就不能再修改 response.headers
  request.response.close();
  ShowWebMessage('SendResponse desktop_mlprdoc_DecodeUpload0');
}

void AppendCORS(HttpRequest request) // 2023/08/23
{
  request.response.headers.add("Access-Control-Allow-Origin", "*"); //CORS
  request.response.headers.add("Access-Control-Allow-Headers", "*");
  request.response.headers.add("Access-Control-Expose-Headers", "*"); // for server header to be visible by client web app
  request.response.headers.add("Access-Control-Allow-Credentials", "true"); // for set cookie
  request.response.headers.add("Access-Control-Allow-Methods", "POST,GET,DELETE,PUT,OPTIONS");
}

void SendResponseUInt8List(HttpRequest request, Uint8List resultValue,String file_name,String errorStatus) {
  //request.response.headers.add('Content-Type', 'text/plain');
  request.response.headers.contentType = ContentType('application', 'octet-stream');;//ContentType("application", "x-oct", charset: 'utf-8');
  AppendCORS(request);

  //file_name = 'test';
  String fname = Uri.encodeQueryComponent(file_name);
 // debugPrint('download_save fname encoded = $fname');
  request.response.headers.add("file-name", fname);
  request.response.headers.add("status", errorStatus);

  request.response.statusCode = HttpStatus.ok;
  request.response.add(resultValue); //write body 以後就不能再修改 response.headers
  request.response.close();
}




Future<File> writeToFile1(ByteData data) async {
  final buffer = data.buffer;
  Directory tempDir = await getTemporaryDirectory();
  String tempPath = tempDir.path;
  var filePath = tempPath + '/file_01.tmp'; // file_01.tmp is dump file, can be anything
  return new File(filePath).writeAsBytes(buffer.asUint8List(data.offsetInBytes, data.lengthInBytes));
}


Future<bool> UnZipCharPatterns() {
  Completer<bool> complete = new Completer<bool>();
  String binDir = workingPath + "/pattern_bin";
  String patternName = "packed-patttern.bin";
  String patBin = binDir + "/" + patternName;
  patternBinPath = patBin;
  File binFile = File(patBin);
  binFile.exists().then((exist) {
    if (exist) {
      //已經存在
      complete.complete(true);
    } else {
      //檔案不存在，需要解壓縮來產生一個字母樣本.
      rootBundle.load("Assets/" + patternName + ".zip").then((datas) {
        //讀取 zip resource，因為 flutter assets 不是一個檔案，只是個物件。
        writeToFile1(datas).then((zipTempFile) {
          //把 zip 物件 寫到一個暫存檔案，才能解壓縮。

          final destinationDir = Directory(binDir);
          if (destinationDir.existsSync() == false) {
          } else {
            destinationDir.createSync(recursive: true);
          }
          // 2024/02/18 改用這個；停用 ZipFile.extractToDirectory
          String dstPath = destinationDir.path;
          MakeDir(dstPath);
          // Extract the contents of the Zip archive to disk.
          final bytes =  zipTempFile.readAsBytesSync();
          // Decode the Zip file
          final archive = ZipDecoder().decodeBytes(bytes);
          for (final file in archive) {
            final filename = file.name;
            if (file.isFile) {
              final data = file.content as List<int>;
              File('$dstPath/$filename')
                ..createSync(recursive: true)
                ..writeAsBytesSync(data);
            } else {
              Directory('$dstPath/$filename').create(recursive: true);
            }
          }
          zipTempFile.deleteSync(recursive: true);
          complete.complete(true);
/*
          ZipFile.extractToDirectory(
            //將暫存檔案解壓縮。
              zipFile: zipTempFile,
              destinationDir: destinationDir)
              .then((value) {
            //解壓縮成功 字母樣本
            zipTempFile.deleteSync(recursive: true);
            complete.complete(true);
          }).onError((error, stackTrace) {
            debugPrint("zipTempFile.deleteSync error");
            debugPrint(error.toString());
            complete.complete(false);
          });

 */
        });
      });
    }
  });

  return complete.future;
}
bool unzip_busy = false;
String history_lpr_path_dekstop = '';

void MakeDir(String path) {
  Directory dir = Directory(path);
  if (dir.existsSync() == false) {
    try {
      dir.createSync(recursive: true);
    } catch (e) {
      //(e.toString());
    }
  }
}
